#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>
#include <time.h>
#define PI 3.141592654

//to calculate Clebsch-Gordan coefficient
#define S3J_0		1e-10

#define S3J_MAX_FACT	25
#define S3J_TEST

#define S3J_EQUAL(a,b)		(fabs((a)-(b))<S3J_0)
#define S3J_MAX(a,b,c,ris)	(((a)>(b)?(ris=(a)):(ris=(b)))>(c)?ris:(ris=(c)))
#define S3J_MIN(a,b,c,ris)	(((a)<(b)?(ris=(a)):(ris=(b)))<(c)?ris:(ris=(c)))
double CleGor(),s3j();

int findp(),findpd(), findintr();
float polint4();
float insidex();
float insideq();
double poly(),simpf();
double pi;
void integral1(),CV(),replace_flavor();
int ffin1(),ch_index();
double integra();
double gaussrand(),dist2(),countpdf(),countRh(),initial_black_hole();
double CM();
double ch_spectrum_no();
int count_line();
double ch_spectrum_tension(),ch_spectrum_rotation();
int count_line_tension(),count_line_rotation();
void chose_lm();
void put_value();
void arrmome(),N_type_minimum_mass();
int  separation_energy(); 
void assign_charge();
double spectrum_norotating(),spectrum_norotating_tension(),calculate_spectrum_rotating();
void read_pareameter_rotating(),set_parameter_lisa();
int calculate_number_case_rotating(),set_initial_Rsb_spectrum(),assign_particle_type();
void P_E_L(),initial_color();
void One_step_hawking(),setup_emitted_momentum();
void set_parameter_yoshino();
int charge_suppressed(), exchange_rout();
int minimum_solution();
double pick_one_solution(),part23();
//define for rkqs and rkck
#define N1 2
#define N2 1
#define NTOT (N1+N2)
#define DXX 1.0e-4
#define SAFETY 0.9
#define PGROW -0.2
#define PSHRNK -0.25
#define ERRCON 1.89e-4

//define for odeint
#define MAXSTP 10000
#define TINY 1.0e-30
int kmax=10000, kount;
double *xp,**yp,dxsav;
void odeint();
void derivs();

void angle_ca();

double hmax=1.e-3;

// Global scope information to enter into Pythia common block
int    xIpdg1,xIpdg2,xIgrp1,xIgrp2,xIset1,xIset2;
double xEnergy1, xEnergy2;
int    xIweight,xNproc,xProcList;
double xXsec, xXsecErr, xXsecMax;

void getbeaminfo_(int *, int *, double *, double *, int *,int *,int *,int *);
void getxsecinfo_(int *, int *, double *, double *, double *, int *);
void ClearEventInfo(); // Reset event record for each new event
void AddParticle(int* NewEvent, int Flag, int dim, int Id, int *ChargeCol, double *Momentum, double Qscale);
int  NFreeColours(int, int, int);

// This is the HEPEUP common block from Pythia (routine UPEVNT)
#define Nmax 500
extern struct{ 
  int Np;
  int ProcessID;
  double Wgt;
  double Scale; 
  double Aqed;
  double Aqcd;
  int    Ipdg[Nmax];
  int   Istat[Nmax];
  int   Imoth[Nmax][2];
  int    Icol[Nmax][2];
  double Pmom[Nmax][5];
  double  Tau[Nmax];
  double Spin[Nmax];
} hepeup_;
 
extern void initpy_();
extern void upinit_();
extern void upevnt_();
extern void pyevnt_();
extern void pylist_();
extern void pystat_();
extern void initlha_(int*);
extern double getparton_(double*, double*, int*);
void Banner();
void ColourFlow();
void DumpLHAevent(FILE* );   //alternative LHA interface - writes LHA event common block to a text file

//===================================


//mass of standard model particles 
double mass_ga[5]={0.,0.,80.425,80.425,91.1876},/*gluon photon W+ W- Z*/
       mass_s[4]={114.4,80.425,80.425,91.1876},/*Higgs W+ w- Z*/
       mass_q[6]={3.2e-3,3.2e-3,70e-3,1.2,4.2,178.1},/*u,d,s,c,b,t*/
       mass_lc[3]={5.1e-4,1.05e-1,1.776},/*e,mu,tau*/
       mass_ln[3]={0.0,0.0,0.0},/*nu_e,nu_mu,nu_tau*/
       mass_g[1]={0.0};


void blackmaxinit_(), blackmaxevent_();
//######################################
//parameter for blackmainit_() and blackmaxevent_()
int fix_time,dim,dims;

double *yoshino_factor, yoshino_r_max;
int yoshino_i=7,do_yo;

int *for_switch,num_c, num_switch, **group_poss, number_ex,**exchange,N_lm[3];
int suppress,Charge_suppress;
double **pro_group_poss,  **group_poss_mass, suppressL, suppressQ, suppressC;

int N_spectrum=1000,N_a_rotation;
double time_step,Q;
double **spectrum[4],***spectrum_r[3];
double ***A_ro[3],***B_ro[3],***C_ro[3],***D_ro[3],***location[3],***eigen_ro[3],**eigen_location[3];
double Epow_s[4],*Epow_r[3],*aa_r,Mmax,Mmin,Mlra,Plra,Llra,Mpl,L5,Lg_size; 
long Ndice;
double **pos,*width,Bt,rho,Mpl_factor;
int ch_case,initial_particle,de_Mpl,on_gravity;
int in_pdf;
int WriteLHArecord;
clock_t time1,time2;
FILE *pFile7;
//################################################


int main()
{blackmaxinit_();
 
 blackmaxevent_();
 return 0;
}//end of main

//initial set up 
void blackmaxinit_()
{
//  FILE *pFile7;
  // long lSize;
  int Nfmx,i,j,k,total1,inx,inq;
  int power=7;
  char *buffer,*buffer1,pdf_name[100];
  float Nfl,QINI,QMAX,*TV,XMIN,aa,aa1;
  double Fem;
  char filename[100],filename7[100],filenamea[100];


  int number_constraint, **constraint;
 
  int fitpower=8,fiteigen=8;
  double end_spectrum=15,Lmax=9.1;
  
  double n_t,p_t,E_f_factor;
  int fl,E_index,A_index;
  int Mass_min,Mass_max;
  double ibig;
  int N_ne_an;//chose odd
  double MM1,MM2;
  double ch_N;
  int flag1,flag2;

  //parameter for calculating error of cross section
            
  long int rseed;

  //Timing information

  time1 = clock(); 

  buffer =malloc(500*sizeof(char));
  buffer1 =malloc(500*sizeof(char));
  group_poss=malloc(16*5*sizeof(int));

  pro_group_poss=malloc(16*5*sizeof(double));group_poss_mass=malloc(16*5*sizeof(double));
  for(i=0;i<16;i++){group_poss[i]=malloc(5*sizeof(int));pro_group_poss[i]=malloc(5*sizeof(double));group_poss_mass[i]=malloc(5*sizeof(double));}
  exchange=malloc(14*156*sizeof(int));
  for(i=0;i<156;i++)exchange[i]=malloc(14*sizeof(int));

  // Write banner to output file
  Banner();
  printf("\n");
  printf("***** Initialising ..... \n");
  printf("\n");


  constraint=malloc(14*20*sizeof(int));
  constraint=malloc(12*20*sizeof(int));
  for(i=0;i<20;i++)constraint[i]=malloc(12*sizeof(int));

  constraint=malloc(14*20*sizeof(int));
  for_switch=malloc(14*sizeof(int));
  for(i=0;i<20;i++)constraint[i]=malloc(14*sizeof(int));
  for(j=0;j<4;j++)for(i=0;i<14;i++)constraint[j][i]=0;

  for(i=0;i<4;i++)
   {spectrum[i]=malloc(2*N_spectrum*sizeof(double));
    for(j=0;j<2;j++)spectrum[i][j]=malloc(N_spectrum*sizeof(double));
   }


  //  srand48(time(0));
  pi=asin(1.)*2;

  sprintf(filename7,"output.txt");



  // read set up//

  N_lm[0]=((int)Lmax+1)*((int)Lmax+1);
  N_lm[1]=(1+(int)(Lmax+0.5))*(int)(Lmax+0.5);
  N_lm[2]=((int)Lmax+1)*((int)Lmax+1)-1;


  dims=9;//assume there are 9 extra dimensins
  width=malloc(42*sizeof(double));
  pos=malloc((42*dims)*sizeof(double));
  for(i=0;i<42;i++)pos[i]=malloc(dims*sizeof(double));


  //read parameters from parameter.txt
  printf("\n");
  printf("***** Reading Parameters ..... \n");
  printf("\n");
  read_parameters(filename7, &Ndice,&Q,&Mpl,&Lg_size,&ch_case,&dim,&dims,&L5,&Bt,&in_pdf,&Mmax,&Mmin,&time_step,&Mlra,&Plra, &Llra,&rseed,&suppress,&suppressL,&Charge_suppress,&suppressQ,&suppressC,width,pos,&fix_time,&do_yo, &de_Mpl, &Mpl_factor,&initial_particle,&number_constraint,constraint,&on_gravity,&WriteLHArecord);

  if (ch_case==2&&do_yo==1)
   {printf("Yoshino's factors are not suitable for tension brane model\n");
    exit(1);
   }

  if(exchange_rout(constraint,number_constraint,for_switch,&num_c,&num_switch,group_poss,pro_group_poss,group_poss_mass,dims,dim,exchange,&number_ex,on_gravity)==0)
   {printf("The code can deal with only flavor, baryon number, lepton numbe, and B-L constraints.\n");
    exit(1);
   }

//printf("%d %d jj\n",number_ex,num_switch);
//for(i=0;i<number_ex;i++)
// {
//  for(j=0;j<num_switch;j++)printf("%d ",exchange[i][j]);
//  printf("k \n");
// }

  pFile7=fopen(filename7,"r+");
  fseeko(pFile7, 0, SEEK_END);

  printf("*****  Nevents                  = %i\n",Ndice);
  printf("*****  Beam Particles           = ");
  if (initial_particle == 1 ) printf("PP\n");
  if (initial_particle == 2 ) printf("PPbar\n");
  if (initial_particle == 3 ) printf("e+/e-\n");
  printf("*****  Centre of Mass Energy    = %f GeV\n",Q);
  printf("*****  M_ph                     = %f GeV\n",Mpl);
  printf("*****  Model Type               = ");
  if (ch_case == 1 ) printf("No Tension, Non-rotating BlackHole\n");
  if (ch_case == 2 ) printf("Tension, Non-Rotating BlackHole\n");
  if (ch_case == 3 ) printf("Rotating BlackHole, non-split dimensions\n");
  if (ch_case == 4 ) printf("Two particle final state\n");
  printf("*****  Number Extra Dimensions  = %i \n",dim);
  printf("*****  Number Split Dimensions  = %i \n",dims);
  printf("*****  Size   Extra Dimensions  = %f \n",L5);
  printf("*****  Tension Parameter        = %f \n",Bt);
  printf("*****  Input PDFs               = %i \n",in_pdf);
  printf("*****  Minimum BH Mass          = %f \n",Mmin);
  printf("*****  Maximum BH Mass          = %f \n",Mmax);
  printf("*****  Time Step Fixed?         = ");
  if (fix_time == 1 ) printf("Yes\n");
  if (fix_time == 2 ) printf("No \n");
  printf("*****  Time Step                = %e (1/GeV)\n",time_step);
  printf("*****  Do YoShino suppression?  = ");
  if (do_yo == 1 ) printf("Yes\n");
  if (do_yo == 0 ) printf("No \n");
  printf("*****  Mass Loss Factor         = %f \n",Mlra);
  printf("*****  Momentum Loss Factor     = %f \n",Plra);
  printf("*****  Ang.Momentum Loss Factor = %f \n",Llra);
  printf("*****  Gravitons in FinalBurst? = ");
  if (on_gravity == 1 ) printf("Yes\n");
  if (on_gravity == 0 ) printf("No \n");
  printf("\n");
  printf("\n");
  
  //set up random seed
  srand48(rseed);

  // check if program can calculate this case
  if(ch_case==2)
    {if(dim!=2){ printf("this program only has spectra for 2 extra diemsions.\n");exit(1);}
      else if (dims !=0&&dims!=2) 
	{printf("this program only has spectra for 0 or 2 extra diemsions for splitting fermions.\n");
	  exit(1);
	}
    }//end of if (ch_case ==2)

  if(ch_case==3&&dims!=0)
    {printf(" This program only have spectra of rotating black hole in brane model\n");
     exit(1);
    }
  //end of checking


  //set up  spectrum and read spectra for nonrotation case
  if(ch_case ==1)
    {for(i=0;i<4;i++)
      Epow_s[i]=spectrum_norotating(i,end_spectrum,N_spectrum,spectrum[i],dim,dims);
    }//end of case 1

  //set up spectrum for tension case
  if(ch_case==2)
    {for(i=0;i<4;i++)
      Epow_s[i]=spectrum_norotating_tension(i,end_spectrum,N_spectrum,spectrum[i],dim,dims,Bt);
    }//end of case 2

  Epow_s[3]*=on_gravity;

  //set up size for rotation 
  if (ch_case ==3)
    {
     N_a_rotation=calculate_number_case_rotating(dim);
     for(i=0;i<3;i++)
      {
       A_ro[i]=malloc(N_a_rotation*N_lm[i]*2*sizeof(double));
       B_ro[i]=malloc(N_a_rotation*N_lm[i]*fitpower*sizeof(double));
       C_ro[i]=malloc(N_a_rotation*N_lm[i]*fitpower*sizeof(double));
       D_ro[i]=malloc(N_a_rotation*N_lm[i]*2*sizeof(double));
       location[i]=malloc(N_a_rotation*N_lm[i]*3*sizeof(double));
       eigen_ro[i]=malloc(N_lm[i]*5*fiteigen*sizeof(double));
       eigen_location[i]=malloc(N_lm[i]*5*sizeof(double));
       for(j=0;j<N_a_rotation;j++)
        {A_ro[i][j]=malloc(N_lm[i]*2*sizeof(double));
         B_ro[i][j]=malloc(N_lm[i]*fitpower*sizeof(double));
         C_ro[i][j]=malloc(N_lm[i]*fitpower*sizeof(double));
         D_ro[i][j]=malloc(N_lm[i]*2*sizeof(double));
         location[i][j]=malloc(N_lm[i]*3*sizeof(double));
//         eigen_ro[i][j]=malloc(N_lm[i]*fiteigen*sizeof(double));
        }
       for(j=0;j<N_a_rotation;j++)for(k=0;k<N_lm[i];k++)
        {A_ro[i][j][k]=malloc(2*sizeof(double));
         B_ro[i][j][k]=malloc(fitpower*sizeof(double));
         C_ro[i][j][k]=malloc(fitpower*sizeof(double));
         D_ro[i][j][k]=malloc(2*sizeof(double));
         location[i][j][k]=malloc(3*sizeof(double));
//         eigen_ro[i][j][k]=malloc(fiteigen*sizeof(double));
        }
       for(j=0;j<N_lm[i];j++)
        {eigen_ro[i][j]=malloc(5*fiteigen*sizeof(double));
         eigen_location[i][j]=malloc(5*sizeof(double));
        }
       for(j=0;j<N_lm[i];j++)for(k=0;k<5;k++)
        eigen_ro[i][j][k]=malloc(fiteigen*sizeof(double));
         

       spectrum_r[i]=malloc(N_a_rotation*2*N_spectrum*sizeof(double));
       Epow_r[i]=malloc(N_a_rotation*sizeof(double));
       for(j=0;j<N_a_rotation;j++)
        spectrum_r[i][j]=malloc(2*N_spectrum*sizeof(double));
       for(j=0;j<N_a_rotation;j++)for(k=0;k<2;k++)
        spectrum_r[i][j][k]=malloc(N_spectrum*sizeof(double));
       aa_r=malloc(N_a_rotation*sizeof(double));
       read_pareameter_rotating(i,N_a_rotation,end_spectrum,N_spectrum,spectrum_r[i],aa_r,dim, A_ro[i],B_ro[i],C_ro[i],D_ro[i],N_lm[i],location[i],Epow_r[i],fiteigen,eigen_ro[i],eigen_location[i]);


      }
 
    }//end of chose case 

  //set parameter for Lisa two particles decay


  if(ch_case ==4)
    set_parameter_lisa(dim,&rho,N_spectrum,end_spectrum);
  //end of case 4

  //set parameters for yoshino 
  yoshino_factor=malloc(yoshino_i*sizeof(double));
  set_parameter_yoshino(yoshino_factor,&yoshino_r_max,dim,yoshino_i);

  //Initialise LHAPDF for pp or p-pbar scattering (not e+e-)
  if (initial_particle != 3) {
    initlha_(&in_pdf);
    printf("Done initialising LHAPDF with set = %7i\n",in_pdf);
  }

  //---------------finish opening pdf file---//
  // set up some parameter //



}//end of blackmaxinit_()

//###################################33
//####################################33
//###################################

//start the process 
void blackmaxevent_()
{
 int N_a=101,num_total, **final_bur,**N_type,check_ap,Emtype,total,pp1,j1,i,j,k,l,m,qn,sepu=1000,sepv=1000;
 int E_belong,E_belong1,gors,E_simble,Nq=9;
 int *B_q_c,*E_q_c,*F_q_c,*flavor,vc,uvc;
 double Lm2,Lm3,*pick_an, **M,**M1,**M2,**angl_spectrum,*power_possibility,**pick_lm[3],*N_type_mass;
 double Rsb,Rsb1,LL,MM,Elose,Mb,time_bh,Q1;
 double **Pwe,*posuv,*posv,*separt1,*separt2;
 double *posbh,*Pb,*Pe,*Pec,*Vc,*fcolor,Emass,width_max,theta,phi,*Pe1,ap1=0,ap;
 double Pm,Mm,Lm,Lm1,fpik,pp1_r,kn,bn,Rs,*fqt,**fq,*fq_v,*Rst;
 long Ndice_total,NN;
 double N_ave,N2_ave,cross,cross1,cross2,x,y ,u,v;
 int no_charge;

  //prarameter for lisa 
 double  N_lisa,P_lisa,ch_mass_possible[2];


// Unbuffer the output
 setbuf(stdout,NULL);  
 static bool Debug;  
 Debug = false; 
 double *Parton;  //Eram: momentum vector of incoming parton
 int    NewEvent; //Eram: Identifies if particle is first particle of an event


 int nvar=2;
 double *ystart;
 //define odeint 
 double *yscal, *y1,*dydx;
 //for rkqs 
 double *yerr,*ytemp;
 //for rkck
 double *ak2,*ak3,*ak4,*ak5,*ak6,*ytemp1;
 //for rkck
 ak2=malloc(nvar*sizeof(double));
 ak3=malloc(nvar*sizeof(double));
 ak4=malloc(nvar*sizeof(double));
 ak5=malloc(nvar*sizeof(double));
 ak6=malloc(nvar*sizeof(double));
 ytemp1=malloc(nvar*sizeof(double));
  
 //for rkqs
 yerr=malloc(nvar*sizeof(double));
 ytemp=malloc(nvar*sizeof(double));
 //for odeint 
 yscal=malloc(nvar*sizeof(double));
 y1=malloc(nvar*sizeof(double));
 dydx=malloc(nvar*sizeof(double));


 ystart=malloc(nvar*sizeof(double)); 
 // yend=malloc(nvar*sizeof(double));
 xp=malloc(kmax*sizeof(double));
 yp=malloc(nvar*kmax*sizeof(double));
 for(i=0;i<nvar;i++)yp[i]=malloc(kmax*sizeof(double));
 

  angl_spectrum=malloc(2*N_a*sizeof(double));
  for(i=0;i<2;i++)angl_spectrum[i]=malloc(N_a*sizeof(double));
  for(i=0;i<N_a;i++)angl_spectrum[0][i]=-1.+2./(N_a+1.)*(i+1.);

  M=malloc(9*sizeof(double));
  M1=malloc(9*sizeof(double));
  M2=malloc(9*sizeof(double));
  for(i=0;i<3;i++){M[i]=malloc(3*sizeof(double));M1[i]=malloc(3*sizeof(double));M2[i]=malloc(3*sizeof(double));}

  pick_an=malloc(30*sizeof(double));
  N_type=malloc(100*(num_switch+2)*sizeof(int));
  for(i=0;i<100;i++)N_type[i]=malloc((num_switch+2)*sizeof(int));
  N_type_mass=malloc((num_switch+2)*sizeof(double));
  final_bur=malloc(2*40*sizeof(int));
  for(i=0;i<2;i++)final_bur[i]=malloc(40*sizeof(int));

  N_type_minimum_mass(N_type_mass,group_poss,num_switch);


  for(i=0;i<3;i++)pick_lm[i]=malloc(2*N_lm[i]*sizeof(double));
  for(i=0;i<3;i++)for(j=0;j<2;j++)pick_lm[i][j]=malloc(N_lm[i]*sizeof(double));



  width_max=0;
  for(i=0;i<42;i++)if(1./width[i]>width_max)width_max=1./width[1];

  //set some parameter
  Emtype=95+12*(dims+2);
  power_possibility=malloc((Emtype+1)*sizeof(double));

  posuv=malloc((dim+3)*sizeof(double));
  posv=malloc((dim+3)*sizeof(double)); 
  posbh=malloc((dim+3)*sizeof(double)); 
  Pb=malloc((dim+4)*sizeof(double));
  Pe=malloc((dim+4)*sizeof(double));
  Pe1=malloc(3*sizeof(double));  
  Pec=malloc((dim+4)*sizeof(double));
  Vc=malloc((dim+3)*sizeof(double));
  Parton=malloc((dim+4)*sizeof(double)); // Eram
  fcolor=malloc((Nq+1)*sizeof(double));


  E_q_c=malloc(4*sizeof(int));
  B_q_c=malloc(4*sizeof(int));
  F_q_c=malloc(4*sizeof(int));
  flavor=malloc(14*sizeof(int));//d,s,b,u,c,t,e,mu,tau,nu_e,nu_mu,nu_tau,W,g


  separt1=malloc((3+dim)*sizeof(double));//use to set momentum
  separt2=malloc((2+dim)*sizeof(double));

  Pwe=malloc(3*40*sizeof(double));
  for(i=0;i<40;i++)Pwe[i]=malloc(3*sizeof(double));

  fqt=malloc((sepu)*sizeof(double));
  fq=malloc(sepu*(sepv)*sizeof(double));
  for(i=0;i<sepu;i++)fq[i]=malloc((sepv)*sizeof(double));
  fq_v=malloc((sepv)*sizeof(double));
  Rst=malloc((sepu)*sizeof(double));


  if (de_Mpl==1)kn=pow(pow(2.,dim)*pow(pi,(dim-3.)/2.)*exp(lgamma((3.+dim)/2))/(2.+dim),1./(1.+dim));
  if (de_Mpl==2)kn=pow(pow(2.,dim+1)*pow(pi,(dim-3.)/2.)*exp(lgamma((3.+dim)/2))/(2.+dim),1./(1.+dim));
  if (de_Mpl==3)kn=pow(pow(2.,3)*pow(pi,-(dim+1.)/2.)*exp(lgamma((3.+dim)/2))/(2.+dim),1./(1.+dim));
  if (de_Mpl==4)kn=Mpl_factor;
  // kn=1./sqrt(pi)*pow(8*exp(lgamma((3.+dim)/2))/(2.+dim),1./(1.+dim));
  bn=2.*pow(1.+(dim+2.)*(dim+2.)/4.,-1/(dim+1.))*kn;
  if(ch_case==2)bn=2*kn;
  if(ch_case==4)bn=kn;
  if(do_yo==1)bn=kn;
  // set up the extra dimensional changing//
  Rs=2*bn/Mpl*pow(Q/Mpl,1./(1.+dim) ); 
  for(i=0;i<sepu;i++)
    {fqt[i]=0.;
      for(j=0;j<sepv;j++)fq[i][j]=0.;
    }

  //set up pdf


  // start the calculation //
  printf("\n");
  printf("***** Calculating Cross Section ..... \n");
  printf("\n"); 

  if(do_yo==1)Mlra=1-part23(yoshino_factor,0.,yoshino_i);
//  if(ch_case==4)Mlra=0.;
  if(initial_particle!=3) 
   {
    y=Mmin/Q/(1.-Mlra); 
    if(y>1.){printf("error: energy is less than smallest black hole.\n");exit(1);}
    y*=y;
    for(j1=0;j1<sepu;j1++)
     {u=j1*(1.-y)/sepu+y;
      Rst[j1]=bn/Mpl*pow(Q*sqrt(u)*(1.-Mlra)/Mpl,1./(1.+dim) );
      if(ch_case==2)Rst[j1]*=pow(1./Bt,1./(3.) );
       //assume cross section is proportional to tensionless 
      Rst[j1]*=Rst[j1];
      Q1=sqrt(u)*Q;

       // crossection of every kind of particle finish //
      for(k=0;k<sepv;k++)
       {v=k*(1.-u)/sepv+u;
	cross1=0.;
	for(l=0;l<Nq;l++)
	 {x=v;qn=l;
          x=countpdf(x,Q1,qn);
	  if(l>1&&l!=8)x*=2;
	  cross1+=x;
         }//end of l
           
        cross2=0.;
	for(m=0;m<Nq;m++)
	 {x=u/v;qn=m;
          x=countpdf(x,Q1,qn);
	  if(m>1&&m!=8)x*=2;
	  cross2+=x;
	 }// end m//
	cross=cross1*cross2/2/v*(1-u)/sepv*(1.-y)/sepu;
	if(k!=0){fq[j1][k]+=cross+fq[j1][k-1];}
	if(k!=sepv-1)fq[j1][k+1]+=cross;     
       }//end of sepv //

      if(j1>0){fqt[j1]+=fq[j1][sepv-1]/2+fq[j1-1][sepv-1]/2+fqt[j1-1];}      

     }//end of sepu//

 
    cross=fqt[sepu-1];// it will be use at last step

    for(i=0;i<sepu;i++){fqt[i]/=fqt[sepu-1];for(j=0;j<sepv;j++)fq[i][j]/=fq[i][sepv-1];}

   }//end of if(initial_particle!=3)

  else cross=1.;
  //end of set up pdf



  //calculate cross section
  N_ave=0.;N2_ave=0;
  NN=0;
  Ndice_total=0;


  // Ndice1 is the number of iterations used in calculating the cross section
  // choose 10000 to get 1% precision on the error.
  int Ndice1 = 10000;
  while(NN<Ndice1)
    {Ndice_total++;
     if(Ndice_total==1000000&NN==0){
       printf("\n Error: Cross section is too small to calculate reliably\n Please change input paramters.\n");
       exit(1);
     }
     //set up initial position of black hole 
     pp1_r=initial_black_hole(&u,&v,y,sepu,sepv,fqt,fq,fq_v,&Q,Nq,   fcolor, dim, dims, &Rs, pos, posuv, posv, width, M, L5, Lg_size, &P_lisa,rho, &Mpl, &kn, ch_case, &uvc,&vc,do_yo,yoshino_r_max,initial_particle, yoshino_i, yoshino_factor);
     if(initial_particle!=3){pp1=(int)pp1_r;Rsb=Rst[pp1]+(Rst[pp1+1]-Rst[pp1])*(pp1_r-pp1);}
     else {Rsb=kn/Mpl*pow(Q/Mpl,1./(1.+dim) );Rsb*=Rsb;}

     if(do_yo==1)Rsb*=yoshino_r_max*yoshino_r_max;

     if (Rsb>dist2(posuv,posv,dim+3)&&drand48()<P_lisa)
         {
          //setup momentum energy and angular momentum
          P_E_L(&Pm, &Mm, &Lm, &Lm1, &ap, &u,&v,&Q,posuv,posv,&Mlra,&Plra,&Llra,dim,do_yo,yoshino_i,yoshino_factor,yoshino_r_max,Rsb,Mpl);
	  //printf("%d %e \n",NN,P_lisa);
	  if(Mm<Mmin||Mm>Mmax)continue;//check mass

          if (ch_case!=4)
           {if (set_initial_Rsb_spectrum(dim,ch_case,&Mpl,&kn, &Rsb,Bt,&ap1,ap, Mm)==0)
              continue;
           }  
//          if (ch_case==4&& do_yo==1 &&Mm>(1+1e-6)*Mpl) 
//           {P_lisa=rho*pow(4*pi*kn/(2.+dim)*sqrt(u)*(1-Mlra)*Q/Mpl,(dim+2.)/(dim+1.));
//            printf("%e\n",P_lisa);
//            if(drand48()>exp(-P_lisa)*(1+P_lisa+P_lisa*P_lisa/2.))continue;
//           }

	  NN++;
	  N2_ave+=Ndice_total*Ndice_total;
	  N_ave+=Ndice_total;
	  Ndice_total=0;
         }
    }
  N_ave/=Ndice1;
  N2_ave/=Ndice1;
  cross*= pi*Rs*Rs/N_ave;
  N2_ave=sqrt((N2_ave-N_ave*N_ave)/(Ndice1-1.))/N_ave;


  //total cross section
  fprintf(pFile7,"total cross section = %e (GeV^-2) = %e b\n",cross,cross*3.89e-4);
  fprintf(pFile7,"cross section error = %e (GeV^-2) = %e b\n",cross*N2_ave,cross*3.89e-4*N2_ave);

  printf("\n");
  printf("*****\n");
  printf("***** BlackMax cross section = %13.5e   +/- %13.5e barn \n",cross*3.89e-4,cross*3.89e-4*N2_ave);
  printf("*****\n");
  printf("\n");


  //Initialise Pythia and Fill initialisation info
  if (initial_particle == 1){
    xIpdg1 = 2212;
    xIpdg2 = 2212;
  } else if (initial_particle == 2) {
    xIpdg1 = 2212;
    xIpdg2 = -2212;
  } else if (initial_particle == 3) {
    xIpdg1 = 11;
    xIpdg2 = -11;
  }
  // For default PDFs (in standalone mode, i.e. no LHAPDF) we use the bundled CTEQ6.1m PDFs
  if (in_pdf < 241 && in_pdf >=200 ) {
    xIgrp1 = xIgrp2 = 4;
    xIset1 = xIset2 = 41;
  } else {
    xIgrp1 = xIgrp2 = 0;
    xIset1 = xIset2 = in_pdf;
  }
  xEnergy1 = xEnergy2 = Q/2;
  xIweight = 3;      // Events are unweighted
  xNproc = 1;        
  xProcList = 1;
  // LHA cross sections *MUST* be in pb
  xXsec    = cross * 3.89e-4 * 1e12;   
  xXsecErr = cross * N2_ave * 3.89e-4 * 1e12;
  xXsecMax = 0.0;   // no meaning for xIweight == 3
  initpy_();  // Initialise Pythia

  // If required - write out the LHA compatible text files
  FILE* LHAfile;
  if (WriteLHArecord >= 1) {
    printf("***** BlackMax will write output to LHA compatible text files\n");
    LHAfile = fopen("BlackMaxLHArecord.txt","w");



    char *ReadBuffer;

    ReadBuffer =malloc(500*sizeof(char));
    fprintf(LHAfile,"********************************  \n");
    fprintf(LHAfile,"***   Welcome to:       BLACKMAX  \n");
    fprintf(LHAfile,"***   Release tag : $Name: REL_2_00_2 $   \n");
    fprintf(LHAfile,"***   Release ID  :   $Id: BlackMax.c,v 1.65 2009/02/23 08:25:23 rizvi Exp $   \n");
    fprintf(LHAfile,"***   Release date: $Date: 2009/02/23 08:25:23 $   \n");
    fprintf(LHAfile,"***   Writing input parameter set...  \n");
    fprintf(LHAfile,"***   \n");
    FILE *pFile = fopen("parameter.txt","r");
    while ( !feof(pFile) ) {
      fscanf(pFile,"%s",ReadBuffer);
      fprintf(LHAfile,"%s\n",ReadBuffer);
    }
    fclose(pFile);
    fprintf(LHAfile,"***   Finished writing input parameter set  \n");
    fprintf(LHAfile,"********************************  \n");
    fprintf(LHAfile,"%6i  %6i  %15.7e  %15.7e  %6i  %6i  %6i  %6i  %6i  %6i\n",
	    xIpdg1,xIpdg2,xEnergy1,xEnergy2,xIgrp1,xIgrp2,xIset1,xIset2,xIweight,xNproc);
    fprintf(LHAfile,"%15.7e  %15.7e  %15.7e  %6i\n",
	    xXsec,xXsecErr,xXsecMax,xProcList);
    printf("***** Finished writing BlackMax LHA Header information - keep file open for event info...\n");
  }

  // End of initialisation timing
  time2 = clock();
  float TimeInit = (time2-time1) / (float)CLOCKS_PER_SEC;
    
  //start to simulate
  printf("\n");
  printf("***** Starting Event Generation \n");
  printf("\n"); 
  NN=0;

  while(NN<Ndice)
    {

     //set up initial position of black hole 
     pp1_r=initial_black_hole(&u,&v,y,sepu,sepv,fqt,fq,fq_v,&Q,Nq, fcolor, dim, dims, &Rs, pos, posuv, posv, width, M, L5, Lg_size, &P_lisa,rho, &Mpl, &kn, ch_case, &uvc,&vc,do_yo,yoshino_r_max,initial_particle, yoshino_i, yoshino_factor);
     if(initial_particle!=3){pp1=(int)pp1_r;Rsb=Rst[pp1]+(Rst[pp1+1]-Rst[pp1])*(pp1_r-pp1);}
     else {Rsb=kn/Mpl*pow(Q/Mpl,1./(1.+dim) );Rsb*=Rsb;}

     if(do_yo==1)Rsb*=yoshino_r_max*yoshino_r_max;

     if (Rsb>dist2(posuv,posv,dim+3)&&drand48()<P_lisa)
         {
          //setup momentum energy and angular momentum
          P_E_L(&Pm, &Mm, &Lm, &Lm1, &ap, &u,&v,&Q,posuv,posv,&Mlra,&Plra,&Llra,dim,do_yo,yoshino_i,yoshino_factor,yoshino_r_max,Rsb,Mpl);

	  if(Mm<Mmin||Mm>Mmax)continue;//check mass

          if (ch_case!=4)
           {if (set_initial_Rsb_spectrum(dim,ch_case,&Mpl,&kn, &Rsb,Bt,&ap1,ap, Mm)==0)
              continue;
           }  

//          if (ch_case==4&& do_yo==1 &&Mm>(1+1e-6)*Mpl) 
//           {P_lisa=rho*pow(4*pi*kn/(2.+dim)*sqrt(u)*Q/Mpl,(dim+2.)/(dim+1.));
//            if(drand48()>exp(-P_lisa)*(1+P_lisa+P_lisa*P_lisa/2.))continue;
//           }

	  NN++;


	  // Printout of progress
	  int power=log10((float)NN);
	  int Iprint = pow(10,power);
	  if (NN%Iprint == 0) printf("      Event Number %6i\n",NN);

	  //Reset the Event info
	  ClearEventInfo();
	  NewEvent=1;
	  if (Debug) printf("***** Starting new event %5i\n",NN);


          if (ch_case==3)
           {for (i=0;i<3;i++)
             Epow_s[i]=calculate_spectrum_rotating(ap1, N_a_rotation, N_spectrum,aa_r, Epow_r[i],spectrum[i],spectrum_r[i]);


            Epow_s[3]=0;
            theta =acos(Lm1/Lm);
            if(Lm<0.1)theta=0.;
            phi=drand48()*2.*pi;
            put_value(M,theta,phi);

           };
         
//#######################   
          //energy loss by graviton (maybe others)       

	  //------------------------
	  // Arrays to store inital burst particles before writing them to event record
	  int NinitMax = 10; // max number of initial burst particles
	  int Ninit;         // number initial burst particles in this event
	  int     *InitialBurstID;
	  int    **InitialBurstCol;
	  double **InitialBurstMom;
	  InitialBurstID  = malloc(NinitMax * sizeof(int));
	  InitialBurstCol = malloc(NinitMax *    4   *sizeof(int));
	  InitialBurstMom = malloc(NinitMax * (4+dim)*sizeof(double));
	  for(i=0;i<NinitMax;i++) {
	    //InitialBurstID[i] =malloc(      sizeof(int));
	    InitialBurstCol[i]=malloc(  4 * sizeof(int));
	    InitialBurstMom[i]=malloc( (4+dim)*sizeof(double));
	  }
	  Ninit = 0;  // set counter to zero
	  //------------------------

          if(Mlra!=0.)
           {
            for(i=0;i<dim+3;i++)Pb[i+1]=0.;
            Pb[0]=(u/v+v)*Q/2.*Mlra;
            Pb[3]=(u/v-v)*Q/2.*Plra;


            //set up momemtum for energy loss
            total=2;
            for(i=0;i<dim+3;i++)Vc[i]=Pb[i+1]/Pb[0];
            Pb[0]=sqrt(Pb[0]*Pb[0]-Pb[3]*Pb[3]);
            Pb[3]=0.;
            i=0;
            while(i==0)
             {
              if(on_gravity!=0){final_bur[0][0]=final_bur[0][1]=39; i=separation_energy(Pwe, Pb, total, final_bur[0],dim);}
              else{final_bur[0][0]=final_bur[0][1]=22; i=separation_energy(Pwe, Pb, total, final_bur[0],dims);}
             }
            //set up direction and quantum number

            while(total >=1)
              { //assigned color and charge
                assign_charge(&total, E_q_c, B_q_c, final_bur[0]);
                for(i=4;i<dim+4;i++)Pe[i]=0.;
                if(total>=1){if(on_gravity==1)arrmome(Pb,Pe,separt1,separt2,Pwe,4+dim,total+1);else arrmome(Pb,Pe,separt1,separt2,Pwe,4+dims,total+1);}
                else for(i=0;i<4+dim;i++)Pe[i]=Pb[i];
                CV(Vc,Pe,dim+4);

                if(WriteLHArecord==2)
                 {
                  fprintf(pFile7,"Begin  ");
                  fprintf(pFile7,"%7i %13.5e %3i",NN,0.0,final_bur[0][total]);
                  for(i=0;i<4;i++)fprintf(pFile7," %3i",E_q_c[i]);
                  for(i=0;i<4+dim;i++)fprintf(pFile7," %13.5e",Pe[i]);
                  fprintf(pFile7," %13.5e",0.0); // Only gravitons and photons allowed in balding phase emission: mass = 0
                  fprintf(pFile7,"\n");
                 }
		// store properties of initial burst particles so
		// they can be written to event record *after* the parent particles
		InitialBurstID[Ninit] = final_bur[0][total];		
		for(j=0;j<4    ;j++) InitialBurstCol[Ninit][j] = E_q_c[j];	       
		for(j=0;j<4+dim;j++) InitialBurstMom[Ninit][j] = Pe[j];
		Ninit++;
              }//end of while(total>=1
           }


//#################################


	  //color and charge of initial black hole 
          initial_color(B_q_c,E_q_c,flavor,uvc,vc);

	  for(i=0;i<4;i++)F_q_c[i]=B_q_c[i]-E_q_c[i]; //eram
	  //printf("Checking colvec %3i: a) %2i   %2i   %2i\n",NN,E_q_c[1],E_q_c[2],E_q_c[3]);//eram
	  //printf("Checking colvec %3i: b) %2i   %2i   %2i\n",NN,F_q_c[1],F_q_c[2],F_q_c[3]);//eram
	  
	  //set up black hole position
	  for(i=0;i<dim+3;i++){posbh[i]=(posuv[i]+posv[i])/2.;Pb[i+1]=0.;}
	  Pb[0]=sqrt(Pm*Pm+Mm*Mm);
	  Pb[3]=Pm;
	  time_bh=0.;

	  //set up mass and velocity
	  Mb=CM(Pb,dim+4);for(i=0;i<dim+3;i++)Vc[i]=Pb[i+1]/Pb[0];
	  //set initial point
          if(WriteLHArecord==2)
           {
	    fprintf(pFile7,"trace  ");
	    fprintf(pFile7,"%7i %13.5e                    ",NN,0.0);                    
	    for(i=0;i<dim+3;i++)fprintf(pFile7," %13.5e",posbh[i]); 
	    fprintf(pFile7,"\n"); 

	    fprintf(pFile7,"Pbh    ");
	    fprintf(pFile7,"%7i %13.5e  40",NN,0.0);                 
	    for(i=0;i<4;i++)fprintf(pFile7," %3i",B_q_c[i]);
	    for(i=0;i<dim+4;i++)fprintf(pFile7," %13.5e",Pb[i]);  
            fprintf(pFile7," %13.5e",Mm);     
	    if(ch_case==3){
	      fprintf(pFile7," %13.5e",Lm);
	    } else {
	      fprintf(pFile7," %13.5e",0.0); //Print ang.momentum = 0 for non-rotating case
	    }
	    fprintf(pFile7,"\n");                             
           }

	  // Eram print out bh momentum!
	  if (Debug) for(i=0;i<dim+4;i++) printf("BH: %2i   %13.5e\n",i,Pb[i]);  
	  

	  if (Debug) printf("BlackMax: Adding Parents\n");

	  if(WriteLHArecord==2)fprintf(pFile7,"Parent ");

	  for (i=0;i<dim+4;i++)Parton[i]=0.0;
	  if(abs(ch_index(uvc))==1) {
	    Parton[0]=u/v*Q/2.;
	    Parton[3]=sqrt(u*u/v/v*Q*Q/4.-mass_q[1]*mass_q[1]);
            Mm=mass_q[1];
	  } else if (abs(ch_index(uvc))==2){
	    Parton[0]=u/v*Q/2.;
	    Parton[3]=sqrt(u*u/v/v*Q*Q/4.-mass_q[0]*mass_q[0]);
            Mm=mass_q[0];
	  } else if(abs(ch_index(uvc))==21){
	    Parton[0]=u/v*Q/2.;
	    Parton[3]=u/v*Q/2.;
            Mm=0.;
	  } else if (abs(ch_index(uvc))==11){
	    Parton[0]=u/v*Q/2.;
	    Parton[3]=sqrt(u*u/v/v*Q*Q/4.-mass_lc[0]*mass_lc[0]);
            Mm=mass_lc[0];
	  } else {
	    Parton[0]=u/v*Q/2.;
	    Parton[3]=sqrt(u*u/v/v*Q*Q/4.-mass_q[abs(ch_index(uvc))-1]*mass_q[abs(ch_index(uvc))-1]);
            Mm=mass_q[abs(ch_index(uvc))-1];
	  }
         
          if(WriteLHArecord==2)
           {
	    fprintf(pFile7,"%7i               %3i",NN,ch_index(uvc));
	    for(i=0;i<4;i++)fprintf(pFile7," %3i",E_q_c[i]);
	    for(i=0;i<4;i++)fprintf(pFile7," %13.5e",Parton[i]);
            fprintf(pFile7," %13.5e",Mm);
	    fprintf(pFile7,"\n");
           }

          for(i=0;i<4;i++)F_q_c[i]=E_q_c[i];
	  AddParticle(&NewEvent,1,dim,ch_index(uvc),F_q_c,Parton,Q1);

	  if(WriteLHArecord==2)fprintf(pFile7,"Parent ");
	  if(abs(ch_index(vc))==1){
	    Parton[0]=v*Q/2.;
	    Parton[3]=-1.*sqrt(v*v*Q*Q/4.-mass_q[1]*mass_q[1]);
            Mm=mass_q[1];
	  }else if (abs(ch_index(vc))==2){
	    Parton[0]=v*Q/2.;
	    Parton[3]=-1*sqrt(v*v*Q*Q/4.-mass_q[0]*mass_q[0]);
            Mm=mass_q[0];
	  } else if(abs(ch_index(vc))==21){
	    Parton[0]=v*Q/2.;
	    Parton[3]=-1*v*Q/2.;
            Mm=0.;
	  }else if (abs(ch_index(vc))==11){
	    Parton[0]=v*Q/2.;
	    Parton[3]=-1*sqrt(v*v*Q*Q/4.-mass_lc[0]*mass_lc[0]);
            Mm=mass_lc[0];
	  } else {
	    Parton[0]=v*Q/2.;
	    Parton[3]=-1.*sqrt(v*v*Q*Q/4.-mass_q[abs(ch_index(vc))-1]*mass_q[abs(ch_index(vc))-1]);
            Mm=mass_q[abs(ch_index(uvc))-1];
	  }
          if(WriteLHArecord==2)
           {
	    fprintf(pFile7,"%7i               %3i",NN,ch_index(vc));
	    for(i=0;i<4;i++)fprintf(pFile7," %3i",B_q_c[i]-E_q_c[i]);
	    for(i=0;i<4;i++)fprintf(pFile7," %13.5e",Parton[i]);
            fprintf(pFile7," %13.5e",Mm);
	    fprintf(pFile7,"\n");
           }

          for(i=0;i<4;i++)F_q_c[i]=B_q_c[i]-E_q_c[i];
	  AddParticle(&NewEvent,1,dim,ch_index(vc),F_q_c,Parton,Q1);

		  
	  // Write out the Initial burst particles to the event record
	  // after the parents have been written
	  if (Ninit>0) {
	    if (Debug) printf("BlackMax: Adding Initial Burst\n");
	    for(i=0;i<Ninit;i++) {
	      AddParticle(&NewEvent,4,dim,InitialBurstID[i],InitialBurstCol[i],InitialBurstMom[i],Q1);	   
	    }
	  }

	  // Add black hole as a "particle" to event record, but keep it's mass invariant.
	  // Add it after the incoming partons
	  // It has PDG Id = 0; Flag = 0 --> means it is the black hole!
	  if (Debug) printf("BlackMax: Adding Black hole\n");
          for(i=0;i<4;i++)F_q_c[i]=B_q_c[i];
	  //jobby AddParticle(&NewEvent,0,dim,0,F_q_c,Pb,Q1);: don't write the black hole to particle list

	  //start to decay

	  while(Mb>Mpl&&ap1<(dim+2.)/2.&&ch_case!=4)
	    {
             One_step_hawking(dims, dim, B_q_c, Emtype, time_step, posbh , posv, Pb, Vc, pos, width, L5, Lg_size, ch_case, power_possibility, Epow_s[0], Epow_s[1], Epow_s[2], Epow_s[3], Rsb, &time_bh, Mb,fix_time,width_max);

             while(assign_particle_type(dim, dims, Emtype, power_possibility, &E_simble, E_q_c, &Elose, spectrum[0], spectrum[1], spectrum[2], spectrum[3], &gors, Mb, Rsb, N_spectrum,&E_belong,&Emass,flavor)==0);



            //charge suppressed
             if(Charge_suppress==2)
              if (charge_suppressed(E_q_c, B_q_c, suppressQ, suppressC)==0)continue;

            //setup momentum of emitted particle
             if(E_belong==3)E_belong1=2;//to avoid read empty space
             else E_belong1=E_belong;


             setup_emitted_momentum(ch_case, gors, &Mb,Pb,Pe,Pe1,Pec,dim, Elose, Emass, eigen_ro[E_belong1],eigen_location[E_belong1], N_lm[E_belong1], Rsb, pick_lm[E_belong1], aa_r, ap1, N_a_rotation, A_ro[E_belong1],  B_ro[E_belong1], C_ro[E_belong1], D_ro[E_belong1], location[E_belong1], Vc, E_belong, angl_spectrum, N_a, ystart, nvar, yscal, y1, dydx, yerr, ytemp, ak2, ak3, ak4, ak5, ak6, ytemp1,  M, M1, M2, pick_an, &ap, &Lm, &Lm1, &Lm2, &Lm3, &LL, &MM);


             Rsb1=Rsb;
             Mb=CM(Pb,4+dim);
             check_ap=set_initial_Rsb_spectrum(dim,ch_case,&Mpl,&kn, &Rsb,Bt,&ap1,ap, Mb);


             //check suppression
             if(ch_case==3&&suppress!=1&&check_ap==1)
              {if (angular_suppress(suppress, suppressL, Rsb, Rsb1, LL, Lm, Lm3)==0)
                {
                 for(i=0;i<4+dim;i++)Pb[i]+=Pe[i];
                 for(i=0;i<3+dim;i++)Vc[i]=Pb[i+1]/Pb[0];
                 Mb=CM(Pb,4+dim);
                 Rsb=Rsb1;
                 replace_flavor(E_simble,flavor);
                 continue;
                }
              }        
 
             //setup new spectrum of rotating black hole
             if (ch_case==3)
              {ap1=ap/Rsb;
               for (i=0;i<3;i++)
                Epow_s[i]=calculate_spectrum_rotating(ap1, N_a_rotation, N_spectrum,aa_r, Epow_r[i],spectrum[i],spectrum_r[i]);
               Lm=Lm3;Lm1=Lm2;
               for(i=0;i<3;i++)for(j=0;j<3;j++)M[i][j]=M2[i][j];
              }

             for(i=0;i<4;i++)B_q_c[i]-=E_q_c[i];

             if(Mb<Mpl)
              {i=minimum_solution(flavor, B_q_c, N_type, for_switch, num_c, num_switch, group_poss, pro_group_poss, exchange, number_ex,&num_total,&no_charge);
               for (j=0;j<i;j++)
                {ch_mass_possible[1]=0;
                 for (k=0;k<num_switch+2;k++){ch_mass_possible[1]+=abs(N_type[j][k])*N_type_mass[k];}
                 if(j==0)ch_mass_possible[0]=ch_mass_possible[1];
                 if(ch_mass_possible[1]<ch_mass_possible[0])ch_mass_possible[0]=ch_mass_possible[1];

                }  

               if (ch_mass_possible[0]>Mb)
                {for(i=0;i<4+dim;i++)Pb[i]+=Pe[i];
                 for(i=0;i<3+dim;i++)Vc[i]=Pb[i+1]/Pb[0];
                 for(i=0;i<4;i++)B_q_c[i]+=E_q_c[i];
                 Mb=CM(Pb,4+dim);
                 Rsb=Rsb1;
                 replace_flavor(E_simble,flavor);
                 continue;
                }
              }

             if(WriteLHArecord==2)
              {

	       fprintf(pFile7,"trace  ");
	       fprintf(pFile7,"%7i %13.5e                    ",NN,time_bh);
	       for(i=0;i<dim+3;i++)fprintf(pFile7," %13.5e",posbh[i]);
	       fprintf(pFile7,"\n");


	       fprintf(pFile7,"Pbh    ");
	       fprintf(pFile7,"%7i %13.5e  40",NN,time_bh);
	       for(i=0;i<4;i++)fprintf(pFile7," %3i",B_q_c[i]);
	       for(i=0;i<dim+4;i++)fprintf(pFile7," %13.5e",Pb[i]);
               fprintf(pFile7," %13.5e",CM(Pb,4+dim));
	       if(ch_case==3){
		 fprintf(pFile7," %13.5e",Lm);
	       } else {
		 fprintf(pFile7," %13.5e",0.0); //Print ang.momentum = 0 for non-rotating case
	       }
	       fprintf(pFile7,"\n");


	       fprintf(pFile7,"Pem    ");
	       fprintf(pFile7,"%7i %13.5e %3i",NN,time_bh,E_simble);
	       for(i=0;i<4;i++)fprintf(pFile7," %3i",E_q_c[i]);
	       for(i=0;i<dim+4;i++)fprintf(pFile7," %13.5e",Pe[i]);
               fprintf(pFile7," %13.5e",Emass);
	       fprintf(pFile7,"\n"); 
              }

	     if (Debug) printf("adding c\n");
             for(i=0;i<4;i++)F_q_c[i]=E_q_c[i];
	     AddParticle(&NewEvent,2,dim,E_simble,F_q_c,Pe,Q1);

             if(WriteLHArecord==2)
              {
               fprintf(pFile7,"Pemc   ");
	       fprintf(pFile7,"%7i %13.5e %3i",NN,time_bh,E_simble);
	       for(i=0;i<4;i++)fprintf(pFile7," %3i",E_q_c[i]);
	       for(i=0;i<dim+4;i++)fprintf(pFile7," %13.5e",Pec[i]);
               fprintf(pFile7," %13.5e",Emass);
	       fprintf(pFile7,"\n");
              }
             if(check_ap==0)break;

	    }//end of while (Mb>Mpl)

//set last jet down up electron gluon others graviton

          Mb=CM(Pb,dim+4);for(i=0;i<dim+3;i++)Vc[i]=Pb[i+1]/Pb[0];
          Pb[0]=Mb;for(i=0;i<dim+3;i++)Pb[i+1]=0.;


          while(1)
          {

           i=minimum_solution(flavor, B_q_c, N_type, for_switch, num_c, num_switch, group_poss, pro_group_poss, exchange, number_ex,&num_total,&no_charge);
           pick_one_solution(num_total,dims,i,num_switch,pos,posbh,width,N_type,group_poss,pro_group_poss,group_poss_mass,final_bur,N_type_mass,Mb,no_charge,B_q_c);


	  //set up momentum  
	  //in the step ignore momentum at high dimension
	  //set up passible explosive momentum

	  //reset momentum
      	  //end of seting up passible explosive energy
           j=0;
           for(i=4;i<4+dims;i++)if(fabs(Pb[i])!=0.) {j=dims;break;}	
           for(i=4+dims;i<4+dim;i++)if(fabs(Pb[i])!=0.) {j=dim;break;}  
           if(separation_energy( Pwe, Pb, num_total, final_bur[0],j)==1)break;

	  }//end of while 	
	  //set up direction and quantum number
          total=num_total;

	  while(total >=1)
	    { //assigned color and charge
              assign_charge(&total, E_q_c, B_q_c, final_bur[0]);    
              for(i=4;i<dim+4;i++)Pe[i]=0.;
              if(total>=1)arrmome(Pb,Pe,separt1,separt2,Pwe,j+4,total+1);
              else for(i=0;i<4+dim;i++)Pe[i]=Pb[i];
              
              CV(Vc,Pe,dim+4);

              if(WriteLHArecord==2)
               {
 	        fprintf(pFile7,"Elast  ");
	        fprintf(pFile7,"%7i %13.5e %3i",NN,time_bh,final_bur[0][total]); 
	        for(i=0;i<4;i++)fprintf(pFile7," %3i",E_q_c[i]);
	        for(i=0;i<4+dim;i++)fprintf(pFile7," %13.5e",Pe[i]);
                fprintf(pFile7," %13.5e",Pwe[total][2]);
	        fprintf(pFile7,"\n");
               }
	      if (Debug) printf("adding f\n");
              for(i=0;i<4;i++)F_q_c[i]=E_q_c[i];
	      AddParticle(&NewEvent,3,dim,final_bur[0][total],F_q_c,Pe,Q1);

	    }//end of while(total>=1

          if(B_q_c[0]!=0||B_q_c[1]!=B_q_c[2]||B_q_c[1]!=B_q_c[3]){printf("Please report color flow error %d %d %d %d %d\n",NN,B_q_c[0],B_q_c[1],B_q_c[2],B_q_c[3]);exit(1);}
	  // Finalise the colour flow amongst all particles of the event
	  if (Debug) printf("ER: main calling upevnt\n");
	  ColourFlow();                // Arrange colour flow lines for Pythia

	  // write out the event record in LHA format
	  if (WriteLHArecord >= 1) DumpLHAevent(LHAfile);

	  // Now call Pythia
	  pyevnt_();                   // Call Pythia to hadronise the event
	  int val=7; pylist_(&val);    // Give some printout after hadronisation
	}//end of if a black hole is created Rst>dis

    }//end of NN
  
  if (WriteLHArecord >= 1) {
    printf("***** \n");
    printf("***** Closed LHA event file \n");
    printf("***** \n");
    fclose(LHAfile);
  }

  // End of Event loop timing
  clock_t time3;
  time3 = clock();
  float TimeLoop = (time3-time2) / (float)CLOCKS_PER_SEC;
  if (TimeLoop < 0) TimeLoop = 0;
  float TimePerEvent = (float)TimeLoop/(float)NN;

  // Printout of Pythia Statistics
  int val = 2;pystat_(&val);


  fclose(pFile7);

  printf("\n");
  printf("*****\n");
  printf("***** BlackMax clock timing info:\n");
  printf("*****\n");
  printf("***** Initialisation time = %f seconds\n",TimeInit);
  if (TimeLoop > 0) {
    printf("*****     Event Loop time = %f seconds for %i events \n",TimeLoop,NN);
    printf("*****     Time per event  = %f seconds\n",TimePerEvent);
  } else {
    printf("*****     Event Loop time = Error - job too long for accurate timing - sorry! \n");
  }
  printf("*****\n");
  printf("\n");
}//end of blackmaxevent_()


//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$




//calculate Rh
double countRh(int dim1,double ap, double Rsb)
{double Rh,A,B;
  int i;

  A=ap*ap;B=pow(Rsb,dim1+1);
  Rh=Rsb;
  for(i=0;i<10;i++){Rh=Rh-(pow(Rh,dim1+1)+A*pow(Rh,dim1-1)-B)/((dim1+1)*pow(Rh,dim1)+A*(dim1-1)*pow(Rh,dim1-2));}

  return Rh;
}

//calculate pdf 
//the index of pdf 
//uval->0 dval->1 ubar->2 dbar->3 sbar->4 cbar->5 bbar->6 tbar->7 glu->8

double countpdf(double x, double Q1,int qn)
{
  //Returns the PDFs
  // x = Bjorken x
  // Q1 = Momentum scale (in GeV)
  // qn = parton index: uval->0 dval->1 ubar->2 dbar->3 sbar->4 cbar->5 bbar->6 tbar->7 glu->8
  //printf("countpdf: x=%13.4e   Q=%13.4e   qn=%5i \n",x,Q1,qn);
  double pdf = getparton_(&x,&Q1,&qn);
  //printf("countpdf: x=%13.4e   Q=%13.4e   qn=%5i  pdf=%13.4e\n",x,Q1,qn,pdf);
  if (pdf < -1.0) printf("Countpdf: negative pdf returned!!! x=%13.4e  Q=%13.4e  qn=%4i  pdf=%13.4e\n",x,Q1,qn,pdf);
return pdf;
}


/* find the position */ 
int findp(float *Y,int N,float *X)
{
  int JLX,JU,JM;
  JLX=-1;
  JU=N+1;
  while(JU-JLX>1)
    {JM=(JU+JLX)/2;
      if(Y[0]>X[JM])JLX=JM;
      else JU=JM;
    }

  return JLX;
}
/* find the position double*/ 
int findpd(double Y,int N,double *X)
{
  int JLX,JU,JM;
  JLX=-1;
  JU=N+1;
  while(JU-JLX>1)
    {JM=(JU+JLX)/2;
      if(Y>X[JM])JLX=JM;
      else JU=JM;
    }
  if (JLX<0)JLX=0;
  return JLX;
}
/*   polint4 routine */
float polint4 (float *XA,float *YA,float *X)
{float H1,H2,H3,H4,W,DEN,D1,D2,D3,C1,C2,C3,CD1,CD2,CC1,CC2,DD1,DC1,Y; 

  H1=XA[0]-X[0]; H2=XA[1]-X[0]; H3=XA[2]-X[0]; H4=XA[3]-X[0];

  W=YA[1]-YA[0]; DEN=W/(H1-H2); D1=H2*DEN; C1=H1*DEN;
      
  W=YA[2]-YA[1]; DEN=W/(H2-H3); D2=H3*DEN; C2=H2*DEN;

  W=YA[3]-YA[2]; DEN=W/(H3-H4); D3=H4*DEN; C3=H3*DEN;

  W=C2-D1; DEN=W/(H1-H3); CD1=H3*DEN; CC1=H1*DEN;

  W=C3-D2; DEN=W/(H2-H4); CD2=H4*DEN; CC2=H2*DEN;

  W=CC2-CD1; DEN=W/(H1-H4); DD1=H4*DEN; DC1=H1*DEN;

  if((H3+H4)<0.) 
    Y=YA[3]+D3+CD2+DD1;
  else if((H2+H3)<0.) 
    Y=YA[2]+D2+CD1+DC1;
  else if((H1+H2)<0.)
    Y=YA[1]+C2+CD1+DC1;
  else
    Y=YA[0]+C1+CC1+DC1;

  return Y;
}

/* for x index between 1 to N-2 */
float insidex(float *xvpow,float *yup, float *x)
{float ss,svec1,svec2,svec3,svec4;
  float s12,s13,s23,s24,s34,sy2,sy3;
  float const1,const2,const3,const4,const5,const6,s1213,s2434;
  float tmp,sdet,sf2,sf3,g1,g4,Y;

  ss = x[0];

  /* initiation work for "interior bins": store the lattice points in s...*/
  svec1 = xvpow[0];svec2 = xvpow[1];svec3 = xvpow[2];svec4 = xvpow[3];
  s12 = svec1 - svec2; s13 = svec1 - svec3; s23 = svec2 - svec3;
  s24 = svec2 - svec4; s34 = svec3 - svec4;

  sy2 = ss - svec2; sy3 = ss - svec3;

  /* constants needed for interpolating in s at fixed t lattice points...*/
  const1 = s13/s23; const2 = s12/s23; const3 = s34/s23; const4 = s24/s23;
  s1213 = s12 + s13; s2434 = s24 + s34;
  sdet = s12*s34 - s1213*s2434; tmp = sy2*sy3/sdet;
  const5 = (s34*sy2-s2434*sy3)*tmp/s12;
  const6 = (s1213*sy2-s12*sy3)*tmp/s34;

  sf2 = yup[1];
  sf3 = yup[2];

  g1 =  sf2*const1 - sf3*const2;
  g4 = -sf2*const3 + sf3*const4;
  Y= (const5*(yup[0]-g1)+ const6*(yup[3]-g4) + sf2*sy3 - sf3*sy2) / s23;
 
  return Y;
}

/*for q index between 1 to N-2 */
float insideq(float *Tv,float *fvec, float *q)
{float tvec1, tvec2,tvec3,tvec4,t12,t13,t23,t24,t34,tt;
  float ty2,ty3,tmp1,tmp2,tdet,tf2,tf3,g1,g4,h00,ff;
 
  tt=q[0];
  tvec1 = Tv[0]; tvec2 = Tv[1]; tvec3 = Tv[2]; tvec4 = Tv[3];
 
  t12 = tvec1 - tvec2; t13 = tvec1 - tvec3;
  t23 = tvec2 - tvec3; t24 = tvec2 - tvec4;
  t34 = tvec3 - tvec4;

  ty2 = tt - tvec2; ty3 = tt - tvec3;

  tmp1 = t12 + t13; tmp2 = t24 + t34;
  tdet = t12*t34 - tmp1*tmp2;
  tf2 = fvec[1]; tf3 = fvec[2];

  g1 = ( tf2*t13 - tf3*t12) / t23; g4 = (-tf2*t34 + tf3*t24) / t23;
  h00 = ((t34*ty2-tmp2*ty3)*(fvec[0]-g1)/t12+(tmp1*ty2-t12*ty3)*(fvec[3]-g4)/t34);
  ff = (h00*ty2*ty3/tdet + tf2*ty3 - tf3*ty2) / t23;

  return ff;
}
/*calculate polynomial function*/
double poly(int n, double x, double *cof)
{ int i;
  double a,b;

  a=0;
  b=1;
  for(i=0;i<n;i++){a=a+b*cof[i];b=b*x;}
  return a;
}


/* find position of quark and return index */
int ffin1(int i)
{
  if(i==0)return 0;
  else if(i==1)return 4;
  else if(i==2)return 0;
  else if(i==3)return 4;
  else if(i==4)return 8;
  else if(i==5)return 12;
  else if(i==6)return 16;
  else if(i==7)return 20;
  else if(i==8)return -1;//for gluon not top
  else if(i==-2)return 2;
  else if(i==-3)return 6;
  else if(i==-4)return 10;
  else if(i==-5)return 14;
  else if(i==-6)return 18;
  else if(i==-7)return 22;


}
/* calculate the probability changing with distance*/

/*return parton index*/
int ch_index(int i)
{
  if(i==0)return 2;
  else if(i==2)return -2;
  else if(i==4)return 1;
  else if(i==6)return -1;
  else if(i==8)return 3;
  else if(i==10)return -3;
  else if(i==12)return 4;
  else if(i==14)return -4;
  else if(i==16)return 5;
  else if(i==18)return -5;
  else if(i==20)return 6;
  else if(i==22)return -6;
  else if(i==24)return 11;
  else if(i==26)return -11;
  else return 21;
 
}

//calculate simpson factor//
//
double simpf(int Ni, int Nt)
{if (Nt%2==1)
    {if (Ni==0||Ni==Nt-1) return 1./3.;
      else if(Ni%2==1)return 4./3.;
      else return 2./3.;
    }
 
  else 
    {if (Ni==0)return 1./3.;
      else if (Ni==Nt-1) return 0.5;
      else if (Ni==Nt-2) return 5./6.;
      else if (Ni%2==1) return 4./3.;
      else return 2./3.;
    }
}

//simpson way to integrate the number 
void integral1(double *x,double *y,double *iny,int N)
{double sum;
  int i;
  sum=0.;
  iny[0]=0;
  for(i=1;i<N;i++)
    {if(i%2==1)sum+=(y[i]+y[i-1])/2.;
      else sum+=(-y[i]+5.*y[i-1]+y[i-2]*2.)/6.;
      iny[i]=sum*(x[1]-x[0]);
    }
}

//integral not uniform
/* integration*/
double integra(double *x, double *y, int Nt)
{double a,b,c,sum;
  int i,j,Nt2,Ntr;
 
  Nt2=Nt/2;Ntr=Nt%2;
  if(Ntr==0)Nt2-=1;
 
  sum=0.;
  for(j=0;j<Nt2;j++)
    {i=j*2;
      a=(y[i]-y[i+1])/(x[i]-x[i+1])-(y[i]-y[i+2])/(x[i]-x[i+2]);
      a/=(x[i+1]-x[i+2]);
      b=(y[i]-y[i+1])/(x[i]-x[i+1])-a*(x[i]+x[i+1]);
      c=y[i]-a*x[i]*x[i]-b*x[i];
      sum+=a/3.*(x[i+2]-x[i])*(x[i+2]*x[i+2]+x[i+2]*x[i]+x[i]*x[i]);
      sum+=b/2.*(x[i+2]-x[i])*(x[i+2]+x[i]);
      sum+=c*(x[i+2]-x[i]);
    }/*end j*/
  if(Ntr==0)sum+=(y[Nt-1]+y[Nt-2])*(x[Nt-1]-x[Nt-2])/2.;
  return sum;
}

//find intrapolate point

int findintr(double Y,int N,double *X)
{ 
  int JLX,JU,JM;
  JLX=-1;
  JU=N+1;

  while(JU-JLX>1)
    {JM=(JU+JLX)/2;
      if(Y>X[JM])JLX=JM;
      else JU=JM;
    }
  if (JLX<0)JLX=0;
  if(JLX>N-1)JLX=N-1;

  return JLX;
}


double gaussrand() {
  /* PDG method */
  double v1,v2,r;
  do {
    v1 = 2.0 * drand48() - 1.0;
    v2 = 2.0 * drand48() - 1.0;
    r = v1*v1 + v2*v2;
  } while (r == 0.0 || r > 1.0);
  return v1 * sqrt(-2.0 * log(r) / r);
}

//calculate distant
double dist2(double *x1, double *x2, int N)
{double a=0.;
  int i;
  for (i=0;i<N; i++)a+=(x1[i]-x2[i])*(x1[i]-x2[i]);
  return a;
}

/*calculate mass */  
double CM(double *P,int n)
{double KK;
  int i;
  KK=P[0]*P[0];
  for(i=1;i<n;i++)KK-=P[i]*P[i];
  if(KK<0.)KK=0.;
  KK=sqrt(KK);
  return KK;
}
//Lorenz transform//
void CV(double *Vc, double *Pe, int n)
{double Pp,V1,V2,V3,ga,p;
  int i;

  V1=V2=0.;
  for(i=0;i<n-1;i++)
    {V1+=Vc[i]*Vc[i];
      V2+=Vc[i]*Pe[i+1];
      V3+=Pe[i+1]*Pe[i+1];
    }/*end i*/
  ga=1./sqrt(1.-V1);
  V1=sqrt(V1);V3=sqrt(V3);
  Pp=V2/V1;
  if(V1>0.)
    {for(i=0;i<n-1;i++)Pe[i+1]-=Vc[i]*Pp/V1;
      p=Pe[0];
      Pe[0]=(p+V1*Pp)*ga;
      Pp=(p*V1+Pp)*ga;
      for(i=0;i<n-1;i++)Pe[i+1]+=Vc[i]*Pp/V1;
    }

}/* end CV*/


//calculate angular distribution

//angle calculate
void angle_ca(double **angl_spectrum, int N_a,double *ystart, int nvar,double *yscal,double *y,double *dydx,double *yerr,double *ytemp,double *ak2,double *ak3,double *ak4,double *ak5,double *ak6, double *ytemp1,double mm,double ss,double E, double aa, double omega)
{double x1,x2,hmin,eps,dd,ed1,ed,endra,h1;
  int nok,nbad;
  double ap,am;
  int i,k,j;

  //calculate eigen valuse of engular part
  dd=1.0e-7;x1=-1.+dd;x2=1.-dd;
  hmin=1e-8;
  eps=1e-4;
  ap=fabs(mm+ss)/2.;am=fabs(mm-ss)/2.;

  dd=1.e-1;
  for(k=0;k<9;k++)
    {j=0;dd/=-10.;
      while(j>=0)
	{
	  ed1=E+ss*(ss+1)+2*(mm+ss)*aa*omega-(ap+am)*(ap+am+1.);
	  ed1/=2.*(1.+2.*am);
	  ystart[0]=1+ed1*(x1+1);
	  ystart[1]=ed1;
	  ed1=E+ss*(ss+1)+2*(mm-ss)*aa*omega-(ap+am)*(ap+am+1);
	  endra=-ed1/2./(1.+2.*ap);
	  h1=0.01;
	  odeint(ystart,nvar,x1,x2,eps,h1,hmin,&nok,&nbad,/*odeint*/yscal,y,dydx,/*rkqs*/yerr,ytemp,/*rkck*/ak2,ak3,ak4,ak5,ak6,ytemp1,mm,ss,E,aa,omega, ap,am);
	  ed1=ystart[1]-ystart[0]*endra;
	  if(j==0)ed=ed1;
	  else 
	    {if((ed>0&&ed1>ed)||(ed<0&&ed1<ed)||ed==0.){E-=dd;break;}
	      if(ed>0){ed=ed1;if(ed1<=0)break;}
	      if(ed<0){ed=ed1;if(ed1>=0)break;}
	    }
	  E+=dd;

	  j++;
	}//end of while

    }//end of for j

  //set up probability
  dd=1.0e-7;x1=-1.+dd;x2=angl_spectrum[0][0];
  ed1=E+ss*(ss+1)+2*(mm+ss)*aa*omega-(ap+am)*(ap+am+1.);
  ed1/=2.*(1.+2.*am);
  ystart[0]=1+ed1*(x1+1);
  ystart[1]=ed1;
  for(i=0;i<N_a;i++)
    {
      h1=0.01;
      odeint(ystart,nvar,x1,x2,eps,h1,hmin,&nok,&nbad,/*odeint*/yscal,y,dydx,/*rkqs*/yerr,ytemp,/*rkck*/ak2,ak3,ak4,ak5,ak6,ytemp1,mm,ss,E,aa,omega, ap,am);
      angl_spectrum[1][i]=ystart[0];
      if(i!=N_a-1)
	{x1=angl_spectrum[0][i];
	  x2=angl_spectrum[0][i+1];
	}
    }

  //set up probability function
  for(i=0;i<N_a;i++)
    {angl_spectrum[1][i]*=pow(1-angl_spectrum[0][i],ap)*pow(1+angl_spectrum[0][i],am);
      angl_spectrum[1][i]*=angl_spectrum[1][i];
    }

  for(i=0;i<N_a/2;i++)
    {angl_spectrum[1][i]=(angl_spectrum[1][i]+angl_spectrum[1][N_a-i-1])/2.;
      angl_spectrum[1][N_a-i-1]=angl_spectrum[1][i];
    }
  for(i=1;i<N_a;i++)angl_spectrum[1][i]+=angl_spectrum[1][i-1];
  for(i=0;i<N_a;i++)angl_spectrum[1][i]/=angl_spectrum[1][N_a-1];
}//end of angle_ca


//part of fifth runge-kutta
void rkck(double *y, double *dydx, int n, double x,double h, double *yout, double *yerr,double *ak2,double *ak3,double *ak4,double *ak5,double *ak6,double *ytemp,double mm,double ss,double E, double aa, double omega, double ap, double am)
{int i;
  static double a2=0.2,a3=0.3,a4=0.6,a5=1.0,a6=0.875, b21=0.2,
    b31=3.0/40.0,b32=9.0/40.0,b41=0.3,b42=-0.9,b43=1.2,
    b51=-11.0/54.0, b52=2.5, b53=-70.0/27.0, b54=35.0/27.0,
    b61=1631./55296., b62=175./512., b63=575./13824.,
    b64=44275./110592.,b65=253./4096.,c1=37./378.,
    c3=250.0/621.0,c4=125./594.,c6=512./1771.,
    dc5=-277./14336.;
  double dc1=c1-2825./27648.,dc3=c3-18575/48384.,
    dc4=c4-13525./55296.,dc6=c6-0.25;


  for(i=0;i<n;i++)ytemp[i]=y[i]+b21*h*dydx[i];//first step
  derivs(x+a2*h,ytemp,ak2,mm,ss,E,aa,omega, ap,am);    //second step 
  for(i=0;i<n;i++)ytemp[i]=y[i]+h*(b31*dydx[i]+b32*ak2[i]);
  derivs(x+a3*h,ytemp,ak3,mm,ss,E,aa,omega, ap,am);     //third step 
  for(i=0;i<n;i++)ytemp[i]=y[i]+h*(b41*dydx[i]+b42*ak2[i]+b43*ak3[i]);
  derivs(x+a4*h,ytemp,ak4,mm,ss,E,aa,omega, ap,am);     //fourth step 
  for(i=0;i<n;i++)ytemp[i]=y[i]+h*(b51*dydx[i]+b52*ak2[i]+b53*ak3[i]+b54*ak4[i]);
  derivs(x+a5*h,ytemp,ak5,mm,ss,E,aa,omega, ap,am);     //fifth step 
  for(i=0;i<n;i++)ytemp[i]=y[i]+h*(b61*dydx[i]+b62*ak2[i]+b63*ak3[i]+b64*ak4[i]+b65*ak5[i]);
  derivs(x+a6*h,ytemp,ak6,mm,ss,E,aa,omega, ap,am);     //sixth step    
  for(i=0;i<n;i++)//sum and error
    {yout[i]=y[i]+h*(c1*dydx[i]+c3*ak3[i]+c4*ak4[i]+c6*ak6[i]);
      yerr[i]=h*(dc1*dydx[i]+dc3*ak3[i]+dc4*ak4[i]+dc5*ak5[i]+dc6*ak6[i]);
    }

}//end of rkck

//Fifth-order Runge-kutta
void rkqs(double *y, double *dydx, int n, double *x, double htry, double eps, double *yscal, double *hdid, double *hnext,double *yerr,double *ytemp,double *ak2,double *ak3,double *ak4,double *ak5,double *ak6,double *ytemp1,double mm,double ss,double E, double aa, double omega, double ap,double am)
{int i;
  double errmax, h, htemp,xnew;

  h=htry;
  for(;;)
    {rkck(y,dydx,n,*x,h,ytemp,yerr,ak2,ak3,ak4,ak5,ak6,ytemp1,mm,ss,E,aa,omega, ap,am); //take a step
      errmax=0.0;
      for(i=0;i<n;i++){if(errmax<fabs(yerr[i]/yscal[i]) )errmax=fabs(yerr[i]/yscal[i]);}
      errmax/=eps;// scale relative to required tolerance
      if(errmax<=1.0) break;
      htemp=SAFETY*h*pow(errmax,PSHRNK);
      if ((h>=0.0&&htemp>0.1*h)||(h<0.0&&htemp<0.1*h))h=htemp; else h=0.1*h;
      xnew=(*x)+h;
      if(xnew==*x){printf(" step is too small broken \n");exit(1);} 
    }//end of for

  if(errmax>ERRCON) *hnext=SAFETY*h*pow(errmax,PGROW);
  else *hnext=5.0*h;
  *x+=(*hdid=h);
  for(i=0;i<n;i++)y[i]=ytemp[i];

}//end of rkqs


//DO ODEINT
void odeint(double *ystart, int nvar, double x1, double x2,double eps,double h1,double hmin, int *nok, int *nbad,double *yscal,double *y,double *dydx,double *yerr,double *ytemp,double *ak2,double *ak3,double *ak4,double *ak5,double *ak6, double *ytemp1,double mm,double ss,double E, double aa, double omega, double ap, double am)
{int nstp,i;
  double xsav,x,hnext,hdid,h;

  x=x1;
  h=fabs(h1)*(x2-x1)/fabs(x2-x1);
  *nok=(*nbad)=kount=0;
  for(i=0;i<nvar;i++) y[i]=ystart[i];
  if(kmax>0)xsav=x-dxsav*2.0;

  for(nstp=0;nstp<MAXSTP;nstp++)
    {derivs(x,y,dydx,mm,ss,E,aa,omega, ap,am);//derivative may be changed
      for(i=0;i<nvar;i++)yscal[i]=fabs(y[i])+fabs(dydx[i]*h)+TINY; //scaling factor
      if(kmax>0&& kount<kmax-1&& fabs(x-xsav)>fabs(dxsav))
	{xp[++kount]=x;
     
	  for(i=0;i<nvar;i++)yp[i][kount]=y[i];
	  xsav=x;
	}
      if((x+h-x2)*(x+h-x1)>0.0)h=x2-x; //if stepsize can overshoot
      if (h>hmax)h=hmax;
      rkqs(y,dydx,nvar,&x,h,eps,yscal,&hdid,&hnext,yerr,ytemp,ak2,ak3,ak4,ak5,ak6,ytemp1,mm,ss,E,aa,omega, ap,am);
      if(hdid==h)++(*nok); else ++(*nbad);
      if((x-x2)*(x2-x1)>=0.0)
	{for(i=0;i<nvar;i++)ystart[i]=y[i];
	  if(kmax){xp[++kount]=x;for(i=0;i<nvar;i++)yp[i][kount]=y[i];}
	  return;
	}
      if(fabs(hnext)<=hmin){printf("Step size is too small \n");exit(1);}
      h=hnext;
    }//end of nstp

  printf("too many step\n");
  exit(1);
     
}//end of odeint

void derivs(double x,double *y,double *dydx,double mm,double ss,double E, double aa, double omega, double ap, double am)
{dydx[0]=y[1];
  dydx[1]=2.*(ap-am+(ap+am+1)*x)*y[1]-(E+ss*(ss+1)+aa*aa*omega*omega*(x*x-1)+2*omega*aa*(mm-ss*x)-(ap+am)*(ap+am+1))*y[0];
  dydx[1]/=(1-x*x);
}

// put matric value
void put_value(double **M,double a,double b)
{M[0][0]=cos(b)*cos(a);
  M[0][1]=-sin(b);
  M[0][2]=cos(b)*sin(a);
  M[1][0]=sin(b)*cos(a);
  M[1][1]=cos(b);
  M[1][2]=sin(b)*sin(a);
  M[2][0]=-sin(a);
  M[2][1]=0;
  M[2][2]=cos(a);
}

// set to calculate Clebsch-Gordan coefficient


double s3j(double j1, double j2, double j3, double m1, double m2, double m3)
{int k, kmin, kmax;
  int jpm1, jmm1, jpm2, jmm2, jpm3, jmm3;
  int j1pj2mj3, j3mj2pm1, j3mj1mm2;
  double ris, mult, f[S3J_MAX_FACT];

  f[0]=1.0;
  mult=1.0;
  for (k=1; k<S3J_MAX_FACT; ++k){f[k]=f[k-1]*mult;mult+=1.0;}
  jpm1=(int)(j1+m1);
  if (!S3J_EQUAL(jpm1,j1+m1)) return 0.0;
  jpm2=(int)(j2+m2);
  if (!S3J_EQUAL(jpm2,j2+m2)) return 0.0;
  jpm3=(int)(j3+m3);
  if (!S3J_EQUAL(jpm3,j3+m3)) return 0.0;
  jmm1=(int)(j1-m1);
  if (!S3J_EQUAL(jmm1,j1-m1)) return 0.0;
  jmm2=(int)(j2-m2);
  if (!S3J_EQUAL(jmm2,j2-m2)) return 0.0;
  jmm3=(int)(j3-m3);
  if (!S3J_EQUAL(jmm3,j3-m3)) return 0.0;

  /* delta(m1+m2+m3,0) */
  if ((jpm1-jmm1+jpm2-jmm2+jpm3-jmm3)!=0) return 0.0;
  /* j1+j2-j3 = (j1+j2-j3) + (m1+m2+m3) = jpm1+jpm2-jmm3 */
  j1pj2mj3=jpm1+jpm2-jmm3;
  /* j3-j2+m1 = (j3-j2+m1) - (m1+m2+m3) = jmm3-jpm2 */
  j3mj2pm1=jmm3-jpm2;
  /* j3-j1-m2 = (j3-j1-m2) + (m1+m2+m3) = jpm3-jmm1 */
  j3mj1mm2=jpm3-jmm1;

  S3J_MAX(-j3mj2pm1, -j3mj1mm2,   0,         kmin);
  S3J_MIN(j1pj2mj3,  jmm1,       jpm2,       kmax);
  if (kmin>kmax) return 0.0;	

  ris=0.0;
  if (kmin%2==0) mult=1.0;
  else mult=-1.0;
  for (k=kmin; k<=kmax; ++k) 
    {ris+=mult/(f[k]*f[j1pj2mj3-k]*f[jmm1-k]*f[jpm2-k]*f[j3mj2pm1+k]*f[j3mj1mm2+k]);
      mult=-mult;
    }

  /* (-1)^(j1-j2-m3)=(-1)^(j1-j2-m3+m1+m2+m3)=(-1)^(jpm1-jmm2) */
  if ((jpm1-jmm2)%2!=0) ris=-ris;

  ris*=sqrt(f[j1pj2mj3]*f[jpm1-jmm2+jpm3]*f[-jmm1+jpm2+jpm3]*
	    f[jpm1]*f[jpm2]*f[jpm3]*f[jmm1]*f[jmm2]*f[jmm3]/
	    f[jpm1+jpm2+jpm3+1]);

  return ris;
}

//Clebsch Gordan coefficient
double CleGor(double j1, double j2, double m1, double m2, double j, double m)
{int esp;
  double cgris;

  esp=(int)(j1-j2+m);
  if (!S3J_EQUAL(esp,j1-j2+m)) return 0.;
  if (esp%2==0) cgris=1.0;
  else cgris=-1.0;

  cgris*=sqrt(2*j+1)*s3j(j1,j2,j,m1,m2,-m);
  //if (fabs(cgris)<1);
  //else printf("c %e %e %e %e %e %e %e\n",cgris,j1,j2,m1,m2,j,m);
  return cgris;
}

//arrange momentum
void arrmome(double *p,double *p1,double *v, double *separt,double **Pwe,int N,int Nt)
{int i,k,Fn0;
  double Ppara,Ppara1,Pvert,Pother;

  for(k=0;k<N-1;k++)if(p[k+1]!=0.){break;}
  Fn0=k;


  Ppara=0.;
  for(i=1;i<N;i++){Ppara+=p[i]*p[i];p1[i]=0.;}

  Ppara=sqrt(Ppara);
  p1[0]=Pwe[Nt-1][0];
  if (Fn0!=N-1)for(i=1;i<N;i++)v[i-1]=p[i]/Ppara;
  else {for(i=0;i<N-1;i++)v[i]=0;v[N-2]=1.;}

  Pother=0.;
  Ppara1=0.;
  for(i=0;i<Nt-1;i++){Pother+=Pwe[i][1];if(Pwe[i][1]>Ppara1)Ppara1=Pwe[i][1];}
  Ppara1=2.*Ppara1-Pother;
  if(fabs(Pwe[Nt-1][1]-Ppara)<Ppara1)Ppara1=(Ppara*Ppara+Pwe[Nt-1][1]*Pwe[Nt-1][1]-Ppara1*Ppara1)/2./Ppara;
  else Ppara1=Pwe[Nt-1][1];

  if(fabs(Ppara1)>Pwe[Nt-1][1])printf("error  \n");
  if(Ppara!=0.)Ppara=(Ppara*Ppara+Pwe[Nt-1][1]*Pwe[Nt-1][1]-Pother*Pother)/2./Ppara;

  if(Ppara<-Pwe[Nt-1][1])Ppara=-Pwe[Nt-1][1];
  Ppara=Ppara+(Ppara1-Ppara)*drand48();



  Pvert=sqrt(Pwe[Nt-1][1]*Pwe[Nt-1][1]-Ppara*Ppara);
  for(i=1;i<N;i++)p1[i]+=Ppara*v[i-1];

  Ppara=1.1;
  while(Ppara>1.0)
   {Ppara=0.;
    for(i=0;i<N-2;i++){separt[i]=drand48();Ppara+=separt[i]*separt[i];}
    for(i=0;i<N-2;i++)separt[i]=separt[i]/sqrt(Ppara);
   }



  for(k=0;k<N-2;k++)
    {
      if(k<Fn0){for(i=0;i<N-1;i++)v[i]=0.;v[k]=1.;}
      else if(p[k+2]==0.0) {for(i=0;i<N-1;i++)v[i]=0.;v[k+1]=1.;}
      else {v[k+1]=0.;
      for(i=0;i<=k;i++){v[i]=p[i+1];v[k+1]-=p[i+1]*p[i+1];}
       v[k+1]/=p[k+2];
       for(i=k+2;i<N-1;i++)v[i]=0.;
      }

      Ppara=0.;
      for(i=0;i<N-1;i++){Ppara+=v[i]*v[i];}

      Ppara=sqrt(Ppara);
      for(i=0;i<N-1;i++)v[i]/=Ppara;
      if(drand48()<0.5)for(i=1;i<N;i++)p1[i]+=Pvert*v[i-1]*separt[k];
      else for(i=1;i<N;i++)p1[i]-=Pvert*v[i-1]*separt[k];
    }

  for(i=0;i<N;i++)p[i]-=p1[i];

}//end of arrange momentum


//sum all the mass
double sum_mass(int total,int *sym_last)
{int i;
 double MM2;
 MM2=0.;
 
 for(i=0;i<total;i++)
  {
   if(abs(sym_last[i])==1)MM2+=mass_q[1];
   else if(abs(sym_last[i])==2)MM2+=mass_q[0];
   else if(abs(sym_last[i])==3)MM2+=mass_q[2];
   else if(abs(sym_last[i])==4)MM2+=mass_q[3];
   else if(abs(sym_last[i])==5)MM2+=mass_q[4];
   else if(abs(sym_last[i])==6)MM2+=mass_q[5];
   else if(abs(sym_last[i])==11)MM2+=mass_lc[0];
   else if(abs(sym_last[i])==12)MM2+=mass_ln[0];
   else if(abs(sym_last[i])==13)MM2+=mass_lc[1];
   else if(abs(sym_last[i])==14)MM2+=mass_ln[1];
   else if(abs(sym_last[i])==15)MM2+=mass_lc[2];
   else if(abs(sym_last[i])==16)MM2+=mass_ln[2];
   else if(abs(sym_last[i])==21)MM2+=mass_ga[0];
   else if(abs(sym_last[i])==22)MM2+=mass_ga[1];
   else if(sym_last[i]==24)MM2+=mass_ga[2];
   else if(sym_last[i]==-24)MM2+=mass_ga[3];
   else if(sym_last[i]==23)MM2+=mass_ga[4];
   else if(sym_last[i]==25)MM2+=mass_s[0];
   else MM2+=mass_g[0];
   
  }
return MM2;

}//end of sum_mass

//separate energy at final burst 
int separation_energy(double **Pwe, double *Pb, int total, int *sym_last,int dim1)
{int flag1,flag2,i,j,count;
 double ch_N,MM1,MM2,MM3;

 MM3=Pb[0]-sum_mass(total,sym_last); 
 ch_N=0.;
 for(i=1;i<4+dim1;i++)ch_N+=Pb[i]*Pb[i];

 count=0;
 flag1=0;
 while(flag1==0)
 {flag1=1;
  
  ch_N=0.;
  for(i=1;i<4+dim1;i++)ch_N+=Pb[i]*Pb[i];

  for(i=0;i<total-1;i++)
   {Pwe[i][0]=drand48();
    for(j=0;j<i;j++)
     if(Pwe[i][0]<Pwe[j][0]){Pwe[total-1][0]=Pwe[i][0];Pwe[i][0]=Pwe[j][0];Pwe[j][0]=Pwe[total-1][0];}
   }
  
  Pwe[total-1][0]=1-Pwe[total-2][0];
  for(i=total-2;i>0;i--)Pwe[i][0]-=Pwe[i-1][0];
//################################################
  if(ch_N==0.&&total==2)
   {
    if(abs(sym_last[0])==1)MM2=mass_q[1];
    else if(abs(sym_last[0])==2)MM2=mass_q[0];
    else if(abs(sym_last[0])==3)MM2=mass_q[2];
    else if(abs(sym_last[0])==4)MM2=mass_q[3];
    else if(abs(sym_last[0])==5)MM2=mass_q[4];
    else if(abs(sym_last[0])==6)MM2=mass_q[5];
    else if(abs(sym_last[0])==11)MM2=mass_lc[0];
    else if(abs(sym_last[0])==12)MM2=mass_ln[0];
    else if(abs(sym_last[0])==13)MM2=mass_lc[1];
    else if(abs(sym_last[0])==14)MM2=mass_ln[1];
    else if(abs(sym_last[0])==15)MM2=mass_lc[2];
    else if(abs(sym_last[0])==16)MM2=mass_ln[2];
    else if(abs(sym_last[0])==21)MM2=mass_ga[0];
    else if(abs(sym_last[0])==22)MM2=mass_ga[1];
    else if(sym_last[0]==24)MM2=mass_ga[2];
    else if(sym_last[0]==-24)MM2=mass_ga[3];
    else if(sym_last[0]==23)MM2=mass_ga[4];
    else if(sym_last[0]==25)MM2=mass_s[0];
    else MM2=mass_g[0];

    if(abs(sym_last[1])==1)MM1=mass_q[1];
    else if(abs(sym_last[1])==2)MM1=mass_q[0];
    else if(abs(sym_last[1])==3)MM1=mass_q[2];
    else if(abs(sym_last[1])==4)MM1=mass_q[3];
    else if(abs(sym_last[1])==5)MM1=mass_q[4];
    else if(abs(sym_last[1])==6)MM1=mass_q[5];
    else if(abs(sym_last[1])==11)MM1=mass_lc[0];
    else if(abs(sym_last[1])==12)MM1=mass_ln[0];
    else if(abs(sym_last[1])==13)MM1=mass_lc[1];
    else if(abs(sym_last[1])==14)MM1=mass_ln[1];
    else if(abs(sym_last[1])==15)MM1=mass_lc[2];
    else if(abs(sym_last[1])==16)MM1=mass_ln[2];
    else if(abs(sym_last[1])==21)MM1=mass_ga[0];
    else if(abs(sym_last[1])==22)MM1=mass_ga[1];
    else if(sym_last[1]==24)MM1=mass_ga[2];
    else if(sym_last[1]==-24)MM1=mass_ga[3];
    else if(sym_last[1]==23)MM1=mass_ga[4];
    else if(sym_last[1]==25)MM1=mass_s[0];
    else MM1=mass_g[0];
 
    Pwe[0][1]= (Pb[0]*Pb[0]+(MM1*MM1*MM1*MM1+MM2*MM2*MM2*MM2)/Pb[0]/Pb[0])/4.-(MM2*MM2+MM1*MM1)/2.;
    Pwe[0][0]=sqrt(MM2*MM2 +Pwe[0][1]);
    Pwe[1][0]=sqrt(MM1*MM1 +Pwe[0][1]);
    Pwe[0][1]=sqrt(Pwe[0][1]);
    Pwe[1][1]=Pwe[0][1];
    Pwe[0][2]=MM2;
    Pwe[1][2]=MM1;
   }

  else
   {
    for(i=0;i<total;i++)
     {
      if(abs(sym_last[i])==1)MM2=mass_q[1];
      else if(abs(sym_last[i])==2)MM2=mass_q[0];
      else if(abs(sym_last[i])==3)MM2=mass_q[2];
      else if(abs(sym_last[i])==4)MM2=mass_q[3];
      else if(abs(sym_last[i])==5)MM2=mass_q[4];
      else if(abs(sym_last[i])==6)MM2=mass_q[5];
      else if(abs(sym_last[i])==11)MM2=mass_lc[0];
      else if(abs(sym_last[i])==12)MM2=mass_ln[0];
      else if(abs(sym_last[i])==13)MM2=mass_lc[1];
      else if(abs(sym_last[i])==14)MM2=mass_ln[1];
      else if(abs(sym_last[i])==15)MM2=mass_lc[2];
      else if(abs(sym_last[i])==16)MM2=mass_ln[2];
      else if(abs(sym_last[i])==21)MM2=mass_ga[0];
      else if(abs(sym_last[i])==22)MM2=mass_ga[1];
      else if(sym_last[i]==24)MM2=mass_ga[2];
      else if(sym_last[i]==-24)MM2=mass_ga[3];
      else if(sym_last[i]==23)MM2=mass_ga[4];
      else if(sym_last[i]==25)MM2=mass_s[0];
      else MM2=mass_g[0];

      Pwe[i][0]=Pwe[i][0]*MM3+MM2;
      Pwe[i][1]=sqrt(Pwe[i][0]*Pwe[i][0]-MM2*MM2);
      Pwe[i][2]=MM2;
     }

    MM2=0.;
    for(i=1;i<4+dim1;i++)MM2+=Pb[i]*Pb[i];
    MM2=sqrt(MM2);
    MM1=MM2;
    for(i=0;i<total;i++){MM2+=Pwe[i][1];if(Pwe[i][1]>MM1)MM1=Pwe[i][1]; }
    if(MM1>MM2/2.)flag1=0;

   }//end of else
  
  count+=1;
  if(count ==100)return 0;
 }//end of while 

return 1;
}//end of separation energy


//assign color and charge in final burst one by one
void assign_charge(int *total, int *E_q_c, int *B_q_c, int *sym_last)
{int i,pp1,pp2,pp3;
 
 for(i=0;i<4;i++)E_q_c[i]=0;
 total[0]--;

 if(sym_last[total[0]]==21)
  {pp1=1;pp2=2;pp3=3;
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp1;pp1=pp2;pp2=i;}
   if(B_q_c[pp2]<B_q_c[pp3]){i=pp2;pp2=pp3;pp3=i;} 
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp2;pp2=pp1;pp1=i;}
   B_q_c[pp1]--;
   E_q_c[pp1]++;

   pp1=1;pp2=2;pp3=3;
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp1;pp1=pp2;pp2=i;}
   if(B_q_c[pp2]<B_q_c[pp3]){i=pp2;pp2=pp3;pp3=i;} 
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp2;pp2=pp1;pp1=i;}
   B_q_c[pp3]++;
   E_q_c[pp3]--;

  }//gluon

 else if(abs(sym_last[total[0]])==1||abs(sym_last[total[0]])==3||abs(sym_last[total[0]])==5)
  {pp1=1;pp2=2;pp3=3;
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp1;pp1=pp2;pp2=i;}
   if(B_q_c[pp2]<B_q_c[pp3]){i=pp2;pp2=pp3;pp3=i;} 
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp2;pp2=pp1;pp1=i;}
   if(sym_last[total[0]]>0){B_q_c[pp1]--;E_q_c[pp1]++;E_q_c[0]-=1;B_q_c[0]+=1;}
   if(sym_last[total[0]]<0){B_q_c[pp3]++;E_q_c[pp3]--;E_q_c[0]+=1;B_q_c[0]-=1;}
  }//down quark

 else if(abs(sym_last[total[0]])==2||abs(sym_last[total[0]])==4||abs(sym_last[total[0]])==6)
  {pp1=1;pp2=2;pp3=3;
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp1;pp1=pp2;pp2=i;}
   if(B_q_c[pp2]<B_q_c[pp3]){i=pp2;pp2=pp3;pp3=i;} 
   if(B_q_c[pp1]<B_q_c[pp2]){i=pp2;pp2=pp1;pp1=i;}
   if(sym_last[total[0]]>0){B_q_c[pp1]--;E_q_c[pp1]++;E_q_c[0]+=2;B_q_c[0]-=2;}
   if(sym_last[total[0]]<0){B_q_c[pp3]++;E_q_c[pp3]--;E_q_c[0]-=2;B_q_c[0]+=2;}
  }//e

 else if(abs(sym_last[total[0]])==11||abs(sym_last[total[0]])==13||abs(sym_last[total[0]])==15)
  {
   if(sym_last[total[0]]>0){E_q_c[0]-=3;B_q_c[0]+=3;}
   if(sym_last[total[0]]<0){E_q_c[0]+=3;B_q_c[0]-=3;}
  }//W

 else if(abs(sym_last[total[0]])==24)
  {
   if(sym_last[total[0]]>0){E_q_c[0]+=3;B_q_c[0]-=3;}
   if(sym_last[total[0]]<0){E_q_c[0]-=3;B_q_c[0]+=3;}
  }//up quark

 else ;


}//end of assign charge



//read parameter file.
int read_parameters(char *filename,int *Ndice1,double *Q2,double *Mpl1,double *Lg_size1,int *ch_case1,int *dim1,int *dims1, double *L51,double *Bt1,int *in_pdf,double *Mmax1,double *Mmin1, double *time_step1,double *Mlra1,double *Plra1, double *Llra1,long int *rseed,int *suppress1,double *suppressL1,int *Charge_suppress1,double *suppressQ1,double *suppressC1,double *width1, double **pos1,int *fix_time1,int *do_yo1,int *de_Mpl1, double *Mpl_factor1, int *initial_particle1, int *number_constraint,int **constraint, int *on_gravity1, int *WriteLHArecord)
{ FILE *pFile, *pFile7;
  char *buffer,*buffer1;
  float aa;
  int j,i;

  buffer =malloc(500*sizeof(char));
  buffer1 =malloc(500*sizeof(char));
  pFile = fopen("parameter.txt","r");
  pFile7= fopen(filename,"w");

  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",Ndice1);                     fprintf(pFile7,"%d\n",Ndice1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",initial_particle1);          fprintf(pFile7,"%d\n",initial_particle1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Q2);                        fprintf(pFile7,"%lf\n",Q2[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Mpl1);Lg_size1[0]=1./Mpl1[0];fprintf(pFile7,"%lf\n",Mpl1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",de_Mpl1);                     fprintf(pFile7,"%d\n",de_Mpl1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Mpl_factor1);               fprintf(pFile7,"%f\n",Mpl_factor1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",ch_case1);                   fprintf(pFile7,"%d\n",ch_case1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",dim1);                       fprintf(pFile7,"%d\n",dim1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",dims1);                      fprintf(pFile7,"%d\n",dims1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%f",&aa);L51[0]=aa/Mpl1[0];      fprintf(pFile7,"%f\n",aa);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%f",&aa);Bt1[0]=aa;               fprintf(pFile7,"%f\n",aa);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",in_pdf);                     fprintf(pFile7,"%d\n",in_pdf[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Mmin1);                     fprintf(pFile7,"%lf\n",Mmin1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Mmax1);                     fprintf(pFile7,"%lf\n",Mmax1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",fix_time1);                  fprintf(pFile7,"%d\n",fix_time1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%f",&aa);time_step1[0]=aa;       fprintf(pFile7,"%e\n",aa);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",do_yo1);                     fprintf(pFile7,"%d\n",do_yo1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Mlra1);                     fprintf(pFile7,"%lf\n",Mlra1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Plra1);                     fprintf(pFile7,"%lf\n",Plra1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%lf",Llra1);                     fprintf(pFile7,"%lf\n",Llra1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",on_gravity1);                fprintf(pFile7,"%d\n",on_gravity1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%ld",rseed);                     fprintf(pFile7,"%ld\n",rseed[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",WriteLHArecord);             fprintf(pFile7,"%d\n",WriteLHArecord[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",suppress1);                  fprintf(pFile7,"%d\n",suppress1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%f",&aa);suppressL1[0]=aa;       fprintf(pFile7,"%f\n",aa);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",Charge_suppress1);           fprintf(pFile7,"%d\n",Charge_suppress1[0]);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%f",&aa);suppressQ1[0]=aa;       fprintf(pFile7,"%f\n",aa);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%f",&aa);suppressC1[0]=aa;       fprintf(pFile7,"%f\n",aa);
  fscanf(pFile,"%s",buffer);                     fprintf(pFile7,"%s\n",buffer);

  //  fscanf(pFile,"%s",buffer);
  for(j=0;j<42;j++)
    {
      fscanf(pFile,"%s",buffer);               fprintf(pFile7,"%s\n",buffer);
      fscanf(pFile,"%f",&aa);                  fprintf(pFile7,"%f\n",aa);
      width1[j]=Mpl1[0]/aa;

      fscanf(pFile,"%s",buffer);               fprintf(pFile7,"%s\n",buffer);
      //printf("%s \n",buffer);
      for(i=0;i<dims1[0];i++)
	{sscanf(buffer,"%f,%s",&aa,buffer1);
	  pos1[j][i]=aa*L51[0]/30.;
	  buffer=buffer1;
	}
    }


//  fclose(pFile);


//reading constraint
//  pFile = fopen("conservation.txt","r");


  fscanf(pFile,"%s",buffer);                  fprintf(pFile7,"%s\n",buffer);
  fscanf(pFile,"%d",number_constraint);       fprintf(pFile7,"%d\n",number_constraint[0]);
  fscanf(pFile,"%s",buffer);                  fprintf(pFile7,"%s\n",buffer);

  for(j=0;j<number_constraint[0];j++)
    {fscanf(pFile,"%s",buffer);               fprintf(pFile7,"%s\n",buffer);
     for(i=0;i<12;i++)
      {sscanf(buffer,"%d,%s",&constraint[j][i],buffer1);

       buffer=buffer1;
      }
     constraint[j][12]=constraint[j][13]=0;
    }

  fclose(pFile7);fclose(pFile);


  return 1;

}

//caclulation of the first part of the spectrum
//A0*x^A1
double part1(double *A, double x)
{
 return A[0]*pow(x,A[1]);
}

//caclulation of second and the third part of the spectrum
//Bn*x^n
double part23(double *B, double x ,int n)
{int i; 
 double a,b;
 a=0;b=1;
 for(i=0;i<n;i++)
  {a+=B[i]*b;
   b*=x;
  }
 return a;
}

//caclulation of the forth part of the spectrum
//D0/(1+exp(D1x)
double part4(double *D,double x)
{return D[0]/(1+exp(D[1]*x));
}

//calculate of the part4 of rotation
double part4_rotation(double D,double x,double omega, double T,double m,int i)
{if (i==0|| i==2)return D*x/(exp((x-m*omega)/T)-1.);
 else return D*x/(exp((x-m*omega)/T)+1.);
}

double part1_4(double *A, double *B, double *C, double *D, double *location1, double aa, int power ,double omega,double T,double m,int type)
{double aa1;

 if (aa<location1[0])aa1=part1(A, aa);
 else if (aa<location1[1])aa1=part23(B, aa-location1[1],power);
 else if (aa<location1[2])aa1=part23(C, aa-location1[2],power);
 else aa1=part4_rotation(D[0], aa,omega,T,m,type);

 return aa1;
}
//setup spactrum for nonrotating black hole
double spectrum_norotating(int type, double end_spectrum,int N_spectrum1,double **spectrum1,int dim1, int dims1)
{int i,power=8; 
 char filename[100],*buffer,*buffer1;
 FILE *pFile;
 double aa,aa1;
 double location1[3];
 double *A,*B,*C,*D;
 A=malloc(2*sizeof(double));
 B=malloc(power*sizeof(double));
 C=malloc(power*sizeof(double));
 D=malloc(2*sizeof(double));
 buffer =malloc(500*sizeof(char));
 buffer1 =malloc(500*sizeof(char));

 if (type==0) sprintf(filename,"spectrum/nonrotation/scalar/scalar_%d_%d.txt",dim1,dims1);
 else if (type==1)sprintf(filename,"spectrum/nonrotation/spinor/spinor_%d.txt",dim1);
 else if (type==3)sprintf(filename,"spectrum/nonrotation/graviton/graviton_%d.txt",dim1);
 else sprintf(filename,"spectrum/nonrotation/vector/gauge_%d_%d.txt",dim1,dims1);


 pFile = fopen(filename,"r");

 fscanf(pFile,"%s",buffer);
 for(i=0;i<3;i++){sscanf(buffer,"%lf,%s",&location1[i],buffer1);buffer=buffer1;}
 fscanf(pFile,"%s",buffer);
 for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&A[i],buffer1);buffer=buffer1;}
 fscanf(pFile,"%s",buffer);
 for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&B[i],buffer1);buffer=buffer1;}
 fscanf(pFile,"%s",buffer);
 for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&C[i],buffer1);buffer=buffer1;}
 fscanf(pFile,"%s",buffer);
 for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&D[i],buffer1);buffer=buffer1;}
 fclose(pFile);


 for(i=0;i<N_spectrum1;i++)
  {spectrum1[0][i]=(i+1)*end_spectrum/N_spectrum1;
   if (spectrum1[0][i]<location1[0])spectrum1[1][i]=part1(A, spectrum1[0][i])/spectrum1[0][i];
   else if (spectrum1[0][i]<location1[1])spectrum1[1][i]=part23(B, spectrum1[0][i]-location1[1],power)/spectrum1[0][i];
   else if (spectrum1[0][i]<location1[2])spectrum1[1][i]=part23(C, spectrum1[0][i]-location1[2],power)/spectrum1[0][i];
   else spectrum1[1][i]=part4(D, spectrum1[0][i])/spectrum1[0][i];
  }

 aa=spectrum1[1][0];
 spectrum1[1][0]=0.;
 for(i=1;i<N_spectrum1;i++)
  {aa1=spectrum1[1][i];
   spectrum1[1][i]=(aa+aa1)/2.+spectrum1[1][i-1];
   aa=aa1;

  }

 aa1=spectrum1[1][N_spectrum1-1]*(spectrum1[0][1]-spectrum1[0][0]);
 for(i=0;i<N_spectrum1;i++)spectrum1[1][i]/=spectrum1[1][N_spectrum1-1];

 return aa1;

} //end of setup spectrum for nonroating black hole 


//set up spectrum for tension model
//setup spactrum for nonrotating black hole
double spectrum_norotating_tension(int type, double end_spectrum,int N_spectrum1,double **spectrum1,int dim1, int dims1, double Bt1)
{int i,power=8; 
 char filename[100],*buffer,*buffer1;
 FILE *pFile;
 double aa,aa1;
 double location2[3],location1[3];
 double *A,*B,*C,*D,*A1,*B1,*C1,*D1;
 int Bc1,Bc2;

 A=malloc(2*sizeof(double));
 B=malloc(power*sizeof(double));
 C=malloc(power*sizeof(double));
 D=malloc(2*sizeof(double));
 A1=malloc(2*sizeof(double));
 B1=malloc(power*sizeof(double));
 C1=malloc(power*sizeof(double));
 D1=malloc(2*sizeof(double));

 buffer =malloc(500*sizeof(char));
 buffer1 =malloc(500*sizeof(char));



 if((dims1==0&&type<3)||type==1)
  {if(type==0)sprintf(filename,"spectrum/nonrotation/scalar/scalar_%d_%d.txt",dim1,dims1);
   else if (type==1)sprintf(filename,"spectrum/nonrotation/spinor/spinor_%d.txt",dim1);
   else sprintf(filename,"spectrum/nonrotation/vector/gauge_%d_%d.txt",dim1,dims1);

   pFile=fopen(filename,"r");

   fscanf(pFile,"%s",buffer);
   for(i=0;i<3;i++){sscanf(buffer,"%lf,%s",&location2[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&A[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&B[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&C[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&D[i],buffer1);buffer=buffer1;}
   fclose(pFile);

   for(i=0;i<N_spectrum1;i++)
    {spectrum1[0][i]=(i+1)*end_spectrum/N_spectrum1;
     if (spectrum1[0][i]<location2[0])spectrum1[1][i]=part1(A, spectrum1[0][i])/spectrum1[0][i];
     else if (spectrum1[0][i]<location2[1])spectrum1[1][i]=part23(B, spectrum1[0][i]-location2[1],power)/spectrum1[0][i];
     else if (spectrum1[0][i]<location2[2])spectrum1[1][i]=part23(C, spectrum1[0][i]-location2[2],power)/spectrum1[0][i];
     else spectrum1[1][i]=part4(D, spectrum1[0][i])/spectrum1[0][i];


    }

   aa=spectrum1[1][0];
   spectrum1[1][0]=0.;
   for(i=1;i<N_spectrum1;i++)
    {aa1=spectrum1[1][i];
     spectrum1[1][i]=(aa+aa1)/2.+spectrum1[1][i-1];
     aa=aa1;
    }

   aa1=spectrum1[1][N_spectrum1-1]*(spectrum1[0][1]-spectrum1[0][0]);
   for(i=0;i<N_spectrum1;i++)spectrum1[1][i]/=spectrum1[1][N_spectrum1-1];

   return aa1;
  }

 if((dims1==2&&type!=1)||type==3)
  {if(Bt1<0.4){Bc1=0;Bc2=4;}
   else if(Bt1<0.6){Bc1=4;Bc2=6;}
   else if(Bt1<0.8){Bc1=6;Bc2=8;}
   else if(Bt1<0.9){Bc1=8;Bc2=9;}
   else {Bc1=9;Bc2=10;}

   if (type==0) sprintf(filename,"spectrum/tension/scalar/scalar_t_%d.txt",Bc1);
   else if (type==3)sprintf(filename,"spectrum/tension/graviton/graviton_t_%d.txt",Bc1);
   else sprintf(filename,"spectrum/tension/vector/gauge_t_%d.txt",Bc1);

   pFile=fopen(filename,"r");

   fscanf(pFile,"%s",buffer);
   for(i=0;i<3;i++){sscanf(buffer,"%lf,%s",&location2[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&A[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&B[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&C[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&D[i],buffer1);buffer=buffer1;}
   fclose(pFile);

   if (type==0) sprintf(filename,"spectrum/tension/scalar/scalar_t_%d.txt",Bc2);
   else if (type==3)sprintf(filename,"spectrum/tension/graviton/graviton_t_%d.txt",Bc2);
   else sprintf(filename,"spectrum/tension/vector/gauge_t_%d.txt",Bc2);

    pFile=fopen(filename,"r");

   fscanf(pFile,"%s",buffer);
   for(i=0;i<3;i++){sscanf(buffer,"%lf,%s",&location1[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&A1[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&B1[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<power;i++){sscanf(buffer,"%lf,%s",&C1[i],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(i=0;i<2;i++){sscanf(buffer,"%lf,%s",&D1[i],buffer1);buffer=buffer1;}
   fclose(pFile);

   for(i=0;i<N_spectrum1;i++)
    {spectrum1[0][i]=(i+1)*end_spectrum/N_spectrum1;
     aa=(Bc2-Bt1*10.)/((double)(Bc2-Bc1));aa1=(10*Bt1-Bc1)/((double)(Bc2-Bc1));
     if (spectrum1[0][i]<location2[0])spectrum1[1][i]=part1(A, spectrum1[0][i])*aa/spectrum1[0][i];
     else if (spectrum1[0][i]<location2[1])spectrum1[1][i]=part23(B, spectrum1[0][i]-location2[1],power)*aa/spectrum1[0][i];
     else if (spectrum1[0][i]<location2[2])spectrum1[1][i]=part23(C, spectrum1[0][i]-location2[2],power)*aa/spectrum1[0][i];
     else spectrum1[1][i]=part4(D, spectrum1[0][i])*aa/spectrum1[0][i];

     if (spectrum1[0][i]<location1[0])spectrum1[1][i]+=part1(A1, spectrum1[0][i])*aa1/spectrum1[0][i];
     else if (spectrum1[0][i]<location1[1])spectrum1[1][i]+=part23(B1, spectrum1[0][i]-location1[1],power)*aa1/spectrum1[0][i];
     else if (spectrum1[0][i]<location1[2])spectrum1[1][i]+=part23(C1, spectrum1[0][i]-location1[2],power)*aa1/spectrum1[0][i];
     else spectrum1[1][i]+=part4(D1, spectrum1[0][i])*aa1/spectrum1[0][i];
    }

   aa=spectrum1[1][0];
   spectrum1[1][0]=0.;
   for(i=1;i<N_spectrum1;i++)
    {aa1=spectrum1[1][i];
     spectrum1[1][i]=(aa+aa1)/2.+spectrum1[1][i-1];
     aa=aa1;
    }

   aa1=spectrum1[1][N_spectrum1-1]*(spectrum1[0][1]-spectrum1[0][0]);
   for(i=0;i<N_spectrum1;i++)spectrum1[1][i]/=spectrum1[1][N_spectrum1-1];
   return aa1;
  }


}//end of set up spectrum for tension model 


int calculate_number_case_rotating(int dim1)
{FILE *pFile;
 int total;
 char filename[100];

 sprintf(filename,"spectrum/rotation/n%d.txt",dim1);
 pFile = fopen(filename,"r");
 total =-1;
 while(!feof(pFile)){fscanf (pFile,"%s",filename);total++;}
 fclose(pFile);

 return total;
}

//set up the spectrum of the rotating black hole 
void read_pareameter_rotating(int type,int N_a_rotation1,double end_spectrum,int N_spectrum1,double ***spectrum_r1,double *aa_r1,int dim1,double ***A,double ***B,double ***C,double ***D,int N_lm1,double ***location1,double *Epow_r1,int fiteigen,double ***eigen_ro,double **eigen_location1)
{FILE *pFile;
 int i,j,k,power=9;
 double aa,aa1,m,omega,T;
 char filename[200],*buffer,*buffer1;
 
 buffer =malloc(500*sizeof(char));
 buffer1 =malloc(500*sizeof(char));

 sprintf(filename,"spectrum/rotation/n%d.txt",dim1);

 pFile = fopen(filename,"r");
 for(i=0;i<N_a_rotation1;i++){fscanf(pFile,"%lf",&aa);aa_r1[i]=aa;}
 fclose(pFile);

 for(i=0;i<N_a_rotation1;i++)
  {
   if (type==0){ sprintf(filename,"spectrum/rotation/scalar/n%d/scalar_%1.1f_%d.txt",dim1,aa_r1[i],dim1);}
   else if (type==1)sprintf(filename,"spectrum/rotation/spinor/n%d/spinor_%1.1f_%d.txt",dim1,aa_r1[i],dim1);
   else sprintf(filename,"spectrum/rotation/gauge/n%d/vector_%1.1f_%d.txt",dim1,aa_r1[i],dim1);

   pFile=fopen(filename,"r");

   for(k=0;k<N_spectrum1;k++)
    {
     spectrum_r1[i][0][k]=(k+1)*end_spectrum/N_spectrum1;
     spectrum_r1[i][1][k]=0.;
    }

   omega=aa_r1[i]/(1+aa_r1[i]*aa_r1[i]);
   T=((dim1+1)+(dim1-1)*aa_r1[i]*aa_r1[i])/4./asin(1.)/2./(1.+aa_r1[i]*aa_r1[i]);

   for(j=0;j<N_lm1;j++)
    {


     fscanf(pFile,"%s",buffer);
     sscanf(buffer,"l,%lf,%s",&m,buffer1);buffer=buffer1;
     sscanf(buffer,"%lf",&m);
      fscanf(pFile,"%s",buffer);
     for(k=0;k<3;k++){sscanf(buffer,"%lf,%s",&location1[i][j][k],buffer1);buffer=buffer1;}
     fscanf(pFile,"%s",buffer);
     for(k=0;k<2;k++){sscanf(buffer,"%lf,%s",&A[i][j][k],buffer1);buffer=buffer1;}
     fscanf(pFile,"%s",buffer);
     for(k=0;k<power;k++){sscanf(buffer,"%lf,%s",&B[i][j][k],buffer1);buffer=buffer1;}
     fscanf(pFile,"%s",buffer);
     for(k=0;k<power;k++){sscanf(buffer,"%lf,%s",&C[i][j][k],buffer1);buffer=buffer1;}
     fscanf(pFile,"%s",buffer);
     for(k=0;k<1;k++){sscanf(buffer,"%lf",&D[i][j][k],buffer1);buffer=buffer1;}

     for(k=0;k<N_spectrum1;k++)
      {if (spectrum_r1[i][0][k]<location1[i][j][0])
        spectrum_r1[i][1][k]+=part1(A[i][j], spectrum_r1[i][0][k])/spectrum_r1[i][0][k];
       else if (spectrum_r1[i][0][k]<location1[i][j][1])
        spectrum_r1[i][1][k]+=part23(B[i][j], spectrum_r1[i][0][k]-location1[i][j][1],power)/spectrum_r1[i][0][k];
       else if (spectrum_r1[i][0][k]<location1[i][j][2])
        spectrum_r1[i][1][k]+=part23(C[i][j], spectrum_r1[i][0][k]-location1[i][j][2],power)/spectrum_r1[i][0][k];
       else spectrum_r1[i][1][k]+=part4_rotation(D[i][j][0],spectrum_r1[i][0][k],omega,T,m,type)/spectrum_r1[i][0][k];
 
      }//end of k<N_spectrum
      
    }//end of j <N_lm

   fclose(pFile);

   aa=spectrum_r1[i][1][0];
   spectrum_r1[i][1][0]=0.;
   for(k=1;k<N_spectrum1;k++)
    {aa1=spectrum_r1[i][1][k];
//if (type==2)printf("%e %e\n",spectrum_r[i][0][k],aa1*spectrum_r[i][0][k]);
//if(aa1<0)printf("%d %d\n", type ,i);
     spectrum_r1[i][1][k]=(aa+aa1)/2.+spectrum_r1[i][1][k-1];
     aa=aa1;
    }

   Epow_r1[i]=spectrum_r1[i][1][N_spectrum1-1]*(spectrum_r1[i][0][1]-spectrum_r1[i][0][0]);
   for(k=0;k<N_spectrum1;k++)spectrum_r1[i][1][k]/=spectrum_r1[i][1][N_spectrum1-1]; 



  }  //end of i <N_a_rotation
 
//set up angular parameter
 if (type==0){ sprintf(filename,"spectrum/rotation/angular/scalar/scalar-angle-%d.txt",dim1,aa_r1[i],dim1);}
 else if (type==1)sprintf(filename,"spectrum/rotation/angular/spinor/spinor-angle-%d.txt",dim1,aa_r1[i],dim1);
 else sprintf(filename,"spectrum/rotation/angular/gauge/vector-angle-%d.txt",dim1,aa_r1[i],dim1);
 
 pFile=fopen(filename,"r");
   
 for(j=0;j<N_lm1;j++)
  {
   fscanf(pFile,"%s",buffer);
   fscanf(pFile,"%s",buffer);
   for(i=0;i<5;i++){sscanf(buffer,"%lf,%s",&eigen_location1[j][i],buffer1);buffer=buffer1;}
   for(i=0;i<5;i++)
    {fscanf(pFile,"%s",buffer);
     for(k=0;k<fiteigen;k++){sscanf(buffer,"%lf,%s",&eigen_ro[j][i][k],buffer1);buffer=buffer1;}
    }
  }//end of j<N_lm

 fclose(pFile);


}//end of set up the spectrum of rotating black hole


//calculate parameter of lisa model
void set_parameter_lisa(int dim1, double *rho1, int N_spectrum1,double end_spectrum)
{double   Gamma_i[3], phi_i[3],f_i[3]={1.,7./8.,1.},g_i[3]={1.,3./4.,1.},c_i[3]={1,90,27},T_lisa,lisa1,lisa2,lisa1_1,lisa2_1,delta_lisa;
 int i,j,power=8;
 double aa,aa1;
 double location1[3];
 double *A,*B,*C,*D;
 char *buffer,*buffer1,filename[100];
 FILE *pFile;

 A=malloc(2*sizeof(double));
 B=malloc(power*sizeof(double));
 C=malloc(power*sizeof(double));
 D=malloc(2*sizeof(double));
 buffer =malloc(500*sizeof(char));
 buffer1 =malloc(500*sizeof(char));

 T_lisa=(1.+dim1)/4./pi;
 for(i=0;i<3;i++)
  {
   if (i==0) sprintf(filename,"spectrum/nonrotation/scalar/scalar_%d_%d.txt",dim1,0);
   else if (i==1)sprintf(filename,"spectrum/nonrotation/spinor/spinor_%d.txt",dim1);
   else sprintf(filename,"spectrum/nonrotation/vector/gauge_%d_%d.txt",dim1,0);

   pFile = fopen(filename,"r");

   fscanf(pFile,"%s",buffer);
   for(j=0;j<3;j++){sscanf(buffer,"%lf,%s",&location1[j],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(j=0;j<2;j++){sscanf(buffer,"%lf,%s",&A[j],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(j=0;j<power;j++){sscanf(buffer,"%lf,%s",&B[j],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(j=0;j<power;j++){sscanf(buffer,"%lf,%s",&C[j],buffer1);buffer=buffer1;}
   fscanf(pFile,"%s",buffer);
   for(j=0;j<2;j++){sscanf(buffer,"%lf,%s",&D[j],buffer1);buffer=buffer1;}
   fclose(pFile);

   phi_i[i]=0;
   Gamma_i[i]=0;
   lisa1=0;lisa2=0;

   for(j=0;j<N_spectrum1;j++)
    {aa=(j+1)*end_spectrum/N_spectrum1;
     if (aa<location1[0])aa1=part1(A, aa);
     else if (aa<location1[1])aa1=part23(B, aa-location1[1],power);
     else if (aa<location1[2])aa1=part23(C, aa-location1[2],power);
     else aa1=part4(D, aa);

     if(i==0 || i==2)
      {lisa1_1=aa*aa/(exp(aa/T_lisa)-1);//number
       lisa2_1=aa*aa*aa/(exp(aa/T_lisa)-1);//power
      }
     else
      {lisa1_1=aa*aa/(exp(aa/T_lisa)+1);
       lisa2_1=aa*aa*aa/(exp(aa/T_lisa)+1);
      }

     if(j==0||j==N_spectrum1-1){phi_i[i]+=aa1/2.;Gamma_i[i]+=aa1/aa/2.;lisa1+=lisa1_1/2.;lisa2+=lisa2_1/2.;}
     else {phi_i[i]+=aa1;Gamma_i[i]+=aa1/aa;lisa1+=lisa1_1;lisa2+=lisa2_1;}

    }//end of i<N_spectrum


   phi_i[i]/=lisa2;
   Gamma_i[i]/=lisa1;

  }//end of i

 lisa1=0;lisa2=0; 
 for(i=0;i<3;i++){lisa1+=c_i[i]*g_i[i]*Gamma_i[i];lisa2+=c_i[i]*f_i[i]*phi_i[i];}
 rho1[0]=lisa1/lisa2*1.20206*2/(pi*pi*pi*pi/90.*6.);

}//end of seting up parameters of lisa model

//found the momentum and position of initial black hole 

double initial_black_hole(double *u, double *v, double y,int sepu, int sepv,double *fqt, double **fq, double *fq_v, double *Q2,int Nq, double *fcolor,int dim1,int dims1,double *Rs, double **pos1, double *posuv,double *posv, double *width1, double **M, double L51, double Lg_size1, double *P_lisa, double rho1,double *Mpl1,double *kn1, int ch_case1, int *uvc, int *vc,int do_yo1,double yoshino_r_max1,int initial_particle1, int yoshino_i1,double *yoshino_factor1)

{double fpik,pp1_r,pp2_r;
 int pp1,pp2,l,qn,i,m;
 double Q1,x,aa,theta ,phi,N_lisa;

 // create a black hole with energy u

 if(initial_particle1!=3)//pp or ppbar
  {
   fpik=drand48();
   pp1=findintr(fpik,sepu,fqt);//find u
   pp1_r=pp1+(fpik-fqt[pp1])/(fqt[pp1+1]-fqt[pp1]);

   for(i=0;i<sepv;i++)fq_v[i]=fq[pp1][i]+(fq[pp1+1][i]-fq[pp1][i])*(fpik-fqt[pp1])/(fqt[pp1+1]-fqt[pp1]);
   fpik=drand48();
   pp2=findintr(fpik,sepv,fq_v);//find u/v ,v
   pp2_r=pp2+(fpik-fq_v[pp2])/(fq_v[pp2+1]-fq_v[pp2]);
   u[0]=pp1_r*(1.-y)/sepu+y;
   v[0]=pp2_r*(1.-u[0])/sepv+u[0];
 
   //find incoming quark type
   Q1=sqrt(u[0])*Q2[0];
   fcolor[0]=0.;
   for(l=0;l<Nq;l++)
    {x=v[0];qn=l;
     x=countpdf(x,Q1,qn);
     if(l>1&&l!=8)x*=2;
     fcolor[l+1]=fcolor[l]+x;
    }//end of l

   //end of set up v passibility of v type
   for(i=0;i<Nq+1;i++)fcolor[i]/=fcolor[Nq];
   fpik=drand48();
   vc[0]=findintr(fpik,Nq+1,fcolor);//v type
   if(vc[0]>1&&drand48()>0.5&&vc[0]!=8)vc[0]*=-1;
   vc[0]=ffin1(vc[0]);

   fcolor[0]=0.;
   for(m=0;m<Nq;m++)
    {x=u[0]/v[0];qn=m;
     x=countpdf(x,Q1,qn);
     if(m>1&&l!=8)x*=2;
     fcolor[m+1]=fcolor[m]+x;
    }// end m//
    //end of prossibility of u/v quark type

   for(i=0;i<Nq+1;i++)fcolor[i]/=fcolor[Nq];
   fpik=drand48();

   uvc[0]=findintr(fpik,Nq+1,fcolor);//u/v type

   if(uvc[0]>1&&drand48()>0.5&&uvc[0]!=8)uvc[0]*=-1;
   if(initial_particle==2&&uvc[0]!=8){if(uvc[0]==0||uvc[0]==1)uvc[0]+=2;uvc[0]*=-1;}
   uvc[0]=ffin1(uvc[0]);

  }

 else  
  {v[0]=1;
   u[0]=1; 
   vc[0]=24;
   uvc[0]=26;
  }//e-e+

 //####################################################

 for(i=0;i<dim1+3;i++)posuv[i]=posv[i]=0.;
 posv[0]=Rs[0]*sqrt(drand48());//u/v is at 0 
 aa=2.*pi*drand48();
 posv[1]=posv[0]*sin(aa);posv[0]*=cos(aa);


 theta=pi/2.;phi=aa-pi/2.;
 put_value(M,theta,phi);


 if (drand48()>0.5)i=0;//right or left of uv
 else i=1;
 
 if(uvc[0]!=-1)for(m=0;m<dims1;m++)
  {posuv[3+m]=pos1[uvc[0]+i][m]+gaussrand()/2/width1[uvc[0]+i];
   if(posuv[3+m]>L51/2.)posuv[3+m]=L51/2.;
   if(posuv[3+m]<-L51/2.)posuv[3+m]=-L51/2.;
  }
 else for(m=0;m<dims1;m++)posuv[3+m]=(drand48()-0.5)*L51;

 for(m=dims1;m<dim1;m++)posuv[3+m]=(drand48()-0.5)*Lg_size1;

 if (drand48()>0.5)i=0;//right or left of v
 else i=1;

 if(vc[0]!=-1)for(m=0;m<dims1;m++)
  {posv[3+m]=pos1[vc[0]+i][m]+gaussrand()/2/width1[vc[0]+i];
   if(posv[3+m]>L51/2.)posuv[3+m]=L51/2.;
   if(posv[3+m]<-L51/2.)posuv[3+m]=-L51/2.;
  }
 else for(m=0;m<dims1;m++){posv[3+m]=(drand48()-0.5)*L51;}

 for(m=dims1;m<dim1;m++)posv[3+m]=(drand48()-0.5)*Lg_size1;

 if(ch_case1==4)
  {N_lisa=rho1*pow(4*pi*kn1[0]/(2.+dim1)*u[0]*Q2[0]/Mpl1[0],(dim1+2.)/(dim1+1.));
   if(do_yo1==1)N_lisa=rho1*pow(4*pi*kn1[0]/(2.+dim1)*u[0]*Q2[0]/Mpl1[0]*part23(yoshino_factor1,0.,yoshino_i1),(dim1+2.)/(dim1+1.));
   P_lisa[0]=exp(-N_lisa)*(1+N_lisa+N_lisa*N_lisa/2.);
  }
 else P_lisa[0]=1;
 
// if(do_yo==1)P_lisa[0]=yoshino_r_max*yoshino_r_max;

 

 return pp1_r;
}//end of initial black hole 


//setup momentum energy and angular momentum of initial black hole 
void   P_E_L(double *Pm, double *Mm, double *Lm, double *Lm1, double *ap, double *u,double *v,double *Q2,double *posuv,double *posv,double *Mlra1,double *Plra1, double *Llra1, int dim1,int do_yo1,int yoshino_i1,double *yoshino_factor1,double yoshino_r_max1,double r,double Mpl1)
{double x;

 if(do_yo1!=1)
  {
   Pm[0]=(u[0]/v[0]-v[0])*Q2[0]/2.*(1-Plra1[0]);//momentum keep
   Mm[0]=(u[0]/v[0]+v[0])*Q2[0]/2.*(1-Mlra1[0]);//Energy keep
   Mm[0]=sqrt(Mm[0]*Mm[0]-Pm[0]*Pm[0]);
  }
 else 
  {x=sqrt(dist2(posuv,posv,dim1+3)/r);
   Mlra1[0]=1-part23(yoshino_factor1,x,yoshino_i1);
   if((1-Mlra1[0])<Mpl1/sqrt(u[0])/Q2[0])Mlra1[0]=1-Mpl1/sqrt(u[0])/Q2[0];
   
   Plra1[0]=Mlra1[0];
   Pm[0]=(u[0]/v[0]-v[0])*Q2[0]/2.*(1-Plra1[0]);//momentum keep
   Mm[0]=(u[0]/v[0]+v[0])*Q2[0]/2.*(1-Mlra1[0]);//Energy keep
   Mm[0]=sqrt(Mm[0]*Mm[0]-Pm[0]*Pm[0]);
  }


 Lm[0]=sqrt(u[0]*dist2(posuv,posv,3))/2.*Q2[0]*(1-Llra1[0]);//angular momentum keep in regular
 x=(-1.+sqrt(1+4*Lm[0]*Lm[0]));
 Lm1[0]=(int)x;
 if((x-Lm1[0])>0.5)Lm1[0]++;
 Lm1[0]/=2.;
 Lm[0]=sqrt((Lm1[0]+1)*Lm1[0]);
 ap[0]=(dim1+2.)/2./Mm[0]*Lm[0];
}


//set Rsb of initial black 
int set_initial_Rsb_spectrum(int dim1, int ch_case1, double *Mpl1, double *kn1, double *Rsb, double Bt1,double *ap1, double ap,double Mm)
{

 if(ch_case1==1)Rsb[0]=kn1[0]/Mpl1[0]*pow(Mm/Mpl1[0],1./(1.+dim1) );
 if(ch_case1==2)Rsb[0]=kn1[0]/Mpl1[0]*pow(Mm/Mpl1[0]/Bt1,1./(3.) );

 if(ch_case1==3)
  {Rsb[0]=kn1[0]/Mpl1[0]*pow(Mm/Mpl1[0],1./(1.+dim1) );
   if(dim1>=2)Rsb[0]=countRh(dim1,ap,Rsb[0]);
   else if(dim1==1){if(ap>Rsb[0])return 0;Rsb[0]=sqrt(Rsb[0]*Rsb[0]-ap*ap);}
   else {if(ap>Rsb[0]/2)return 0;Rsb[0]=(Rsb[0]+sqrt(Rsb[0]*Rsb[0]-4*ap*ap))/2;}
   ap1[0]=ap/Rsb[0];
  }//end of ch_case==3

return 1;
}// end of set up radius of initial black hole


//calculate spectrum of rotating black hole 
double calculate_spectrum_rotating(double ap1, int N_a_rotation1, int N_spectrum1, double *aa_r1, double *Epow_r1, double **spectrum1, double ***spectrum_r1)
{int k,A_index;
 double Epow_s1;

 A_index=findpd(ap1,N_a_rotation1,aa_r1);
 if(A_index>N_a_rotation1-2)A_index=N_a_rotation1-2;
 Epow_s1=((ap1-aa_r1[A_index])*Epow_r1[A_index+1]+(aa_r1[A_index+1]-ap1)*Epow_r1[A_index])/(aa_r1[A_index+1]-aa_r1[A_index]);

 for(k=0;k<N_spectrum1;k++)
  {spectrum1[0][k]=spectrum_r1[A_index][0][k];
   spectrum1[1][k]=((aa_r1[A_index+1]-ap1)*spectrum_r1[A_index][1][k]+(ap1-aa_r1[A_index])*spectrum_r1[A_index+1][1][k])/(aa_r1[A_index+1]-aa_r1[A_index]);
  }   

return Epow_s1;
}// end of calculating spectrum of rotating black hole

//set initial color of incoming particle
 
void initial_color(int *B_q_c,int *E_q_c,int *flavor,int uvc,int vc)
{int i;

 for(i=0;i<14;i++)flavor[i]=0;
 for(i=0;i<4;i++)B_q_c[i]=E_q_c[i]=0;

 if(uvc==-1)
  {B_q_c[0]+=0;
   B_q_c[1+(int)(drand48()*3.)]+=1;
   B_q_c[1+(int)(drand48()*3.)]-=1;
   flavor[13]+=1;
  }
 else if((uvc%4)<2&&uvc<24)
  {B_q_c[1+(int)(drand48()*3.)]+=1;
   if(uvc/4==0||uvc/4==3||uvc/4==5)B_q_c[0]+=2;
   else B_q_c[0]-=1;

   if(uvc==0)flavor[3]+=1;
   if(uvc==4)flavor[0]+=1;
   if(uvc==8)flavor[1]+=1;
   if(uvc==12)flavor[4]+=1;
   if(uvc==16)flavor[2]+=1;
   if(uvc==20)flavor[5]+=1;
  }
 else if((uvc%4)>=2&&uvc<24)
  {B_q_c[1+(int)(drand48()*3.)]-=1;
   if(uvc/4==0||uvc/4==3||uvc/4==5)B_q_c[0]-=2;
   else B_q_c[0]+=1;

   if(uvc==2)flavor[3]-=1;
   if(uvc==6)flavor[0]-=1;
   if(uvc==10)flavor[1]-=1;
   if(uvc==14)flavor[4]-=1;
   if(uvc==18)flavor[2]-=1;
   if(uvc==22)flavor[5]-=1;
  }
 else if(uvc==26)
  {B_q_c[0]+=3;
   flavor[6]-=1;
  }

 for(i=0;i<4;i++)E_q_c[i]=B_q_c[i];


 if(vc==-1)
  {B_q_c[0]+=0;
   B_q_c[1+(int)(drand48()*3.)]+=1;
   B_q_c[1+(int)(drand48()*3.)]-=1;
   flavor[13]+=1;
  }
 else if((vc%4)<2&&vc<24)
  {B_q_c[1+(int)(drand48()*3.)]+=1;
   if(vc/4==0||vc/4==3||vc/4==5)B_q_c[0]+=2;
   else B_q_c[0]-=1;

   if(vc==0)flavor[3]+=1;
   if(vc==4)flavor[0]+=1;
   if(vc==8)flavor[1]+=1;
   if(vc==12)flavor[4]+=1;
   if(vc==16)flavor[2]+=1;
   if(vc==20)flavor[5]+=1;

  }
 else if((vc%4)>=2&&vc<24)
  {B_q_c[1+(int)(drand48()*3.)]-=1;
   if(vc/4==0||vc/4==3||vc/4==5)B_q_c[0]-=2;
   else B_q_c[0]+=1;

   if(vc==2)flavor[3]-=1;
   if(vc==6)flavor[0]-=1;
   if(vc==10)flavor[1]-=1;
   if(vc==14)flavor[4]-=1;
   if(vc==18)flavor[2]-=1;
   if(vc==22)flavor[2]-=1;
  }

 else if(vc==24)
  {B_q_c[0]-=3;
   flavor[6]+=1;
  }

}//end of initial_color



//assign particle type after hawking rediation
int assign_particle_type(int dim1, int dims1, int Emtype, double *power_possibility, int *E_simble, int *E_q_c, double *Elose,double **spectrum_s,double **spectrum_f,double **spectrum_ga,double **spectrum_g,int *gors,double Mb, double Rsb,int N_spectrum1, int *E_belong, double *Emass, int *flavor)
{double fpik,Mmax1,n_t;
 int pp1,fl,i,belong,Mmax_in,Mmin_in,flag;
 
 fpik=drand48()*power_possibility[Emtype];
 pp1=findintr(fpik,Emtype+1,power_possibility);
//printf("%d\n",pp1);
 //scalar
 if(pp1<4)
  {Emass[0]=mass_s[pp1];
   E_belong[0]=0;
   if(pp1==0){E_simble[0]=25;E_q_c[0]=0;}
   else if(pp1==1){E_simble[0]=24;E_q_c[0]=3;}
   else if(pp1==2){E_simble[0]=-24;E_q_c[0]=-3;}
   else {E_simble[0]=23;E_q_c[0]=0;}
   for(i=1;i<4;i++)E_q_c[i]=0;
  }
 //quark
 else if(pp1<76)
  {Emass[0]=mass_q[(pp1-4)/12];
   E_belong[0]=1;
   fl=(pp1-4)/3;
   for(i=1;i<4;i++)E_q_c[i]=0;
   E_q_c[(pp1-4)%3+1]=1;
   E_simble[0]=(pp1-4)/12+1;
   if(E_simble[0]==1||E_simble[0]==3||E_simble[0]==5)E_q_c[0]=-1;
   else E_q_c[0]=2;
   if(fl%4>=2){E_simble[0]*=-1;for(i=0;i<4;i++)E_q_c[i]*=-1;}
  }
 //charge lepton
 else if(pp1<88)
  {Emass[0]=mass_lc[(pp1-76)/4];
   E_belong[0]=1;
   fl=(pp1-76)/2+24;
   if((pp1-76)/4==0)E_simble[0]=11;
   else if((pp1-76)/4==1)E_simble[0]=13;
   else E_simble[0]=15;
   if ((pp1-76)%4 >=2)E_simble[0]*=-1;
   if(E_simble[0]>0)E_q_c[0]=-3;
   else E_q_c[0]=3;
   for(i=1;i<4;i++)E_q_c[i]=0;
  }
 //nutrino
 else if(pp1<94)
  {Emass[0]=mass_ln[(pp1-88)/2];
   E_belong[0]=1;
   fl=(pp1-88)+36;
   if((pp1-88)/2==0)E_simble[0]=12;
   else if((pp1-88)/2==1)E_simble[0]=14;
   else E_simble[0]=16;
   if ((pp1-88)%2 >=1)E_simble[0]*=-1;
   for(i=0;i<4;i++)E_q_c[i]=0;
  }
 //Gluons 8*(dims+2)
 else if(pp1<94+8*(dims1+2))
  {Emass[0]=mass_ga[0];
   E_belong[0]=2;
   E_simble[0]=21;
   E_q_c[0]=0;
   if(((pp1-94)/(dims1+2))==0){E_q_c[1]=1;E_q_c[2]=-1;E_q_c[3]=0;}
   else if(((pp1-94)/(dims1+2))==1){E_q_c[1]=1;E_q_c[2]=0;E_q_c[3]=-1;}
   else if(((pp1-94)/(dims1+2))==2){E_q_c[1]=-1;E_q_c[2]=1;E_q_c[3]=0;}
   else if(((pp1-94)/(dims1+2))==3){E_q_c[1]=0;E_q_c[2]=1;E_q_c[3]=-1;}
   else if(((pp1-94)/(dims1+2))==4){E_q_c[1]=-1;E_q_c[2]=0;E_q_c[3]=1;}
   else if(((pp1-94)/(dims1+2))==5){E_q_c[1]=0;E_q_c[2]=-1;E_q_c[3]=1;}
   else {E_q_c[1]=0;E_q_c[2]=0;E_q_c[3]=0;}
  }
 //photon w z
 else if(pp1<94+12*(dims1+2))
  {Emass[0]=mass_ga[(pp1-94)/(dims1+2)-7];
   E_belong[0]=2;
   if(((pp1-94)/(dims1+2)-7)==1){E_simble[0]=22;for(i=0;i<4;i++)E_q_c[i]=0;}
   else if(((pp1-94)/(dims1+2)-7)==2){E_simble[0]=24;;E_q_c[0]=3;for(i=1;i<4;i++)E_q_c[i]=0;}
   else if(((pp1-94)/(dims1+2)-7)==3){E_simble[0]=-24;E_q_c[0]=-3;for(i=1;i<4;i++)E_q_c[i]=0;}
   else {E_simble[0]=23;for(i=0;i<4;i++)E_q_c[i]=0;}
  }
 else {Emass[0]=mass_g[0];E_belong[0]=3;E_simble[0]=39;for(i=0;i<4;i++)E_q_c[i]=0;}

 //start estimate if black hole emits this particle
 Mmax1=(Mb*Mb+Emass[0]*Emass[0])/2./Mb*Rsb;//used to count maximum of spectrum

 Mmax1*=(1.-1.e-5);//to avoid mass of black hole =0 that might cause a little problem
 Emass[0]*=Rsb;

 if(Emass[0]<spectrum_s[0][0])Mmin_in=0;
 else Mmin_in=findintr(Emass[0],N_spectrum1,spectrum_s[0])+1;


 if(Mmax1>spectrum_s[0][N_spectrum1-1])Mmax_in=N_spectrum1-1;
 else Mmax_in=findintr(Mmax1,N_spectrum1,spectrum_s[0]);
 flag =1;
 if (Mmax_in<=Mmin_in) {flag=0;return flag;}

 if(E_belong[0]==0)
  {n_t=spectrum_s[1][Mmax_in]-spectrum_s[1][Mmin_in];
   fpik=drand48()*n_t+spectrum_s[1][Mmin_in];
   pp1=findintr(fpik,N_spectrum1,spectrum_s[1]);
   Elose[0]=spectrum_s[0][pp1]/Rsb;
  }

 else if(E_belong[0]==1)
  {n_t=spectrum_f[1][Mmax_in]-spectrum_f[1][Mmin_in];
   fpik=drand48()*n_t+spectrum_f[1][Mmin_in];
   pp1=findintr(fpik,N_spectrum1,spectrum_f[1]);
   Elose[0]=spectrum_f[0][pp1]/Rsb;
  }

 else if(E_belong[0]==2)
  {n_t=spectrum_ga[1][Mmax_in]-spectrum_ga[1][Mmin_in];
   fpik=drand48()*n_t+spectrum_ga[1][Mmin_in];
   pp1=findintr(fpik,N_spectrum1,spectrum_ga[1]);
   Elose[0]=spectrum_ga[0][pp1]/Rsb;
  }

 else 
  {n_t=spectrum_g[1][Mmax_in]-spectrum_g[1][Mmin_in];
   fpik=drand48()*n_t+spectrum_g[1][Mmin_in];
   pp1=findintr(fpik,N_spectrum1,spectrum_g[1]);
   Elose[0]=spectrum_g[0][pp1]/Rsb;
  }

 Emass[0]/=Rsb;
 if(E_belong[0]==0||E_belong[0]==2)gors[0]=4+dims1;
 else if(E_belong[0]==1)gors[0]=4;
 else gors[0]=4+dim1;

//record flavor
 if(E_simble[0]==1)flavor[0]-=1;
 if(E_simble[0]==2)flavor[3]-=1;
 if(E_simble[0]==3)flavor[1]-=1;
 if(E_simble[0]==4)flavor[4]-=1;
 if(E_simble[0]==5)flavor[2]-=1;
 if(E_simble[0]==6)flavor[5]-=1;
 if(E_simble[0]==11)flavor[6]-=1;
 if(E_simble[0]==12)flavor[9]-=1;
 if(E_simble[0]==13)flavor[7]-=1;
 if(E_simble[0]==14)flavor[10]-=1;
 if(E_simble[0]==15)flavor[8]-=1;
 if(E_simble[0]==16)flavor[11]-=1;
 if(E_simble[0]==24)flavor[12]+=1;
 if(E_simble[0]==21)flavor[13]+=1;
 if(E_simble[0]==-1)flavor[0]+=1;
 if(E_simble[0]==-2)flavor[3]+=1;
 if(E_simble[0]==-3)flavor[1]+=1;
 if(E_simble[0]==-4)flavor[4]+=1;
 if(E_simble[0]==-5)flavor[2]+=1;
 if(E_simble[0]==-6)flavor[5]+=1;
 if(E_simble[0]==-11)flavor[6]+=1;
 if(E_simble[0]==-12)flavor[9]+=1;
 if(E_simble[0]==-13)flavor[7]+=1;
 if(E_simble[0]==-14)flavor[10]+=1;
 if(E_simble[0]==-15)flavor[8]+=1;
 if(E_simble[0]==-16)flavor[11]+=1;
 if(E_simble[0]==-24)flavor[12]-=1;

 return flag;

}//end of assign particle

//assign the possibility of each particle
void assign_emitted(int dim1, int dims1, double L51,double Lg_size1, int ch_case1, double *power_possibility, int Emtype, double Epow_s1,double Epow_f,double Epow_ga,double Epow_g, double *posbh,double *posv, double **pos1, double *width1,double Rsb)
{int i,flag,m,fl,pp1;
 double E_f_factor;


 //check if black hole is outside brane
 flag=1;
 for(i=3;i<3+dims1;i++)if (fabs(posbh[i])>L51/2.)flag=0;
 for(i=3+dims1;i<3+dim1;i++)if (fabs(posbh[i])>Lg_size1/2.)flag=0;

 for(pp1=-1;pp1<Emtype;pp1++) 
  {if (flag ==0)pp1=Emtype-1;
  
   if(pp1<0)power_possibility[pp1+1]=0;
   //scalar
   else if(pp1<4)power_possibility[pp1+1]=power_possibility[pp1]+Epow_s1;
   //quark
   else if(pp1<76)
    {fl=(pp1-4)/3;
     //give emision factor of fermion
     E_f_factor=1;
     if(dims1>0)
      {E_f_factor=0.;
       for(i=0;i<100;i++)
        {for(m=0;m<dims1;m++)posv[3+m]=pos1[fl][m]+gaussrand()/2./width1[fl];
         if(dist2(&posbh[3],&posv[3],dims1)<Rsb*Rsb)E_f_factor+=1.;
        }
       E_f_factor/=100.;
      }
     power_possibility[pp1+1]=power_possibility[pp1]+Epow_f*E_f_factor;
    }
 //charge lepton
   else if(pp1<88)
    {fl=(pp1-76)/2+24;

     E_f_factor=1;
     if(dims1>0)
      {E_f_factor=0.;
       for(i=0;i<100;i++)
        {for(m=0;m<dims1;m++)posv[3+m]=pos1[fl][m]+gaussrand()/2./width1[fl];
         if(dist2(&posbh[3],&posv[3],dims1)<Rsb*Rsb)E_f_factor+=1.;
        }
       E_f_factor/=100.;
      }
     power_possibility[pp1+1]=power_possibility[pp1]+Epow_f*E_f_factor;
    }
 //nutrino
   else if(pp1<94)
    {
     fl=(pp1-88)+36;
     for(i=0;i<100;i++)
      {for(m=0;m<dims1;m++)posv[3+m]=pos1[fl][m]+gaussrand()/2./width1[fl];
       if(dist2(&posbh[3],&posv[3],dims1)<Rsb*Rsb)E_f_factor+=1.;
      }
     E_f_factor/=100.;

     power_possibility[pp1+1]=power_possibility[pp1]+Epow_f*E_f_factor;
     
    }
//Gluons 8*(dims+2)
   else if(pp1<94+8*(dims1+2))power_possibility[pp1+1]=power_possibility[pp1]+Epow_ga;
//photon w z
   else if(pp1<94+12*(dims1+2))power_possibility[pp1+1]=power_possibility[pp1]+Epow_ga;

   else 
    {if (ch_case1==3)power_possibility[pp1+1]=power_possibility[pp1];
     else power_possibility[pp1+1]=power_possibility[pp1]+Epow_g;
    }


  }//end of pp1<Emtype

}//end of assign_emitted()

//the time of one step and energy of emitted particles
void One_step_hawking(int dims1, int dim1, int *B_q_c, int Emtype, double time_step1, double *posbh , double *posv, double *Pb,double *Vc, double **pos1, double *width1, double L51,double Lg_size1,int ch_case1,double *power_possibility,double Epow_s1,double Epow_f,double Epow_ga,double Epow_g,double Rsb, double *time_bh, double Mb,int fix_time1,double width_max)
{double fpik,vmax;
 int i;

 if ((dims1==0||ch_case1==3)&&fix_time1==2)
  {assign_emitted( dim1, dims1, L51, Lg_size1, ch_case1,  power_possibility, Emtype, Epow_s1, Epow_f, Epow_ga, Epow_g, posbh, posv, pos1, width1, Rsb);
  }

 else
  {while(1)
    {
     assign_emitted( dim1, dims1, L51, Lg_size1, ch_case1,  power_possibility, Emtype, Epow_s1, Epow_f, Epow_ga, Epow_g, posbh, posv, pos1, width1, Rsb);
     if(fix_time1==2)
      {
       vmax=0;
       for(i=3;i<3+dim1;i++)vmax+=Vc[i]*Vc[i];
       vmax=sqrt(vmax);
       time_step1=0.05*width_max/vmax;
       if(time_step1>0.1*Rsb/power_possibility[Emtype]||vmax==0.)time_step1=0.2*Rsb/power_possibility[Emtype];
      }

     time_bh[0]+=Pb[0]/Mb*time_step1;
     for(i=0;i<3;i++)posbh[i]+=Pb[0]/Mb*Vc[i]*time_step1;
     for(i=3;i<3+dims1;i++)
      {posbh[i]+=Pb[0]/Mb*Vc[i]*time_step1;
       if(B_q_c[0]!=0||B_q_c[1]!=0||B_q_c[2]!=0||B_q_c[3]!=0)
	{if(posbh[i]>L51/2.){posbh[i]=L51-posbh[i];Vc[i]*=-1.;Pb[i+1]*=-1;}
         if(posbh[i]<-L51/2.){posbh[i]=-L51-posbh[i];Vc[i]*=-1.;Pb[i+1]*=-1;}
	}
      } 

     for(i=3+dims1;i<3+dim1;i++)
      {posbh[i]+=Pb[0]/Mb*Vc[i]*time_step1;
       if(B_q_c[0]!=0||B_q_c[1]!=0||B_q_c[2]!=0||B_q_c[3]!=0)
        {if(posbh[i]>Lg_size1/2.){posbh[i]=Lg_size1-posbh[i];Vc[i]*=-1.;Pb[i+1]*=-1;}
	 if(posbh[i]<-Lg_size1/2.){posbh[i]=-Lg_size1-posbh[i];Vc[i]*=-1.;Pb[i+1]*=-1;}
	}
      }

     fpik=drand48();
     if(fpik<power_possibility[Emtype]*time_step1/Rsb)break;
     

    }//end of while

  }//end of else
  
}//end of one step of Hawking
int charge_suppressed(int *E_q_c, int *B_q_c, double suppressQ1, double suppressC1)
{int flag;
 double fpik;

 flag=1;
 fpik=drand48();
 if(fpik>exp(suppressQ1*E_q_c[0]*B_q_c[0]/9.))flag=0;
 fpik=drand48();
 if(fpik>exp(suppressC1*E_q_c[1]*B_q_c[1]))flag=0;
 fpik=drand48();
 if(fpik>exp(suppressC1*E_q_c[2]*B_q_c[2]))flag=0;
 fpik=drand48();
 if(fpik>exp(suppressC1*E_q_c[3]*B_q_c[3]))flag=0;

 return flag;
}//end of charge suppressed

void setup_emitted_momentum(int ch_case1,int gors,double *Mb, double *Pb, double *Pe,double *Pe1,double *Pec, int dim1,double Elose, double Emass, double ***eigen_ro, double **eigen_location1,int N_lm1, double Rsb,double **pick_lm,double *aa_r1,double ap1,int N_a_rotation1,double ***A_ro1,double ***B_ro1,double ***C_ro1,double ***D_ro1,double ***location1, double *Vc, int E_belong,double **angl_spectrum, int N_a,double *ystart, int nvar,double *yscal,double *y1,double *dydx,double *yerr,double *ytemp,double *ak2,double *ak3,double *ak4,double *ak5,double *ak6, double *ytemp1, double **M,double **M1, double **M2, double *pick_an,double *ap,double *Lm,double *Lm1,double *Lm2,double *Lm3,double *LL, double *MM)

{double aa,ibig,fpik,x,phi,theta,mm,omega,T;
 int E_index,i,j,k,A_index,power=8,m,l,N_ne_an;


 if(ch_case1==1||ch_case1==2)
  {
   aa=1.0;
   while(aa>0.99)
    {aa=0.;
     for(i=1;i<gors;i++){Pe[i]=drand48()*2.-1.;aa+=Pe[i]*Pe[i];}
     for(i=gors;i<dim1+4;i++)Pe[i]=0.;
     aa=sqrt(aa);
    }//end of while aa
   for(i=0;i<dim1+3;i++){Pe[i+1]*=sqrt(Elose*Elose-Emass*Emass)/aa;Pec[i+1]=Pe[i+1];}
   Pec[0]=Pe[0]=Elose;

   CV(Vc,Pe,4+dim1);
   for(i=0;i<dim1+4;i++)Pb[i]-=Pe[i];
   for(i=0;i<dim1+3;i++)Vc[i]=Pb[i+1]/Pb[0];
   Mb[0]=CM(Pb,4+dim1);
  }

 else //case 3
  {//find LL MM

 
   A_index=findpd(ap1,N_a_rotation1,aa_r1);
   if(E_belong==0)ibig=0;
   else if(E_belong==1)ibig=0.5;
   else ibig=1.0;

   Elose*= Rsb;


   for(j=0;j<N_lm1;j++)
    {E_index=j+1;
     if(E_belong==0)
      {l=sqrt(E_index)-1;
       E_index-=(l+1)*(l+1);
       if(E_index==0)mm=l;
       else mm=-l+E_index-2;
      }
     if(E_belong==1)
      {l=sqrt(E_index+0.25)-0.5;
       E_index-=l*(l+1);
       if(E_index==0)mm=l-0.5;
       else mm=-l+E_index-1.5;
      }

     if(E_belong==2)
      {l=sqrt(E_index+1)-1;
       E_index-=(l+1)*(l+1)-1;
       if(E_index==0)mm=l;
       else mm=-l+E_index-2;
      }
     
     power=9;
     omega=aa_r1[A_index]/(1+aa_r1[A_index]*aa_r1[A_index]);
     T=((dim1+1)+(dim1-1)*aa_r1[A_index]*aa_r1[A_index])/4./asin(1.)/2./(1.+aa_r1[A_index]*aa_r1[A_index]);

     aa=part1_4(A_ro1[A_index][j], B_ro1[A_index][j], C_ro1[A_index][j], D_ro1[A_index][j], location1[A_index][j], Elose, power ,omega,T,mm,E_belong);
     pick_lm[0][j]=aa*(aa_r1[A_index+1]-ap1)/(aa_r1[A_index+1]-aa_r1[A_index]);

     omega=aa_r1[A_index+1]/(1+aa_r1[A_index+1]*aa_r1[A_index+1]);
     T=((dim1+1)+(dim1-1)*aa_r1[A_index+1]*aa_r1[A_index+1])/4./asin(1.)/2./(1.+aa_r1[A_index+1]*aa_r1[A_index+1]);

     aa=part1_4(A_ro1[A_index+1][j], B_ro1[A_index+1][j], C_ro1[A_index+1][j], D_ro1[A_index+1][j], location1[A_index+1][j], Elose, power ,omega,T,mm,E_belong);     
     pick_lm[0][j]+=aa*(ap1-aa_r1[A_index])/(aa_r1[A_index+1]-aa_r1[A_index]);


     power=7;
     if(Elose*ap1<eigen_location1[j][1])
      pick_lm[1][j]=part23(eigen_ro[j][0], Elose*ap1-eigen_location1[j][0], power );
     else if(Elose*ap1<eigen_location1[j][2])
      pick_lm[1][j]=part23(eigen_ro[j][1], Elose*ap1-eigen_location1[j][1], power );
     else if(Elose*ap1<eigen_location1[j][3])
      pick_lm[1][j]=part23(eigen_ro[j][2], Elose*ap1-eigen_location1[j][2], power );
     else if(Elose*ap1<eigen_location1[j][4])
      pick_lm[1][j]=part23(eigen_ro[j][3], Elose*ap1-eigen_location1[j][3], power );
     else 
      pick_lm[1][j]=part23(eigen_ro[j][4], Elose*ap1-eigen_location1[j][4], power );

     if(j!=0)pick_lm[0][j]+=pick_lm[0][j-1];

    }


   fpik=drand48()*pick_lm[0][N_lm1-1];
   E_index=findpd(fpik,N_lm1,pick_lm[0])+2;
   m=E_index-1;


   if(E_belong==0)
    {l=sqrt(E_index)-1;
     E_index-=(l+1)*(l+1);
     if(E_index==0){LL[0]=l;MM[0]=LL[0];}
     else {LL[0]=l+1;MM[0]=-LL[0]+E_index-1;}
     x=0.0;
     angle_ca(angl_spectrum,N_a,ystart, nvar, yscal, y1, dydx, yerr, ytemp, ak2, ak3, ak4, ak5, ak6, ytemp1, MM[0],x, pick_lm[1][m], ap1,Elose);

    }//end of E_belong =0     

   if(E_belong==1)
    {l=sqrt(E_index+0.25)-0.5;
     E_index-=l*(l+1);
     if(E_index==0){LL[0]=l-0.5;MM[0]=LL[0];}
     else {LL[0]=l+0.5;MM[0]=-LL[0]+E_index-1;}
     x=-0.5;
     angle_ca(angl_spectrum,N_a,ystart, nvar, yscal, y1, dydx, yerr, ytemp, ak2, ak3, ak4, ak5, ak6, ytemp1, MM[0],x,pick_lm[1][m], ap1,Elose);
    } //end of E_belong =1 
   
   if(E_belong==2)
    {l=sqrt(E_index+1)-1;
     E_index-=(l+1)*(l+1)-1;
     if(E_index==0){LL[0]=l;MM[0]=LL[0];}
     else {LL[0]=l+1;MM[0]=-LL[0]+E_index-1;}
     x=-1.0;
     angle_ca(angl_spectrum,N_a,ystart, nvar, yscal, y1, dydx, yerr, ytemp, ak2, ak3, ak4, ak5, ak6, ytemp1, MM[0],x,pick_lm[1][m], ap1,Elose);
    }     //end of E_belong =2

   Elose/=Rsb;
   fpik=drand48();
   E_index=findpd(fpik,N_a,angl_spectrum[1])+1;
   theta=acos(angl_spectrum[0][E_index]);
   phi=drand48()*2.*pi;

   Pe1[0]=sin(theta)*cos(phi);Pe1[1]=sin(theta)*sin(phi);Pe1[2]=cos(theta);

   for(i=0;i<3;i++)
    {Pe[i+1]=0.;
     for(j=0;j<3;j++){Pe[i+1]+=M[i][j]*Pe1[j];}

     Pe[i+1]*=sqrt(Elose*Elose-Emass*Emass);
     Pec[i+1]=Pe[i+1];
    }
   for(i=3;i<3+dim1;i++)Pe[i+1]=Pec[i+1]=0.;
   Pe[0]=Pec[0]=Elose;
  // save data at center of mass frame

   CV(Vc,Pe,4+dim1);
   for(i=0;i<4+dim1;i++)Pb[i]-=Pe[i];
   for(i=0;i<3+dim1;i++)Vc[i]=Pb[i+1]/Pb[0];
   Mb[0]=CM(Pb,4+dim1);

  //set new rotation angle
   N_ne_an=(int)(Lm1[0]+LL[0]-fabs(Lm1[0]-LL[0])+1.1);
   for(i=0;i<N_ne_an;i++)
    {Lm2[0]=i+fabs(Lm1[0]-LL[0]);
     pick_an[i]=CleGor(LL[0],Lm2[0],MM[0],Lm1[0]-MM[0],Lm1[0],Lm1[0]);
     pick_an[i]*=pick_an[i];
     if(i!=0)pick_an[i]+=pick_an[i-1];
    }

   fpik=drand48()*pick_an[N_ne_an-1];
   E_index=findpd(fpik,N_ne_an,pick_an);

   Lm2[0]=E_index+fabs(Lm1[0]-LL[0]);
   Lm3[0]=sqrt(Lm2[0]*(Lm2[0]+1));

   if(Lm[0]<0.1||Lm3[0]<0.1)theta=0.;
   else theta=acos((Lm1[0]*(Lm1[0]+1)+(Lm2[0]+1)*Lm2[0]-LL[0]*(LL[0]+1))/Lm[0]/Lm3[0]/2.);
   phi=drand48()*2.*pi;

   put_value(M1,theta,phi);
   for(i=0;i<3;i++)
   for(j=0;j<3;j++)
    {M2[i][j]=0.;
     for(k=0;k<3;k++)M2[i][j]+=M[i][k]*M1[k][j];

    }

   ap[0]=(dim1+2.)/2./Mb[0]*Lm3[0];

  }//end of else ch_case 3

} //end of setup_emitted_momentum 


//angular suppress factor
int angular_suppress(int suppress1,double suppressL1,double Rsb,double Rsb1, double LL, double Lm, double Lm3)
{int flag =1;
 
 //suppress factor
 if(suppress1==2)if(drand48()>exp(suppressL1*(-1.+Rsb*Rsb/Rsb1/Rsb1)))flag=0;
 if(suppress1==3)if(drand48()>exp(-suppressL1*fabs(LL)))flag=0;
 if(suppress1==4)if(drand48()>exp(-suppressL1*fabs(Lm-Lm3)))flag=0;

 return flag;
}//end of angular suppress

void   set_parameter_yoshino(double *yoshino_factor1,double *yoshino_r_max1,int dim1,int n)
{FILE *pFile;
 char filename[50];
 int i;
 
 sprintf(filename,"yoshino/yoshino_D%d.txt",dim1+4);

 pFile = fopen(filename,"r");


 fscanf(pFile,"%lf",&yoshino_r_max1[0]);
 for(i=0;i<n;i++)fscanf(pFile,"%lf",&yoshino_factor1[i]);

}//end of set_parameter_yoshino


void getbeaminfo_(int *Ipdg1,int *Ipdg2, double *Energy1, double *Energy2, int *Igrp1,int *Igrp2,int *Iset1,int *Iset2){
  *Ipdg1    = xIpdg1;  
  *Ipdg2    = xIpdg2; 
  *Iset1    = xIset1;
  *Iset2    = xIset2;
  *Igrp1    = xIgrp1;
  *Igrp2    = xIgrp2;
  *Energy1  = xEnergy1;
  *Energy2  = xEnergy2;
}

void getxsecinfo_(int *Iweight, int *Nproc, double *Xsec, double *XsecErr, double *XsecMax ,int *ProcList){
  *Iweight  =  xIweight;   
  *Nproc    =  xNproc;   
  *Xsec     =  xXsec;    
  *XsecErr  =  xXsecErr; 
  *XsecMax  =  xXsecMax; 
  *ProcList =  xProcList;         
}

void ClearEventInfo(){
  // New event, so reset all particle arrays in the Pythia HEPEUP common
  static bool Debug;
  Debug = false;

  if (Debug) printf("ClearEventInfo:: Clearing common block\n");
  hepeup_.Np    = 0;
  hepeup_.Wgt   = 0.0;
  hepeup_.Scale = 0.0;
  hepeup_.Aqed  = 0.0;
  hepeup_.Aqcd  = 0.0;
  int ii;
  for(ii=0;ii<Nmax;ii++){
    hepeup_.Ipdg[ii]  = 0;
    hepeup_.Istat[ii] = 0;
    hepeup_.Imoth[ii][0] = 0;
    hepeup_.Imoth[ii][1] = 0;
    hepeup_.Icol[ii][0]  = 0;
    hepeup_.Icol[ii][1]  = 0;
    hepeup_.Pmom[ii][0]  = 0;
    hepeup_.Pmom[ii][1]  = 0;
    hepeup_.Pmom[ii][2]  = 0;
    hepeup_.Pmom[ii][3]  = 0;
    hepeup_.Pmom[ii][4]  = 0;
    hepeup_.Tau[ii]      = 0;
    hepeup_.Spin[ii]     = 0;
  }
}

// Adds a new particle to the event record
void AddParticle(int *NewEvent, int Flag, int dim1, int Id, int *ChargeCol, double *Momentum, double Qscale){

  // NewEvent: 1 = First particle of this event
  //           0 = Not first particle of this event

  // Flag: 0 = black hole
  //       1 = incoming partons
  //       2 = Hawking radiation particle
  //       3 = final burst particle
  //       4 = Begin - initial burst particle: emission before BH forms (Yoshino & mass loss factors etc)

  // ChargeCol: [0] = EM charge*3
  //            [1]-[3] colour vector

  static bool Debug;
  Debug = false;


  // Store row of initial partons
  static int Parton1;
  static int Parton2;
  static int BlackHole;
  static int count;
  if (*NewEvent==1) {
    Parton1 = Parton2 = -10;
    BlackHole = -10;
    count++;
    if (Debug) printf("AddParticle: New Event %6i\n",count);
  }
  *NewEvent = 0;

  int ii =   hepeup_.Np;
  hepeup_.Np++;  // Post increment so that the row numbers are correct on Fortran side

  if ( Flag == 0) {    
    // BlackHole
    // set mother to be the incoming partons
    // set status = 2 --> mass of black hole is preserved in hadronisation
    hepeup_.Imoth[ii][0] = Parton1;
    hepeup_.Imoth[ii][1] = Parton2;
    hepeup_.Istat[ii]    = 2;
    BlackHole = ii+1;    // Add 1 because fortran counts from 1 (not 0)
  } else if (Flag == 1) {
    // Mother parton from proton
    if (Parton1 == -10) {
      Parton1 = ii+1;    // Add 1 because fortran counts from 1 (not 0)
      hepeup_.Imoth[ii][0] = 0;
      hepeup_.Imoth[ii][1] = 0;
      hepeup_.Istat[ii]    = -1;
      if (Debug) printf("AddParticle: Found parton1 = %3i\n",Parton1);
    } else if (Parton2 == -10) {
      Parton2 = ii+1;    // Add 1 because fortran counts from 1 (not 0)
      hepeup_.Imoth[ii][0] = 0;
      hepeup_.Imoth[ii][1] = 0;
      hepeup_.Istat[ii]    = -1;
      if (Debug) printf("AddParticle: Found parton2 = %3i\n",Parton2);
    } else{
      if (Debug) printf("AddParticle: Error - Too many mothers!\n");
    }
  } else if (Flag == 2) {
    // Hawking radiation
    // Set mother to be the black hole
    hepeup_.Imoth[ii][0] = BlackHole;
    hepeup_.Imoth[ii][1] = BlackHole;
    hepeup_.Istat[ii]    = +1;
    hepeup_.Imoth[ii][0] = 1;   //jobby: don't write the black hole to particle list
    hepeup_.Imoth[ii][1] = 2;   //jobby: don't write the black hole to particle list
  } else if (Flag == 3 || Flag == 4) {
    // Final Burst
    // Set mother to be the black hole
    hepeup_.Imoth[ii][0] = BlackHole;
    hepeup_.Imoth[ii][1] = BlackHole;
    hepeup_.Istat[ii]    = +1;
    hepeup_.Imoth[ii][0] = 1;  //jobby: don't write the black hole to particle list
    hepeup_.Imoth[ii][1] = 2;  //jobby: don't write the black hole to particle list
  }

  hepeup_.ProcessID= 1;
  hepeup_.Wgt   = 1.0;
  if (initial_particle == 3) Qscale = -1.0;  //scale not used for PDGs in e+/e- collisions!
  hepeup_.Scale = Qscale;
  hepeup_.Aqed  = -1.0;    // let Pythia/Herwig decide!
  hepeup_.Aqcd  = -1.0;    // let Pythia/Herwig decide!
  hepeup_.Ipdg[ii] = Id;


  // The colour charges need to be connected between all coloured particles of the event.
  // This will describe the colour flow used to hadronise the event by Pythia
  // Obviously the colour flow can only be configured at the end of the event, so
  // here I am simply re-coding the colour vector for ease later.
  // At the end of the event the routine ColourFlow() will arrange the colour lines
  // before calling Pythia.
  //
  // Copy the input vector...
  int ColVec[4];
  ColVec[0]=ChargeCol[0];
  ColVec[1]=ChargeCol[1];
  ColVec[2]=ChargeCol[2];
  ColVec[3]=ChargeCol[3];
  // Count up how many colour charges this particle has
  // Should be 1 for quark, and 2 for gluon (and anything for BH )
  int ColCount=0;
  if (ColVec[1] != 0) ColCount += 1;
  if (ColVec[2] != 0) ColCount += 1;
  if (ColVec[3] != 0) ColCount += 1;
  if (Debug) printf("ColCount: ii=%3i  id=%3i   count=%3i    colvec=%2i,%2i,%2i \n",ii,Id,ColCount,ColVec[1],ColVec[2],ColVec[3]);
  //if (ColCount > 1 && abs(Id)<7 && Id != 0 ) printf("AddParticle Error: quark with multiple colour charges!!! \n");
  if (ColCount == 0 && (abs(Id)<7 || Id == 21) ) {
    double random = drand48()*3.0;
    int c = 0;
    if (random < 1.0) c = 1;
    if (random >= 1.0 && random < 2.0) c = 2;
    if (random >= 2.0 && random < 3.0) c = 3;
    hepeup_.Icol[ii][0]  = c;
    hepeup_.Icol[ii][1]  = -1 * c;
    if (Debug) printf("AddParticle Error: parton with no colour charges!!! Charge set randomly to %2i\n",c);
  }
  
  // Set the Colour
  if (ColVec[1] > 0) {
    hepeup_.Icol[ii][0]  = 1*ColVec[1];
    ColVec[1] = 0;
  } else if (ColVec[2] > 0) {
    hepeup_.Icol[ii][0]  = 2*ColVec[2];
    ColVec[2] = 0;
  } else if (ColVec[3] > 0) {
    hepeup_.Icol[ii][0]  = 3*ColVec[3];
    ColVec[3] = 0;
  }  

  // Now set the anti-colour
  if (ColVec[1] < 0) {
    hepeup_.Icol[ii][1]  = 1*ColVec[1];
  } else if (ColVec[2] < 0) {
    hepeup_.Icol[ii][1]  = 2*ColVec[2];
  } else if (ColVec[3] < 0) {
    hepeup_.Icol[ii][1]  = 3*ColVec[3];
  }  
  if (Debug) printf("Id = %3i   vec= %2i %2i %2i   cols: %2i %2i\n",Id,ColVec[1],ColVec[2],ColVec[3],hepeup_.Icol[ii][0],hepeup_.Icol[ii][1]);

  // Calculate Mass and 4-momentum
  // In extra dimensions Mass is invariant
  // Recalculate 4-Energy using the 4-momentum and invariant n-dimensional mass
  double Energy,AllMomSq, Mom4dimSq;
  int i;
  Energy = Momentum[0];
  AllMomSq = 0.0;
  Mom4dimSq= 0.0;
  for (i=1;i<dim1+4;i++) {
    AllMomSq += Momentum[i]*Momentum[i] ;
    if (i<4) Mom4dimSq += Momentum[i]*Momentum[i] ;
    //if (Debug) printf("  Id=%3i  P%2i= %13.5e  AllMomSq=%13.5e  4dMom=%13.5e\n",
    //		      Id,i,Momentum[i],AllMomSq,Mom4dimSq);
  }
  double Mass2 = Energy*Energy - AllMomSq ;
  if (Mass2<0.0) Mass2=0;
  double Energy4dim = sqrt(Mass2 + Mom4dimSq);
  double Mass = sqrt(Mass2);

  //if (Debug) printf("AllMomsq=%13.5e , Mom4dimSq=%13.5e , Mass2=%13.5e E=%13.5e  Energy4dim=%13.5e\n",
  //		    AllMomSq,Mom4dimSq,Mass2,Momentum[0],Energy4dim);

  hepeup_.Pmom[ii][0]  = Momentum[1];
  hepeup_.Pmom[ii][1]  = Momentum[2];
  hepeup_.Pmom[ii][2]  = Momentum[3];
  hepeup_.Pmom[ii][3]  = Energy4dim;
  hepeup_.Pmom[ii][4]  = sqrt(Mass2);
  hepeup_.Tau[ii]      = 0;
  hepeup_.Spin[ii]     = 0;

  // Print Debug output, but not for the BlackHole particle entry (it's mass is variable!)
  if (Debug && abs(Id) != 0 ) {
    double Masses[40];
    int j;
    for (j=0;j<40;j++) Masses[j]=0.0;
    Masses[1]=3.2e-3;   // d
    Masses[2]=3.2e-3;   // u
    Masses[3]=70e-3;    // s
    Masses[4]=1.2;      // c
    Masses[5]=4.2;      // b
    Masses[6]=178.1;    // tabs(sym_last[total[0]])==12||
    Masses[11]=5.1e-4;  // e
    Masses[13]=1.05e-1; // mu
    Masses[15]=1.776;   // tau
    Masses[21]=0.0;     // gluon
    Masses[22]=0.0;     // photon
    Masses[23]=91.1876; // Z0
    Masses[24]=80.425;  // W
    int id = abs(Id);  
    
    printf("AddingParticle: %3i: %3i %3i %3i %3i %13.5e %13.5e %13.5e E=%13.5e E4d=%13.5e m=%10.5f diff=%9.4f  %2i id=%3i tru= %9.4f\n",
	 ii,Id,hepeup_.Istat[ii],Parton1,Parton2,
	 Momentum[1],Momentum[2],Momentum[3],Momentum[0],Energy4dim,Mass,fabs(sqrt(Mass2)-Masses[id]),Flag,id,Masses[id]);
  }
}

// Once all particle of event are added to common block we need to arrange the colour lines
void ColourFlow(){

  static bool Debug;
  Debug = false;

  static int event = 0;
  event++;
  //if (event==1) Debug=true;

  // in the common block, the particles are added in this order:
  int m1,m2,bh,fs;
  int BHlist = 0; //jobby: don't write the black hole to particle list
  if (BHlist==1) {
    m1  = 0; // row number of Mother 1
    m2  = 1; // row number of Mother 2
    bh  = 2; // row number of black hole
    fs  = 3; // row number of first Final State particle
  } else {
    m1  = 0; // row number of Mother 1
    m2  = 1; // row number of Mother 2
    bh  = -1; // row number of black hole
    fs  = 2; // row number of first Final State particle
  }

  int Np  = hepeup_.Np;
  int i,j,m;
  int Line = 501;

  if (Debug) {
    printf(" *** Start colour flow matching. Np = %3i \n",Np);
    // Check is colour is conserved
    int IniCol[3]={0,0,0};
    int FinCol[3]={0,0,0};
    for(i=0;i<Np;i++){
      printf("   ColourFlow: i= %3i  Id = %3i    col = %2i  %2i \n",i,hepeup_.Ipdg[i],hepeup_.Icol[i][0],hepeup_.Icol[i][1]); 
      int  c = hepeup_.Icol[i][0];
      int ac = -1*hepeup_.Icol[i][1];
      if (i<2)  IniCol[ c-1 ]+=1;
      if (i<2)  IniCol[ac-1 ]-=1;
      if (i>=2) FinCol[ c-1 ]+=1;
      if (i>=2) FinCol[ac-1 ]-=1;
    }
    printf("initial colour vector = %2i  %2i  %2i\n",IniCol[0],IniCol[1],IniCol[2]);
    printf("  final colour vector = %2i  %2i  %2i\n",FinCol[0],FinCol[1],FinCol[2]);
  }

  int Id1,Col1, ACol1, NCol1;
  int Id2,Col2, ACol2, NCol2;
  

  //------------------
  //------------------
  // Connect any colourless gluons to other colourless gluons first! (i.e. red/anti-red gluons etc)
  for (i=0;i<Np;i++){
    Id1   = hepeup_.Ipdg[i];
    Col1  = hepeup_.Icol[i][0];
    ACol1 = hepeup_.Icol[i][1];
    if (i==bh) continue;
    if (Id1 != 21) continue;  // Only look at gluons
    if ( NFreeColours(Id1,Col1,ACol1)==2 && Col1 == -1*ACol1 ){
      if (Debug) printf("Flow: Colourless gluon!:  i= %2i  Col=%2i  aCol=%2i\n",i,Col1,ACol1);
      for(j=i;j<Np;j++){
	Id2   = hepeup_.Ipdg[j];
	Col2  = hepeup_.Icol[j][0];
	ACol2 = hepeup_.Icol[j][1];
	if ( NFreeColours(Id2,Col2,ACol2)==2 && Col2 == -1*ACol2  && j!=i && j!=bh ) {
	  // decide if match is made with two inital particles / two final particles
	  // or with one initial and one final particle.
	  if ( (j<fs && i<fs )||(j>=fs && i>=fs) ) {
	    hepeup_.Icol[i][0] = Line;
	    hepeup_.Icol[j][1] = Line;
	    Col1 = ACol2 = Line;
	    if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   Col=%2i  aCol=%2i   Line=%2i \n",i,j,Col1,ACol2,Line);
	    Line++;
	    hepeup_.Icol[i][1] = Line;
	    hepeup_.Icol[j][0] = Line;
	    ACol1 = Col2 = Line;
	    if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   aCol=%2i  Col=%2i   Line=%2i \n",i,j,ACol1,Col2,Line);
	    Line++; break;
	  } else {
	    hepeup_.Icol[i][0] = Line;
	    hepeup_.Icol[j][0] = Line;
	    Col1 = Col2 = Line;
	    if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   Col=%2i   Col=%2i   Line=%2i \n",i,j,Col1,Col2,Line);
	    Line++;
	    hepeup_.Icol[i][1] = Line;
	    hepeup_.Icol[j][1] = Line;
	    ACol1 = ACol2 = Line;
	    if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   aCol=%2i   aCol=%2i   Line=%2i \n",i,j,ACol1,ACol2,Line);
	    Line++; break;
	  }
	}
      }  // End loop over particles j  
      if (Debug) printf("Flow: Colourless: done colour loop %2i \n",m);
      if (Debug) printf("Flow: Colourless:  i=%2i   col1= %2i acol1= %2i\n",i,Col1,ACol1);
      if ( NFreeColours(Id1,Col1,ACol1)==0) break;
    }
  }
  //------------------
  //------------------

  //------------------
  // Connect any remaining colourless gluons to anything else
  for (i=0;i<Np;i++){
    Id1   = hepeup_.Ipdg[i];
    Col1  = hepeup_.Icol[i][0];
    ACol1 = hepeup_.Icol[i][1];
    if (i==bh) continue;
    if (Id1 != 21) continue;  // Only look at gluons
    if ( NFreeColours(Id1,Col1,ACol1)==2 && Col1 == -1*ACol1 ){
      // Allow colourless gluon to have any colour (m=1-3) and look for best match
      for(m=1;m<4;m++){
	Col1  =    m ;
	ACol1 = -1*m ;
	if (Debug) printf("Flow: Colourless gluon!:  i= %2i  trying m=%2i   Col=%2i  aCol=%2i\n",i,m,Col1,ACol1);
	for(j=0;j<Np;j++){
	  Id2   = hepeup_.Ipdg[j];
	  Col2  = hepeup_.Icol[j][0];
	  ACol2 = hepeup_.Icol[j][1];
	  if ( NFreeColours(Id2,Col2,ACol2)==0 || j==i || j==bh ) continue;
	  // decide if match is made with two inital particles / two final particles
	  // or with one initial and one final particle.
	  if ( (j<fs && i<fs )||(j>=fs && i>=fs) ) {
	    if (Col1 == -1*ACol2 && ACol2 < 500) {
	      hepeup_.Icol[i][0] = Line;
	      hepeup_.Icol[j][1] = Line;
	      Col1 = ACol2 = Line;
	      if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   Col=%2i  aCol=%2i   Line=%2i \n",i,j,Col1,ACol2,Line);
	      Line++;//continue;	    
	    }
	    if (ACol1 == -1*Col2 && Col2 < 500) {
	      hepeup_.Icol[i][1] = Line;
	      hepeup_.Icol[j][0] = Line;
	      ACol1 = Col2 = Line;
	      if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   aCol=%2i  Col=%2i   Line=%2i \n",i,j,ACol1,Col2,Line);
	      Line++;//continue;
	    }
	  } else {
	    if (Col1 == Col2 && Col2 < 500) {
	      hepeup_.Icol[i][0] = Line;
	      hepeup_.Icol[j][0] = Line;
	      Col1 = Col2 = Line;
	      if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   Col=%2i   Col=%2i   Line=%2i \n",i,j,Col1,Col2,Line);
	      Line++;//continue;
	    }
	    if (ACol1 == ACol2 && ACol2 < 500) {
	      hepeup_.Icol[i][1] = Line;
	      hepeup_.Icol[j][1] = Line;
	      ACol1 = ACol2 = Line;
	      if (Debug) printf("Flow: Colourless match: i/j = %2i %2i   aCol=%2i   aCol=%2i   Line=%2i \n",i,j,ACol1,ACol2,Line);
	      Line++;//continue;
	    }
	  }
	}  // End loop over particles j  
	if (Debug) printf("Flow: Colourless: done colour loop %2i \n",m);
	if (Debug) printf("Flow: Colourless:  i=%2i   col1= %2i acol1= %2i\n",i,Col1,ACol1);
	if ( NFreeColours(Id1,Col1,ACol1)==0) break;
      } // End loop over colours m
    }
  }
  //------------------


  // Now look for colour singlets in the initial state
  // i.e. match colour and anti-colour in initial state
  Col1 = hepeup_.Icol[m1][0];
  ACol1= hepeup_.Icol[m1][1];
  Col2 = hepeup_.Icol[m2][0];
  ACol2= hepeup_.Icol[m2][1];
  if (Debug) printf("Look for singlets in parents Col1/ACol2 = %2i / %2i \n",Col1,ACol2);
  if (Col1 == -1*ACol2 && Col1 !=0 && ACol2 !=0 && Col1 < 500 && ACol2 < 500 ) {
    if (Debug) printf("Flow: Match found i/j = %2i / %2i   Line=%4i \n",m1,m2,Line);
    hepeup_.Icol[m1][0] = Line;
    hepeup_.Icol[m2][1] = Line;
    Line++;
  }
  if (Debug) printf("Look for singlets in parents ACol1/Col2 = %2i / %2i \n",ACol1,Col2);
  if (ACol1 == -1*Col2 && Col2 !=0 && ACol1!=0 && Col2 < 500 && ACol1 < 500 ) {
    if (Debug) printf("Flow: Match found i/j = %2i / %2i   Line=%4i \n",m2,m1,Line);
    hepeup_.Icol[m1][1] = Line;
    hepeup_.Icol[m2][0] = Line;
    Line++;
  }
  
  
  // Now look for colour singlets in the final state
  // i.e. match colour and anti-colour in final state
  // Loop over final state only
  if (Debug) printf("Look for singlets in Final State \n");
  for(i=fs;i<Np-1;i++){
    Id1  = hepeup_.Ipdg[i];
    Col1 = hepeup_.Icol[i][0];
    ACol1= hepeup_.Icol[i][1];
    NCol1 = NFreeColours(Id1,Col1,ACol1);
    if ( NCol1 == 0 ) continue;
    // Loop over final state particles and look for first colour match
    for (j=i+1;j<Np;j++){
      Id2   = hepeup_.Ipdg[j];
      Col2  = hepeup_.Icol[j][0];
      ACol2 = hepeup_.Icol[j][1];
      NCol2 = NFreeColours(Id2,Col2,ACol2);
      if ( NCol2 == 0 ) continue;
      if (Col1 == -1*ACol2 && Col1 !=0 && ACol2 !=0 && Col1 < 500 && ACol2 < 500 ) {
	if (Debug) printf("Flow: match found Col  i=%2i  j=%2i ,Line=%2i\n",i,j,Line);
	hepeup_.Icol[i][0] = Line;
	hepeup_.Icol[j][1] = Line;
	Col1 = ACol2 = Line;
	Line++;
      }
      if (Col2 == -1*ACol1 && Col2 !=0 && ACol1 !=0 && Col2 < 500 && ACol1 < 500 ) {
	if (Debug) printf("Flow: match found ACol i=%2i  j=%2i ,Line=%2i\n",i,j,Line);
	hepeup_.Icol[i][1] = Line;
	hepeup_.Icol[j][0] = Line;
	Col2 = ACol1 = Line;
	Line++;
      }	
    }
    if (Debug) printf("Done the loop over HFS1\n");
  }
  if (Debug) printf("Done the loop over HFS2\n");



  // Loop over parents looking for colour flow matches
  for(i=m1;i<m2+1;i++){
    if (Debug) printf("Starting parent loop  i=%2i\n",i);
    Id1   = hepeup_.Ipdg[i];
    Col1  = hepeup_.Icol[i][0];
    ACol1 = hepeup_.Icol[i][1];
    NCol1 = NFreeColours(Id1,Col1,ACol1);
    if (NCol1 == 0) continue;
    if (Debug) printf("    i=%3i  Id=%4i   col=%3i  acol=%3i   ncol=%2i \n",i,Id1,Col1,ACol1,NCol1);
    
    // Loop over final state particles and look for first colour match
    for (j=fs;j<Np;j++){
      Id2   = hepeup_.Ipdg[j];
      Col2  = hepeup_.Icol[j][0];
      ACol2 = hepeup_.Icol[j][1];
      NCol2 = NFreeColours(Id2,Col2,ACol2);;
      if (NCol2 == 0) continue;
      if (Debug) printf("    j=%3i  Id=%4i   col=%3i  acol=%3i   ncol=%2i \n",j,Id2,Col2,ACol2,NCol2);

      if (Col1 == Col2  && Col1 !=0 && Col2 !=0 && Col1 < 500 && Col2 < 500 ) {
	if (Debug) printf("Flow: match found Col  i=%2i  j=%2i ,Line=%2i\n",i,j,Line);
	hepeup_.Icol[i][0] = Line;
	hepeup_.Icol[j][0] = Line;
	if (bh>0) hepeup_.Icol[bh][0] = Line;
	Col1 = Col2 = Line;
	Line++;
      }	
      if (ACol1 == ACol2 && ACol1 !=0 && ACol2 !=0 && ACol1 < 500 && ACol2 < 500 ) {
	if (Debug) printf("Flow: match found ACol i=%2i  j=%2i ,Line=%2i\n",i,j,Line);
	hepeup_.Icol[i][1] = Line;
	hepeup_.Icol[j][1] = Line;
	if (bh>0) hepeup_.Icol[bh][1] = Line;
	ACol1 = ACol2 = Line;
	Line++;
      }
    }
    if (Debug) printf("Done the loop over final state particles\n");
  }
  if (Debug) printf("Done the loop over parents\n");

  // Final mop up of any remaining lines from initial OR final state (excluding black hole itself)
  for(i=0;i<Np;i++){
    if (i==bh) continue;
    Id1   = hepeup_.Ipdg[i];
    Col1  = hepeup_.Icol[i][0];
    ACol1 = hepeup_.Icol[i][1];
    if ( Col1 == -1*ACol1 && Col1 !=0 && Col1 < 500 && ACol1 !=0 && ACol1 < 500){
      //if (Debug) printf("Flow: mopping up  Col + ACol  i=%2i  Line=%2i\n",i,Line);
      //hepeup_.Icol[i][0] = Line;
      //hepeup_.Icol[i][1] = Line;
      //if ( (i==m1 || i==m2) && bh>0 && hepeup_.Icol[bh][0] < 500) hepeup_.Icol[bh][0]=Line; 
      //Line++;
      //continue;
    }
    if ( Col1 !=0 && Col1 < 500){
      if (Debug) printf("Flow: mopping up  Col i=%2i  Line=%2i\n",i,Line);
      hepeup_.Icol[i][0] = Line;
      if ( (i==m1 || i==m2) && bh>0 && hepeup_.Icol[bh][0] < 500) hepeup_.Icol[bh][0]=Line; 
      Line++;
    }
    if ( ACol1 !=0 && ACol1 < 500){
      if (Debug) printf("Flow: mopping up ACol i=%2i  Line=%2i\n",i,Line);
      hepeup_.Icol[i][1] = Line;
      if ( (i==m1 || i==m2) && bh>0 && hepeup_.Icol[bh][1] < 500) hepeup_.Icol[bh][1]=Line; 
      Line++;
    }
  }

 end:      
  //final printout of all particle colour vectors
  if (Debug) {
    int  colIni =0;
    int acolIni =0;
    int  colFin =0;
    int acolFin =0;
    printf(" Now check all partons have a colour line assigned\n");    
    for(i=0;i<Np;i++){
      Id1   = hepeup_.Ipdg[i];
      Col1  = hepeup_.Icol[i][0];
      ACol1 = hepeup_.Icol[i][1];
      if (i<2)  {
	if (Id1 >  0 && Id1 < 7) colIni += 1;
	if (Id1 > -7 && Id1 < 0) colIni -= 1;
      } else {
	if (Id1 >  0 && Id1 < 7) colFin += 1;
	if (Id1 > -7 && Id1 < 0) colFin -= 1;
      }
      printf("END:    i=%3i  Id=%4i   col=%3i  acol=%3i\n",i,Id1,Col1,ACol1);
    }
    // Look for colour violation!
    if (colIni != colFin || acolIni != acolFin){
      printf("  Colour violation! \n");
      exit;
    }
  }
}

int NFreeColours(int Id, int Col,int ACol){

  //Count the number of "free" colours that need to be matched on colour flow lines

  // Return zero for non-partons
  if (abs(Id) > 7 && Id != 21) return 0;

  int NCol=0;
  if ( Col != 0 &&  Col < 500 ) NCol++;
  if (ACol != 0 && ACol < 500 ) NCol++;


  //printf(" NFreeColours: Id=%3i   Col=%2i  ACol = %3i  N=%3i\n",Id,Col,ACol,NCol);

  return NCol;
}
void DumpLHAevent(FILE* LHAfile){
  // This is an alternative LHA interface
  // writes LHA header common block to a text file
  // instead of allowing Pythia to directly use the common blocks
  // This method does not require pythia to be linked to BlackMax
  // you would run BlackMax first and produce the text file output
  // Then run Pythia standalone, taking the text file as input.

  // int Np;
  // int ProcessID;
  // double Wgt;
  // double Scale; 
  // double Aqed;
  // double Aqcd;
  // int    Ipdg[Nmax];
  // int   Istat[Nmax];
  // int   Imoth[Nmax][2];
  // int    Icol[Nmax][2];
  // double Pmom[Nmax][5];
  // double  Tau[Nmax];
  // double Spin[Nmax];
  
  static int Nevent=0;
  Nevent++;
  //fprintf(LHAfile,"  Event = %6i\n",Nevent);

  // Print the event header info (eg. no. particle, event weight etc...)
  fprintf(LHAfile,"%6i  %6i  %15.7e  %15.7e  %15.7e   %15.7e\n",
	  hepeup_.Np , hepeup_.ProcessID , hepeup_.Wgt , hepeup_.Scale , hepeup_.Aqed , hepeup_.Aqcd);
  
  // Print the particle info
  int Nparticles = hepeup_.Np; 
  int i;
  for ( i=0 ; i < Nparticles; i++){
    fprintf(LHAfile,"%6i %6i %6i %6i %6i %6i %15.7e %15.7e %15.7e %15.7e %15.7e %15.7e %15.7e\n",
	    hepeup_.Ipdg[i],hepeup_.Istat[i],hepeup_.Imoth[i][0],hepeup_.Imoth[i][1],hepeup_.Icol[i][0],hepeup_.Icol[i][1],
	    hepeup_.Pmom[i][0],hepeup_.Pmom[i][1],hepeup_.Pmom[i][2],hepeup_.Pmom[i][3],hepeup_.Pmom[i][4],
	    hepeup_.Tau[i],hepeup_.Spin[i]);
  }

}

void Banner(){
  printf("\n\n");
  printf("***************************************************************** \n");
  printf("***************************************************************** \n");
  printf("***                                                           *** \n");
  printf("***   Welcome to:       BLACKMAX                              *** \n");
  printf("***                                                           *** \n");
  printf("***   A TeV-Scale-Gravity Final-State Generator               *** \n");
  printf("***                                                           *** \n");
  printf("***   De-Chang Dai, Glenn Starkman, Dejan Stojkovic,          *** \n");
  printf("***   Cigdem Issever, Eram Rizvi, Jeff Tseng                  *** \n");
  printf("***                                                           *** \n");
  printf("***   For latest information and downloads please see         *** \n");
  printf("***      http://projects.hepforge.org/blackmax                *** \n");
  printf("***                                                           *** \n");
  printf("***   Please contact the authors at:                          *** \n");
  printf("***        blackmax@projects.hepforge.org                     *** \n");
  printf("***                                                           *** \n");
  printf("***   A manual is available at hepforge and also at:          *** \n");
  printf("***       arXiv:0902.3577 [hep-ph]                            *** \n");
  printf("***                                                           *** \n");
  printf("***   For a discussion of the theoretical treatment see:      *** \n");
  printf("***       arXiv:0711.3012 [hep-ph]                            *** \n");
  printf("***                                                           *** \n");
  printf("***   Release:                                                *** \n");
  printf("***    $Name: REL_2_00_2 $                                                  \n");
  printf("***    $Id: BlackMax.c,v 1.65 2009/02/23 08:25:23 rizvi Exp $     \n");
  printf("***    $Date: 2009/02/23 08:25:23 $                           *** \n");
  printf("***                                                           *** \n");
  printf("***************************************************************** \n");
  printf("***************************************************************** \n");
  printf("\n\n");   
}


//exchange particle d,s,b,u,c,t,e,mu,tau,vu_e,vu_mu,vu_tau,W,g,no-charge,graviton
//use to reduce the number of constraints
int  exchange_rout(int **constraint, int number_constraint, int *for_switch1,int *num_c1,int *num_switch1,int **group_poss1, double **pro_group_poss1,double **group_poss_mass1, int dims1, int dim1, int **exchange1, int *number_ex1,int on_gravity1)
{int i,j,k,l,m,aa,bb,num,j1,j2,k1,k2;

 for(i=0;i<number_constraint;i++)
  {aa=0;bb=0;
   for(j=0;j<6;j++)if (constraint[i][j]!=0)aa=1;
   for(j=6;j<12;j++)if(constraint[i][j]!=0)bb=1;
   if(aa==1&&bb==1)
    {aa=0;for(j=0;j<6;j++)aa+=constraint[i][j];
     bb=0;for(j=6;j<12;j++)bb+=constraint[i][j];
     if(3*aa+bb!=0)return 0;
    }

   
  }
 //grouping different particle 
 for(i=0;i<3;i++) 
 for(j=0;j<14;j++){exchange1[i][j]=0;for_switch1[j]=j;}

 exchange1[0][0]=1;exchange1[0][1]=-1;    //d type ?
 exchange1[1][0]=1;exchange1[1][2]=-1;
 exchange1[2][1]=1;exchange1[2][2]=-1;

 for(l=0;l<3;l++)
  {
   aa=1;
   for(i=0;i<number_constraint;i++)
    {bb=0;
     for(k=0;k<12;k++)bb+=exchange1[l][k]*constraint[i][k];
     if (bb!=0)aa=0;
    }
   if(aa==1){if(l==0)for_switch1[1]=0;else if(l==1)for_switch1[2]=0;else for_switch1[2]=for_switch1[1];}
   
  }

 for(i=0;i<3;i++) 
 for(j=0;j<14;j++)exchange1[i][j]=0;

 exchange1[0][3]=1;exchange1[0][4]=-1;    //u type ?
 exchange1[1][3]=1;exchange1[1][5]=-1;
 exchange1[2][4]=1;exchange1[2][5]=-1;


 for(l=0;l<3;l++)
  {
   aa=1;
   for(i=0;i<number_constraint;i++)
    {bb=0;
     for(k=0;k<12;k++)bb+=exchange1[l][k]*constraint[i][k];
     if (bb!=0)aa=0;
    }
   if(aa==1){if(l==0)for_switch1[4]=for_switch1[3];else if(l==1)for_switch1[5]=for_switch1[3]; else for_switch1[5]=for_switch1[4];}
  }

 for(i=0;i<3;i++) 
 for(j=0;j<14;j++)exchange1[i][j]=0;

 exchange1[0][6]=1;exchange1[0][7]=-1;    //e type ?
 exchange1[1][6]=1;exchange1[1][8]=-1;
 exchange1[2][7]=1;exchange1[2][8]=-1;


 for(l=0;l<3;l++)
  {
   aa=1;
   for(i=0;i<number_constraint;i++)
    {bb=0;
     for(k=0;k<12;k++)bb+=exchange1[l][k]*constraint[i][k];
     if (bb!=0)aa=0;
    }
   if(aa==1){if(l==0)for_switch1[7]=for_switch1[6]; else if(l==1)for_switch1[8]=for_switch[6]; else for_switch1[8]=for_switch1[7];}
  }

 for(i=0;i<3;i++) 
 for(j=0;j<14;j++)exchange1[i][j]=0;

 exchange1[0][6]=1;exchange1[0][12]=-1;   //-1 type
 exchange1[1][7]=1;exchange1[1][12]=-1;
 exchange1[2][8]=1;exchange1[2][12]=-1;

 for(l=0;l<3;l++)
  {
   aa=1;
   for(i=0;i<number_constraint;i++)
    {bb=0;
     for(k=0;k<12;k++)bb+=exchange1[l][k]*constraint[i][k];
     if (bb!=0)aa=0;
    }
   if(aa==1){if(l==0)for_switch1[12]=for_switch1[6];else if(l==1)for_switch1[12]=for_switch1[7];else for_switch1[12]=for_switch1[8];}
  }


 for(i=0;i<3;i++) 
 for(j=0;j<14;j++)exchange1[i][j]=0;

 exchange1[0][9]=1;exchange1[0][10]=-1;   //nu type
 exchange1[1][9]=1;exchange1[1][11]=-1;
 exchange1[2][10]=1;exchange1[2][11]=-1;

 for(l=0;l<3;l++)
  {
   aa=1;
   for(i=0;i<number_constraint;i++)
    {bb=0;
     for(k=0;k<12;k++)bb+=exchange1[l][k]*constraint[i][k];
     if (bb!=0)aa=0;
    }
   if(aa==1){if(l==0)for_switch1[10]=for_switch1[9];else if(l==1)for_switch1[11]=for_switch1[9]; else for_switch1[11]=for_switch1[10];}
  }


 for(i=1;i<13;i++)
  {aa=0;
   for(j=1;j<13;j++)
    {
     if(for_switch1[j]==i)aa=1;
    }
   if(aa==0){for(j=0;j<13;j++)if(for_switch1[j]>i){for_switch1[j]-=1;aa=1;}if(aa==1)i-=1;}
  }



 num=0; for(i=0;i<6;i++)if(for_switch1[i]>num)num=for_switch1[i];
 num_c1[0]=num+1;
 for(i=6;i<13;i++)if(for_switch1[i]>num)num=for_switch1[i];
 num+=1;
 for_switch1[13]=num;
 num_switch1[0]=num+1;


//group them together
 for(i=0;i<14;i++)
 for(j=0;j<4;j++)group_poss1[i][j]=0;

 for(i=0;i<num_switch1[0];i++)
  {num=0;
   for(j=0;j<14;j++)if(for_switch1[j]==i)
    {num+=1;
     group_poss1[i][0]=num;
     if(j>=0&&j<3){pro_group_poss1[i][num]=2;group_poss1[i][num]=2*j+1;}//down quark
     if(j>=3&&j<6){pro_group_poss1[i][num]=2;group_poss1[i][num]=2*(j-3)+2;}//up quark
     if(j>=6&&j<9){pro_group_poss1[i][num]=2;group_poss1[i][num]=11+(j-6)*2;}//charge lepton
     if(j>=9&&j<12){pro_group_poss1[i][num]=1;group_poss1[i][num]=12+(j-9)*2;}//neutrino
     if(j==12){pro_group_poss1[i][num]=dims1+3;group_poss1[i][num]=-24;}//W-
     if(j==13){pro_group_poss1[i][num]=(dims1+2);group_poss1[i][num]=21;}//g

     if(j==0)group_poss_mass1[i][num]=mass_q[1];
     else if(j==1)group_poss_mass1[i][num]=mass_q[2];
     else if(j==2)group_poss_mass1[i][num]=mass_q[4];
     else if(j==3)group_poss_mass1[i][num]=mass_q[0];
     else if(j==4)group_poss_mass1[i][num]=mass_q[3];
     else if(j==5)group_poss_mass1[i][num]=mass_q[5];
     else if(j==6)group_poss_mass1[i][num]=mass_lc[0];
     else if(j==7)group_poss_mass1[i][num]=mass_lc[1];
     else if(j==8)group_poss_mass1[i][num]=mass_lc[2];
     else if(j==9)group_poss_mass1[i][num]=mass_ln[0];
     else if(j==10)group_poss_mass1[i][num]=mass_ln[1];
     else if(j==11)group_poss_mass1[i][num]=mass_ln[2];
     else if(j==12)group_poss_mass1[i][num]=mass_ga[2];
     else if(j==13)group_poss_mass1[i][num]=mass_ga[0];
    }
  }

 group_poss1[num_switch1[0]][0]=4;
 pro_group_poss1[num_switch1[0]][1]=2+dims1;group_poss1[num_switch1[0]][1]=22;group_poss_mass1[num_switch1[0]][1]=mass_ga[1];//photon
 pro_group_poss1[num_switch1[0]][2]=3+dims1;group_poss1[num_switch1[0]][2]=23;group_poss_mass1[num_switch1[0]][2]=mass_ga[4];//Z
 pro_group_poss1[num_switch1[0]][3]=1;group_poss1[num_switch1[0]][3]=25;group_poss_mass1[num_switch1[0]][3]=mass_s[0];//H
 pro_group_poss1[num_switch1[0]][4]=(2+dims1);group_poss1[num_switch1[0]][4]=21;group_poss_mass1[num_switch1[0]][4]=mass_ga[0];//g

 group_poss1[num_switch1[0]+1][0]=1;
 pro_group_poss1[num_switch1[0]+1][1]=(dim1+1)*(dim1+4)/2.*on_gravity1;group_poss1[num_switch1[0]+1][1]=39;group_poss_mass1[num_switch1[0]+1][1]=mass_g[0];//graviton

 for(i=0;i<num_switch1[0]+2;i++)
  {pro_group_poss1[i][0]=0;
   for(j=1;j<group_poss1[i][0]+1;j++){pro_group_poss1[i][0]+=pro_group_poss1[i][j];/*printf("%d ",group_poss1[i][j]);*/}
//   printf("jj\n");
  }



 //start to setup equations to check
 //#######################################
 
 for(i=0;i<156;i++)
 for(j=0;j<14;j++)
  exchange1[i][j]=0;

     //setup d+ubar=W-
 number_ex1[0]=0;
 for(i=0;i<3;i++)
 for(j=3;j<6;j++)
  {
   exchange1[number_ex1[0]][i]=1;exchange1[number_ex1[0]][j]=-1;exchange1[number_ex1[0]][12]=-1;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++)aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];
     if(aa!=0)break;
    }
   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;
   exchange1[number_ex1[0]][for_switch1[i]]+=1;exchange1[number_ex1[0]][for_switch1[j]]+=-1;exchange1[number_ex1[0]][for_switch1[12]]+=-1;

   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }
   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
  }



 //setup e+nu=W-

 for(i=6;i<9;i++)
 for(j=9;j<12;j++)
  {
   exchange1[number_ex1[0]][i]=1;exchange1[number_ex1[0]][j]=-1;exchange1[number_ex1[0]][12]=-1;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++){aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];}     if(aa!=0)break;

    }
   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;

   exchange1[number_ex1[0]][for_switch1[i]]+=1;exchange1[number_ex1[0]][for_switch1[j]]+=-1;exchange1[number_ex1[0]][for_switch1[12]]+=-1;

   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }

   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;

  }


 //setup ddu=nu

 for(m=0;m<3;m++)
 for(i=3;i<6;i++)
 for(j=9;j<12;j++)
  {
   exchange1[number_ex1[0]][m]=2;exchange1[number_ex1[0]][i]=1;exchange1[number_ex1[0]][j]=1;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++){aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];}     if(aa!=0)break;

    }
   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;

   exchange1[number_ex1[0]][for_switch1[m]]+=2;exchange1[number_ex1[0]][for_switch1[i]]+=1;exchange1[number_ex1[0]][for_switch1[j]]+=1;

   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }

   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;

  }


 //setup duu=e+
/* for(m=0;m<3;m++)
 for(i=3;i<6;i++)
 for(j=6;j<9;j++)
  {
   exchange1[number_ex1[0]][m]=1;exchange1[number_ex1[0]][i]=2;exchange1[number_ex1[0]][j]=1;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++){aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];}     if(aa!=0)break;

    }
   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;

   exchange1[number_ex1[0]][for_switch1[m]]+=1;exchange1[number_ex1[0]][for_switch1[i]]+=2;exchange1[number_ex1[0]][for_switch1[j]]+=1;

   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }

   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;

  }
*/

 //setup ddd=W-

/*

 for(i=0;i<3;i++)
  {
   exchange1[number_ex1[0]][i]=3;exchange1[number_ex1[0]][12]=-1;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++)aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];
     if(aa!=0)break;
    }

   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;
   exchange1[number_ex1[0]][for_switch1[i]]+=3;exchange1[number_ex1[0]][for_switch1[12]]+=-1;


   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }

   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
  }
 
*/
 //setup uuu=2W+

 for(i=3;i<6;i++)
  {
   exchange1[number_ex1[0]][i]=3;exchange1[number_ex1[0]][12]=2;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++)aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];
     if(aa!=0)break;
    }
   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;

   exchange1[number_ex1[0]][for_switch1[i]]+=3;exchange1[number_ex1[0]][for_switch1[12]]+=2;

   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }

   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
  }

 //setup nu=0
 for(i=9;i<12;i++)
  {
   exchange1[number_ex1[0]][i]=1;
   aa=0;
   for(k1=0;k1<number_constraint;k1++)
    {aa=0;
     for(k2=0;k2<14;k2++)aa+=exchange1[number_ex1[0]][k2]*constraint[k1][k2];
     if(aa!=0)break;
    }
   for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
   if(aa!=0)continue;
   exchange1[number_ex1[0]][for_switch1[i]]-=1;

   aa=1;
   for(k=0;k<number_ex1[0];k++)
    {bb=1;
     for(l=0;l<num_switch1[0];l++)if(exchange1[number_ex1[0]][l]!=exchange1[k][l]){bb=0;break;}
     if(bb!=0){aa=0;break;}
    }

   if(aa==1)number_ex1[0]++;
   else  for(k=0;k<14;k++)  exchange1[number_ex1[0]][k]=0;
  } 
 
 for(i=number_ex1[0]-1;i>0;i--)
 for(j=i-1;j>0;j--)
  {aa=1;
   for(k=0;k<num_switch1[0];k++)if(exchange1[i][k]!=exchange1[j][k]){aa=0;break;}
   if(aa==1)
    {number_ex1[0]-=1;
     for(k=i;k<number_ex1[0];k++)for(k1=0;k1<num_switch1[0];k1++)exchange1[k][k1]=exchange1[k+1][k1];
     break;
    }
  }

return 1;
}//end of exchange_rout


//finding minimum solution
//find out the all possible solution
//finding minimum solution
int minimum_solution(int *flavor,int *B_q_c,int **N_type,int *for_switch1,int num_c1,int num_switch1,int **group_poss1, double **pro_group_poss1, int **exchange1, int number_ex1, int  *num_total, int *no_charge)

{int total,total1,larg,total2,total3,ii,j,l,k,cp,cn,pp1,pp2,pp3,B_q_c1[4];
 long i,large_number;
 double chose_last[100];

 no_charge[0] =0 ;
 //calculate particle number of initial solution
 for(i=0;i<num_switch1+2;i++) N_type[0][i]=0;
 for(i=0;i<14;i++)N_type[0][for_switch1[i]]+=flavor[i];


 total=0;
 larg=0;
 for(j=0;j<num_switch1-1;j++){total+=abs(N_type[0][j]);if(abs(N_type[0][j])>larg)larg=abs(N_type[0][j]);}
 if(larg<3)larg=3;
 total1=0;

 
 for (j=0;j<4;j++)B_q_c1[j]=B_q_c[j];
 for(k=0;k<num_c1;k++) 
  {cp=0;
   while(N_type[0][k]-cp!=0)
    {pp1=1;pp2=2;pp3=3;
     if(B_q_c1[pp1]<B_q_c1[pp2]){j=pp1;pp1=pp2;pp2=j;}
     if(B_q_c1[pp2]<B_q_c1[pp3]){j=pp2;pp2=pp3;pp3=j;} 
     if(B_q_c1[pp1]<B_q_c1[pp2]){j=pp2;pp2=pp1;pp1=j;}
     if(N_type[0][k]>0){B_q_c1[pp1]--;cp++;}
     if(N_type[0][k]<0){B_q_c1[pp3]++;cp--;}
    }
  }

 total1=(B_q_c1[1]+B_q_c1[2]+B_q_c1[3])/3;
 total1=(abs(B_q_c1[1]-total1)+abs(B_q_c1[2]-total1)+abs(B_q_c1[3]-total1))/2;

 total+=total1;
 N_type[0][num_switch1-1]=total1;
// if(total<2){N_type[0][num_switch1]=2-total;total=2;}
// else N_type[0][num_switch1]=N_type[0][num_switch1+1]=0;


 total1=0;
 if(total==1)
  {N_type[total1][num_switch1]=1;N_type[total1][num_switch1+1]=0;
   total1+=1;
   for(j=0;j<num_switch1;j++)N_type[total1][j]=N_type[total1-1][j];
   N_type[total1][num_switch1]=0;N_type[total1][num_switch1+1]=1;
   total=2;
  }
 else if(total==0)
  {N_type[total1][num_switch1]=2;N_type[total1][num_switch1+1]=0;
   total1+=1;
   for(j=0;j<num_switch1;j++)N_type[total1][j]=N_type[total1-1][j];
   N_type[total1][num_switch1]=1;N_type[total1][num_switch1+1]=1;
   total1+=1;
   for(j=0;j<num_switch1;j++)N_type[total1][j]=N_type[total1-1][j];
   N_type[total1][num_switch1]=0;N_type[total1][num_switch1+1]=2;
   total=2;
   no_charge[0]=1;
  }
 else N_type[total1][num_switch1]=N_type[total1][num_switch1+1]=0;

 total1++;
// for(j=0;j<num_switch+2;j++)printf("%d ",N_type[0][j]);
// printf("\n");

 //start to eliminate the number 
// total1=1;

 large_number=pow(larg*2,number_ex1);
 for(i=0;i<large_number;i++)
  {ii=i;

   for(l=0;l<num_switch1;l++)N_type[total1][l]=N_type[0][l];
   for(j=0;j<number_ex1;j++){for(l=0;l<num_switch1;l++)N_type[total1][l]+=(ii%(larg*2)-larg)*exchange1[j][l];ii/=(larg*2);}
   
   ii=0;
   for(l=0;l<num_switch1;l++)if(N_type[total1][l]!=N_type[0][l]){ii=1;break;}
   if(ii==0)continue;
   

   total2=0;
   for(j=0;j<num_switch1-1;j++)total2+=abs(N_type[total1][j]);
   total3=0; for(j=0;j<num_c1;j++)total3+=N_type[total1][j];
 
   for (j=0;j<4;j++)B_q_c1[j]=B_q_c[j];
   for(k=0;k<num_c1;k++) 
    {cp=0;
     while(N_type[total1][k]-cp!=0)
      {pp1=1;pp2=2;pp3=3;
       if(B_q_c1[pp1]<B_q_c1[pp2]){j=pp1;pp1=pp2;pp2=j;}
       if(B_q_c1[pp2]<B_q_c1[pp3]){j=pp2;pp2=pp3;pp3=j;} 
       if(B_q_c1[pp1]<B_q_c1[pp2]){j=pp2;pp2=pp1;pp1=j;}
       if(N_type[total1][k]>0){B_q_c1[pp1]--;cp++;}
       if(N_type[total1][k]<0){B_q_c1[pp3]++;cp--;}
      }
    }

   total3=(B_q_c1[1]+B_q_c1[2]+B_q_c1[3])/3;
   total3=(abs(B_q_c1[1]-total3)+abs(B_q_c1[2]-total3)+abs(B_q_c1[3]-total3))/2;


   total2+=total3;


   N_type[total1][num_switch1-1]=total3;
   if(total2==1)
    {N_type[total1][num_switch1]=1;N_type[total1][num_switch1+1]=0;
     total1+=1;
     for(j=0;j<num_switch1;j++)N_type[total1][j]=N_type[total1-1][j];
     N_type[total1][num_switch1]=0;N_type[total1][num_switch1+1]=1;
     total2=2;
    }
   else if(total2==0)
    {N_type[total1][num_switch1]=2;N_type[total1][num_switch1+1]=0;
     total1+=1;
     for(j=0;j<num_switch1;j++)N_type[total1][j]=N_type[total1-1][j];
     N_type[total1][num_switch1]=1;N_type[total1][num_switch1+1]=1;
     total1+=1;
     for(j=0;j<num_switch1;j++)N_type[total1][j]=N_type[total1-1][j];
     N_type[total1][num_switch1]=0;N_type[total1][num_switch1+1]=2;
     total2=2;
     no_charge[0]=1;
    }
   else N_type[total1][num_switch1]=N_type[total1][num_switch1+1]=0;

   if(total2==total)
    {
     for(j=total1-1;j>0;j--)
      {cp=1;
       for(k=0;k<num_switch1+1;k++)if(N_type[total1][k]!=N_type[j][k]){cp=0;break;}
       if(cp==1)total1+=1;
      }


    }
   if(total2<total)
    {for(j=0;j<num_switch1+2;j++)N_type[0][j]=N_type[total1][j];
     total=total2;
     total1=1;
     large_number=pow(total*2,number_ex1);
     i=0;
    }  
  }   

 
 for(i=total1-1;i>=0;i--)
 for(j=i-1;j>0;j--)
  {cp=1;
   for(k=0;k<num_switch1+1;k++)if(N_type[i][k]!=N_type[j][k]){cp=0;break;}
   if(cp==1)
    {total1-=1;
     for(k=i;k<total1;k++)for(l=0;l<num_switch1;l++)N_type[k][l]=N_type[k+1][l];
     break;     
    }
  }

 num_total[0]=total;


 return total1;
}//end of minimum_solution

//index exchange for quark position
double index_position(int in_q, double **pos1,double *bhpos, double *width1, int dims1)
{double aa,bb;
 int i;
 if(in_q==1)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[4][i];aa+=bb*bb*width1[4]*width1[4];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[5][i];aa+=bb*bb*width1[5]*width1[5];}
   }

 else if(in_q==-1)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[6][i];aa+=bb*bb*width1[6]*width1[6];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[7][i];aa+=bb*bb*width1[7]*width1[7];}
   }

 else if(in_q==2)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[0][i];aa+=bb*bb*width1[0]*width1[0];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[1][i];aa+=bb*bb*width1[1]*width1[1];}
   }

 else if(in_q==-2)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[2][i];aa+=bb*bb*width1[2]*width1[2];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[3][i];aa+=bb*bb*width1[3]*width1[3];}
   }

 else if(in_q==3)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[8][i];aa+=bb*bb*width1[8]*width1[8];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[9][i];aa+=bb*bb*width1[9]*width1[9];}
   }

 else if(in_q==-3)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[10][i];aa+=bb*bb*width1[10]*width1[10];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[11][i];aa+=bb*bb*width1[11]*width1[11];}
   }

 else if(in_q==4)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[12][i];aa+=bb*bb*width1[12]*width1[12];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[13][i];aa+=bb*bb*width1[13]*width1[13];}
   }

 else if(in_q==-4)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[14][i];aa+=bb*bb*width1[14]*width1[14];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[15][i];aa+=bb*bb*width1[15]*width1[15];}
   }

 else if(in_q==5)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[16][i];aa+=bb*bb*width1[16]*width1[16];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[17][i];aa+=bb*bb*width1[17]*width1[17];}
   }

 else if(in_q==-5)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[18][i];aa+=bb*bb*width1[18]*width1[18];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[19][i];aa+=bb*bb*width1[19]*width1[19];}
   }

 else if(in_q==6)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[20][i];aa+=bb*bb*width1[20]*width1[20];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[21][i];aa+=bb*bb*width1[21]*width1[21];}
   }

 else if(in_q==-6)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[22][i];aa+=bb*bb*width1[22]*width1[22];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[23][i];aa+=bb*bb*width1[23]*width1[23];}
   }

 else if(in_q==11)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[24][i];aa+=bb*bb*width1[24]*width1[24];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[25][i];aa+=bb*bb*width1[25]*width1[25];}
   }

 else if(in_q==-11)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[26][i];aa+=bb*bb*width1[26]*width1[26];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[27][i];aa+=bb*bb*width1[27]*width1[27];}
   }
 else if(in_q==13)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[28][i];aa+=bb*bb*width1[28]*width1[28];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[29][i];aa+=bb*bb*width1[29]*width1[29];}
   }

 else if(in_q==-13)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[30][i];aa+=bb*bb*width1[30]*width1[30];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[31][i];aa+=bb*bb*width1[31]*width1[31];}
   }

 else if(in_q==15)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[32][i];aa+=bb*bb*width1[32]*width1[32];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[33][i];aa+=bb*bb*width1[33]*width1[33];}
   }

 else if(in_q==-15)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[34][i];aa+=bb*bb*width1[36]*width1[36];}
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[35][i];aa+=bb*bb*width1[35]*width1[35];}
   }

 else if(in_q==12)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[36][i];aa+=bb*bb*width1[36]*width1[36];}
   }

 else if(in_q==-12)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[37][i];aa+=bb*bb*width1[37]*width1[37];}
   }

 else if(in_q==14)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[38][i];aa+=bb*bb*width1[38]*width1[38];}
   }

 else if(in_q==-14)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[39][i];aa+=bb*bb*width1[39]*width1[39];}
   }

 else if(in_q==16)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[40][i];aa+=bb*bb*width1[40]*width1[40];}
   }

 else if(in_q==-16)
   {aa=0;
    for(i=0;i<dims1;i++){bb=bhpos[3+i]-pos1[41][i];aa+=bb*bb*width1[41]*width1[41];}
   }

 else aa=0.;

// aa=exp(-2*aa/100.)/2;

 return aa;

}//end of index_position

//move an element from point
int move_one(int *point, int numb, int st)
{int max1,max2,i,min; 
 max1=-1;
 for(i=0;i<numb;i++) if(point[i]!=0){max1=i;break;}

 if(max1==-1)return -1;
 if(max1==0)
  {max2=-1; 
   for(i=1;i<numb;i++)  {if(point[i]!=0){max2=i;break;}}
   if(max2==-1){point[numb-1]=point[0];point[0]=0;return 0;}
   else if(max2!=max1+1)
    {point[max2-1]+=st+point[0];point[max2]-=st;point[0]=0;return 1;}
   else {point[max2-1]+=st;point[max2]-=st;return 1;}
  } 
 else  {point[max1-1]+=st;point[max1]-=st; return 1;}
 
}

//peak up one solution for minimum number of particle
double pick_one_solution(int num_total,int dims1, int total, int num_switch1,double **pos1,double *posbh, double *width1, int **N_type,int **group_poss1,double **pro_group_poss1, double **group_poss_mass1, int **final_bur, double *N_type_mass, double Mb, int no_charge, int *B_q_c)
{double x[2],aa,aa1,x1[2],ch_mass_possible;
 int i,ii,iii,j,jj,k,l,kk,sw_nu[num_switch1+2],search_final[4][num_total],ind1;
 int color_pross_q[6][4],color_pross_g[9],color_g[8][3],wei_color,color_compare[3],mark,mark2; 
 
 
 color_g[0][0]=0;color_g[0][1]=0;color_g[0][2]=0;
 color_g[1][0]=0;color_g[1][1]=0;color_g[1][2]=0;
 color_g[2][0]=-1;color_g[2][1]=1;color_g[2][2]=0;
 color_g[3][0]=-1;color_g[3][1]=0;color_g[3][2]=1;
 color_g[4][0]=0;color_g[4][1]=-1;color_g[4][2]=1;
 color_g[5][0]=0;color_g[5][1]=1;color_g[5][2]=-1;
 color_g[6][0]=1;color_g[6][1]=-1;color_g[6][2]=0;
 color_g[7][0]=1;color_g[7][1]=0;color_g[7][2]=-1;


 x1[0]=0.;
 ind1=-1;
 for(l=0;l<total;l++)
  {
   j=0;
   for(i=0;i<num_switch1+2;i++)
    {for(kk=0;kk<abs(N_type[l][i]);kk++)
      {search_final[1][j]=i;
       search_final[0][j]=1;
       search_final[2][j]=group_poss1[i][0];
       search_final[3][j]=N_type[l][i]/abs(N_type[l][i]);
       j++;
      }
    }
   search_final[0][0]=0;

   while(1)
    {ind1++;
     search_final[0][0]++;
     for(i=0;i<num_total-1;i++)
      if(search_final[0][i]>search_final[2][i]){search_final[0][i+1]++;search_final[0][i]=1;}
     if(search_final[0][num_total-1]==search_final[2][num_total-1]+1)break;
     
     mark=7;
     wei_color=1.;
     for(i=0;i<6;i++)color_pross_q[i][0]=0;color_pross_g[0]=0;
     for(i=0;i<num_total;i++)
       {final_bur[1][i]=search_final[3][i]*group_poss1[search_final[1][i]][search_final[0][i]];
        if(abs(final_bur[1][i])==1){color_pross_q[0][0]+=search_final[3][i];wei_color=-1.;if(mark>0)mark =0;}
        else if(abs(final_bur[1][i])==2){color_pross_q[1][0]+=search_final[3][i];wei_color=-1.;if(mark>1)mark =1;}
        else if(abs(final_bur[1][i])==3){color_pross_q[2][0]+=search_final[3][i];wei_color=-1.;if(mark>2)mark =2;}
        else if(abs(final_bur[1][i])==4){color_pross_q[3][0]+=search_final[3][i];wei_color=-1.;if(mark>3)mark =3;}
        else if(abs(final_bur[1][i])==5){color_pross_q[4][0]+=search_final[3][i];wei_color=-1.;if(mark>4)mark =4;}
        else if(abs(final_bur[1][i])==6){color_pross_q[5][0]+=search_final[3][i];wei_color=-1.;if(mark>5)mark =5;}
        else if(abs(final_bur[1][i])==21){color_pross_g[0]+=search_final[3][i];wei_color=-1.;if(mark>6)mark =6;}
       }

     if(sum_mass(num_total,final_bur[1])>Mb)continue;

     x1[1]=0.;
     x[1]=1.;
     for(i=0;i<num_total;i++)
       {if(dims1!=0)x1[1]+=index_position(final_bur[1][i],pos1,posbh,width1,dims1);
        x[1]*=pro_group_poss1[search_final[1][i]][search_final[0][i]];
       }
      
     if(wei_color<0.)
      {
      
       wei_color=0.;
       for(i=0;i<6;i++){color_pross_q[i][1]=color_pross_q[i][2]=0;color_pross_q[i][3]=color_pross_q[i][0];}
       for(i=1;i<8;i++)color_pross_g[i]=0;color_pross_g[8]=color_pross_g[0];
       while (1)
        {for(jj=0;jj<3;jj++)color_compare[jj]=B_q_c[jj+1];
         for(i=0;i<6;i++)for(jj=0;jj<3;jj++)color_compare[jj]-=color_pross_q[i][jj+1];
         for(i=0;i<8;i++)for(jj=0;jj<3;jj++)color_compare[jj]-=color_pross_g[i+1]*color_g[i][jj];
         if(color_compare[0]==color_compare[1] &&color_compare[1]==color_compare[2] )wei_color++;
         if(move_one(&color_pross_g[1], 8, 1)!=1)
          {if(mark==6)break;
           else 
            {mark2=5;
             while (mark2>-1)
              {if(color_pross_q[mark2][0]<0)i=move_one(&color_pross_q[mark2][1], 3, -1);
               else i=move_one(&color_pross_q[mark2][1], 3, 1);
               if (i==1)break; 
               else mark2-=1;
              }
            }
           if(mark2<mark)break;
          }
         

        }
 
       x[1]*=wei_color;
      }



     if(ind1==0){for(j=0;j<num_total;j++)final_bur[0][j]=final_bur[1][j];x1[0]=x1[1];x[0]=x[1];}
     else if(x1[1]<x1[0]){for(j=0;j<num_total;j++)final_bur[0][j]=final_bur[1][j];x1[0]=x1[1];x[0]=x[1];}
     else if(x1[1]==x1[1]){x[0]+=x[1];if(drand48()<x[1]/x[0])for(j=0;j<num_total;j++)final_bur[0][j]=final_bur[1][j];}

    }
  }

 if(no_charge==1)
  {
   for(l=0;l<num_switch1-1;l++)
    {
     search_final[1][0]=l;
     search_final[0][0]=0;
     search_final[2][0]=group_poss1[l][0];
     search_final[3][0]=1;
     search_final[1][1]=l;
     search_final[0][1]=1;
     search_final[2][1]=group_poss1[l][0];
     search_final[3][1]=-1; 

     
     while(1)
      {
       search_final[0][0]++;
       for(i=0;i<num_total-1;i++)
        if(search_final[0][i]>search_final[2][i]){search_final[0][i+1]++;search_final[0][i]=1;}
       if(search_final[0][num_total-1]==search_final[2][num_total-1]+1)break;

       for(i=0;i<num_total;i++){final_bur[1][i]=search_final[3][i]*group_poss1[search_final[1][i]][search_final[0][i]];}
       if(sum_mass(num_total,final_bur[1])>Mb)continue;
       x1[1]=0.;
       x[1]=1.;
       for(i=0;i<num_total;i++)
         {if(dims1!=0)x1[1]+=index_position(final_bur[1][i],pos1,posbh,width1,dims1);
          x[1]*=pro_group_poss1[search_final[1][i]][search_final[0][i]];
         }
       if(final_bur[1][0]==1||final_bur[1][0]==2||final_bur[1][0]==3||final_bur[1][0]==4||final_bur[1][0]==5||final_bur[1][0]==6)
         x[1]*=3;
       if(final_bur[1][0]==21&&final_bur[1][1]==21)x[1]*=10;
       if(final_bur[1][0]==21&&final_bur[1][1]!=21)x[1]*=2;
       if(final_bur[1][0]!=21&&final_bur[1][1]==21)x[1]*=2;
 
       if(x1[1]<x1[0]){for(j=0;j<num_total;j++)final_bur[0][j]=final_bur[1][j];x1[0]=x1[1];x[0]=x[1];}
       else if(x1[1]==x1[0]){x[0]+=x[1];if(drand48()<x[1]/x[0])for(j=0;j<num_total;j++)final_bur[0][j]=final_bur[1][j];}

      }
    }
  }

 return 0.;
}//end of pick_one_solution

//set up minimum mass for each type of particles
void N_type_minimum_mass(double *N_type_mass1,int **group_poss1,int num_switch1)
{int i,j;
 double MM2,MM1;
 for(i=0;i<num_switch1+2;i++)
  {
   for(j=1;j<group_poss1[i][0]+1;j++)
    {
     if(abs(group_poss1[i][j])==1)MM2=mass_q[1];
     else if(abs(group_poss1[i][j])==2)MM2=mass_q[0];
     else if(abs(group_poss1[i][j])==3)MM2=mass_q[2];
     else if(abs(group_poss1[i][j])==4)MM2=mass_q[3];
     else if(abs(group_poss1[i][j])==5)MM2=mass_q[4];
     else if(abs(group_poss1[i][j])==6)MM2=mass_q[5];
     else if(abs(group_poss1[i][j])==11)MM2=mass_lc[0];
     else if(abs(group_poss1[i][j])==12)MM2=mass_ln[0];
     else if(abs(group_poss1[i][j])==13)MM2=mass_lc[1];
     else if(abs(group_poss1[i][j])==14)MM2=mass_ln[1];
     else if(abs(group_poss1[i][j])==15)MM2=mass_lc[2];
     else if(abs(group_poss1[i][j])==16)MM2=mass_ln[2];
     else if(abs(group_poss1[i][j])==21)MM2=mass_ga[0];
     else if(abs(group_poss1[i][j])==22)MM2=mass_ga[1];
     else if(group_poss1[i][j]==24)MM2=mass_ga[2];
     else if(group_poss1[i][j]==-24)MM2=mass_ga[3];
     else if(group_poss1[i][j]==23)MM2=mass_ga[4];
     else if(group_poss1[i][j]==25)MM2=mass_s[0];
     else MM2=mass_g[0];
     if(j==1)MM1=MM2;
     else {if (MM2<MM1)MM1=MM2;}

    }
   N_type_mass1[i]=MM1;
  }
}//end of N_type_minimum_mass;

void replace_flavor(int E_simble, int *flavor)
{
 if(E_simble==1)flavor[0]-=-1;
 if(E_simble==2)flavor[3]-=-1;
 if(E_simble==3)flavor[1]-=-1;
 if(E_simble==4)flavor[4]-=-1;
 if(E_simble==5)flavor[2]-=-1;
 if(E_simble==6)flavor[5]-=-1;
 if(E_simble==11)flavor[6]-=-1;
 if(E_simble==12)flavor[9]-=-1;
 if(E_simble==13)flavor[7]-=-1;
 if(E_simble==14)flavor[10]-=-1;
 if(E_simble==15)flavor[8]-=-1;
 if(E_simble==16)flavor[11]-=-1;
 if(E_simble==24)flavor[12]+=-1;
 if(E_simble==21)flavor[13]+=-1;
 if(E_simble==-1)flavor[0]+=-1;
 if(E_simble==-2)flavor[3]+=-1;
 if(E_simble==-3)flavor[1]+=-1;
 if(E_simble==-4)flavor[4]+=-1;
 if(E_simble==-5)flavor[2]+=-1;
 if(E_simble==-6)flavor[5]+=-1;
 if(E_simble==-11)flavor[6]+=-1;
 if(E_simble==-12)flavor[9]+=-1;
 if(E_simble==-13)flavor[7]+=-1;
 if(E_simble==-14)flavor[10]+=-1;
 if(E_simble==-15)flavor[8]+=-1;
 if(E_simble==-16)flavor[11]+=-1;
 if(E_simble==-24)flavor[12]-=-1;

}//end pf replace_flavor

